$CCODE
/* bxbasm : Asmif.c : alpha version */
/* ----- function prototypes ----- */
//#include "prototyp.h"



void Do_if()					/* parse an IF statement */
{   int pi, mark_or;

    pi = e_pos;
    strcat(indent, "  ");
    write_str(indent);
    writeln(";--------------------<if>");
		/**/
    endifCtr++;
    strcpy(label_endif[endifCtr], get_NewLabel());
    check_lsif();					/* is there an: elseif */
    check_else();					/* is there an: else */
    mark_or = check_or();			/* is there an: or */
		/**/
    boolexpress();
		/**/
    write_str(indent);
    writeln(";--------------------<block>");
    or_true(mark_or);				/* post block label */
    opcntr = 0;
}
/*------- end Do_if -------*/


void Do_elseif()					/* parse an ELSEIF statement */
{   char label[LLEN];
    int mark_or;

    strcpy(label, label_endif[endifCtr]);
    write_str(indent);
    writeln(";--------------------<end-block>");
    write_str(indent);
    write_str("jmp  ");
    writeln(label);
    write_str(indent);
    writeln(";--------------------<elseif>");
		/**/
    strcpy(label, label_elseif[endifCtr]);
    PostLabel(label);
    check_lsif();					/* is there an: elseif */
    check_else();					/* is there an: else */
    mark_or = check_or();			/* is there an: or */
		/**/
    boolexpress();
		/**/
    write_str(indent);
    writeln(";--------------------<block>");
    or_true(mark_or);				/* post block label */
    opcntr = 0;
}
/*------- end Do_elseif -------*/


void Do_else()					/* parse an ELSE statement */
{   char label[LLEN];
    int len;

    write_str(indent);
    writeln(";--------------------<end-block>");
		/**/
    strcpy(label, label_endif[endifCtr]);
    write_str(indent);
    write_str("jmp  ");
    writeln(label);				/* jump to end */
		/**/
    strcpy(label, label_else[endifCtr]);
    write_str(indent);
    writeln(";--------------------<else>");
    PostLabel(label);
		/**/
    write_str(indent);
    writeln(";--------------------<block>");
		/**/
    label_else[endifCtr][0] = '\0';
}
/*------- end Do_else -------*/


void Do_endif()					/* parse an ENDIF statement */
{   char label[LLEN];
    int len;

    write_str(indent);
    writeln(";--------------------<end-block>");
		/**/
    if(label_elseif[endifCtr][0] != 0)
    {   strcpy(label, label_elseif[endifCtr]);
        PostLabel(label);
    }
		/**/
    strcpy(label, label_endif[endifCtr]);
    write_str(indent);
    writeln(";--------------------<endif>");
    PostLabel(label);
		/**/
    len = strlen(indent);
    len = len - 2;
    indent[len] = '\0';
    indcnt--;
    label_endif[endifCtr][0] = '\0';
    endifCtr--;
}
/*------- end Do_endif -------*/


void boolexpress()
{   int type, op, ab_code=14, x=line_ndx;

    type = get_Exptype();			/* string, numeric, or eof */
    if((type >= 1) && (type <= 5))
    {   type = 1;
    }
	/**/
    switch(type)
    {   case 0:
            op = Sboolterm(type);       	/* a string evaluation */
            break;
        case 1:
        case 11:
            op = Nboolterm(type);        	/* numeric evaluation */
            break;
        case 12:
            op = is_eof();			/* an EOF evaluation */
            break;
        default:
            a_bort(ab_code,x);
            break;
    }
    op = IsAndOrOp(op);  			/* --- process AND / OR --- */
		/**/
    if(op != 0)
    {   opcntr++;
        boolexpress();				/* do: AND/OR */
    }
}
/*------- end boolexpress --------*/


int Nboolterm(int type)
{   char varname[VAR_NAME];
    int op;

    switch(type)
    {   case 1:					/* variable value */
            strcpy(varname, get_varname());
            write_str(indent);
            write_str("mov  eax, ");
            writeln(varname);
            break;
        case 11:					/* expression within parens */
            write_str(indent);
            writeln("FINIT \t\t\t; initialize x87");
            a_Expression();
			/**/
            write_str(indent);
            write_str("FISTP iLVAR");
            writeln("\t\t; store in system left variable");
            write_str(indent);
            writeln("mov  eax, iLVAR");
            break;
    }
    op = Nrelation();
    return op;
}
/*------- end Nboolterm --------*/


int Nrelation()
{   char varname[VAR_NAME];
    int op, type, ab_code=10, x=line_ndx;

    op = get_op();				/* get eval op type */
    type = get_Exptype();			/* get right side type */
    if((type >= 1) && (type <= 5))
    {   type = 1;
    }
	/**/
    switch(type)
    {   case 1:					/* variable value */
            strcpy(varname, get_varname());
            write_str(indent);
            write_str("cmp  eax, ");
            writeln(varname);
            break;
        case 11:					/* expression within parens */
            write_str(indent);
            writeln("FINIT \t\t\t; initialize x87");
            a_Expression();
			/**/
            write_str(indent);
            write_str("FISTP ");
            write_str("iRVAR");
            writeln("\t\t; store in system right variable");
            write_str(indent);
            writeln("cmp  eax, iRVAR");
            break;
        default:
            a_bort(ab_code,x);
            break;
    }
    return op;
}
/*------- end Nrelation --------*/


int Sboolterm(int type)
{   char varname[VAR_NAME], temp[6];
    int pi, op, mark;

    pi = e_pos;
    strcpy(varname, get_varname());		/* string variable */
		/**/
    strcpy(temp, "VARX");
    s_pos = pi;
    mark = find_strng(temp);
    mark--;
		/**/
    if(mark == pi)				/* this is a temp var-name */
    {   write_str(indent);
        write_str("mov  esi, offset ");
        write_str(varname);
        writeln("\t\t; load temp variable address");
    }
    else
    {   write_str(indent);
        write_str("mov  esi, [");
        write_str(varname);
        write_str("]");
        writeln("\t\t\t; address of source string");
    }
		/**/
    op = Srelation();
    return op;
}
/*------- end Sboolterm --------*/


int Srelation()
{   char varname[VAR_NAME], temp[6];
    int pi, op, type, mark, ab_code=13, x=line_ndx;

    op = get_op();				/* get eval op type */
    type = get_Exptype();			/* get right side type */
		/**/
    switch(type)
    {   case 0:					/* string variable */
            pi = e_pos;
            strcpy(varname, get_varname());
			/**/
            strcpy(temp, "VARX");
            s_pos = pi;
            mark = find_strng(temp);
            mark--;
			/**/
            if(mark == pi)			/* this is a temp var-name */
            {   write_str(indent);
                write_str("mov  edi, offset ");
                write_str(varname);
                writeln("\t\t; load temp variable address");
            }
            else
            {   write_str(indent);
                write_str("mov  edi, [");
                write_str(varname);
                write_str("]");
                writeln("\t\t\t; address of source string");
            }
			/**/
            write_str(indent);
            write_str("invoke StrLen, addr ");
            write_str(varname);
            writeln("\t\t; get string length");
            write_str(indent);
            writeln(".if eax == 0");
            write_str(indent);
            writeln("  inc  eax");
            write_str(indent);
            writeln(".endif");
            write_str(indent);
            writeln("mov  ecx, eax\t\t\t\t; Load length of string");
			/**/
            write_str(indent);
            writeln("cld\t\t\t; clear direction flag: work upward");
            write_str(indent);
            writeln("repe cmpsb\t\t; Compare and repeat");
            break;
        default:
            a_bort(ab_code,x);
            break;
    }
    return op;
}
/*------- end Srelation --------*/


int get_op()
{   char ch;
    int pi, op, ab_code=11, x=line_ndx;

    pi = e_pos;
    ch = p_string[pi];
    if(strchr("\"$%!#@&", ch))
    {   pi++;				/* increment past current symbol */
    }
    pi = iswhite(pi);
    ch = p_string[pi];
    switch(ch)
    {   case '=':
            op = 1;				/* is_equal */
            break;
        case '<':
            pi++;
            ch = p_string[pi];
            if(ch == '>')
            {   op = 6;				/* not_equal */
            }
            else if(ch == '=')
            {   op = 4;				/* less-than or equal to */
            }
            else
            {   op = 2;				/* less-than */
            }
            break;
        case '>':
            pi++;
            ch = p_string[pi];
            if(ch == '=')
            {   op = 5;         		/* greater-than or equal to */
            }
            else
            {   op = 3;         		/* greater-than */
            }
            break;
        default:
            a_bort(ab_code,x);
            break;
    }
    if(strchr("=>", ch))
    {   pi++;
    }
    e_pos = pi;
    return op;
}
/*------- end get_op -------*/


int get_Exptype()		/* return: variable, string, or expression */
{   char ch, varname[VAR_NAME];
    int pi, type=0;

    pi = e_pos;
    pi = iswhiter(pi);
    ch = p_string[pi];
    if(isalpha(ch))          				/* variable name */
    {   e_pos = pi;
        strcpy(varname, get_varname());
        if(strcmp("EOF", varname) == 0)
        {   type = 12;
        }
        else
        {   type = get_ObjectType(varname);  /* object type specifier */
        }
  /* printf("getxptyp::varname=%s type=%d\n", varname, type); */

    }
    else if(ch == '(')
    {   type = 11;                      /* expression in parens */
    }
    else if(ch == '<')
    {   type = 12;                      /* 'NOT' boolean expression */
    }
    e_pos = pi;
    return type;
}
/*------- end get_Exptype ---------*/


char *jump_if(int op, char ch)
{   static char jump[10];

    if(ch == '|')					/* ch == | */
    {   switch(op)
        {   case 1:				/* equal to */
                strcpy(jump, "je   ");
                break;
            case 2:				/* less than */
                strcpy(jump, "jl   ");
                break;
            case 3:				/* greater than */
                strcpy(jump, "jg   ");
                break;
            case 4:				/* less than or equal */
                strcpy(jump, "jle  ");
                break;
            case 5:				/* greater than or equal */
                strcpy(jump, "jge  ");
                break;
            case 6:				/* not */
                strcpy(jump, "jnz  ");
                break;
        }
    }
    else						/* ch == & (or no op) */
    {   switch(op)
        {   case 1:				/* equal to */
                strcpy(jump, "jne  ");
                break;
            case 2:				/* less than */
                strcpy(jump, "jnl  ");
                break;
            case 3:				/* greater than */
                strcpy(jump, "jng  ");
                break;
            case 4:				/* less than or equal */
                strcpy(jump, "jnle ");
                break;
            case 5:				/* greater than or equal */
                strcpy(jump, "jnge ");
                break;
            case 6:				/* not */
                strcpy(jump, "jz   ");
                break;
        }
    }
    return jump;
}
/*------- end jump_if -------*/


int look_Or()					/* look for the next OR op */
{   char ch;
    int pi, len, _bool=0;

    pi = e_pos;
    ch = p_string[pi];
    len = strlen(p_string);
    while((ch != '|') && (pi < len))	/* find next OR */
    {   pi++;
        ch = p_string[pi];
    }
    if(pi < len)
    {   if((ch == '|') && (pi > Or_pi))	/* found a new OR */
        {   strcpy(label_Or, get_NewLabel());
            Or_pi = pi;
            _bool = 1;
        }
        else if(ch == '|')			/* use old OR */
        {   _bool = 1;
        }
    }
    return _bool;
}
/*------- end look_Or -------*/


int IsAndOrOp(int op)
{   char ch, jump[10], this_label[LLEN];
    int pi, _bool, len;

    pi = e_pos;
    pi = iswhiter(pi);
    ch = p_string[pi];
    e_pos = pi;
    if(label_elseif[endifCtr][0] != '\0')
    {   strcpy(this_label, label_elseif[endifCtr]);
    }
    else if(label_else[endifCtr][0] != '\0')
    {   strcpy(this_label, label_else[endifCtr]);
    }
    else
    {   strcpy(this_label, label_endif[endifCtr]);
    }
	/**/
    switch(ch)
    {   case '&':						/* AND */
            _bool = look_Or();			/* is there an OR to jump to */
            if(_bool == 1)
            {   strcpy(this_label, label_Or);
            }
            strcpy(jump, jump_if(op, ch));
            op = 1;
            pi++;
            pi = iswhiter(pi);
            write_str(indent);
            write_str(jump);
            writeln(this_label);
            break;
        case '|':						/* OR */
            strcpy(this_label, label_block[endifCtr]);
            strcpy(jump, jump_if(op, ch));
            op = 2;
            pi++;
            pi = iswhiter(pi);
            write_str(indent);
            write_str(jump);
            writeln(this_label);
			/**/
            if(label_Or[0] != '\0')
            {   PostLabel(label_Or);
                label_Or[0] = '\0';
            }
            break;
        case '^':						/* NOT */
            strcpy(jump, jump_if(op, ch));
            op = 3;
            pi++;
            pi = iswhiter(pi);
            write_str(indent);
            write_str(jump);
            writeln(this_label);
            break;
        default:
            strcpy(jump, jump_if(op, ch));
            op = 0;
            write_str(indent);
            write_str(jump);
            writeln(this_label);
            break;
    }
    e_pos = pi;
    return op;
}
/*------- end IsAndOrOp --------*/


void check_lsif()				/* look ahead for an: elseif */
{   int line, tok=0, lsif=0, newif=0;

    line = line_ndx;
    while((tok != 16) && (tok != 14) && (line < nrows))
    {   line++;
        tok = byte_array[line];
        if(tok == 13)					/* found an: if */
        {   newif++;
        }
        else if(tok == 14)				/* found an: elseif */
        {   if(newif == 0)
            {   lsif++;
            }
            else
            {   tok = 0;				/* it's an embedded if */
            }
        }
        else if(tok == 16)				/* found an: endif */
        {   if(newif > 0)				/* is it an embedded if */
            {   newif--;
                tok = 0;
            }
        }
    }
    if(lsif > 0)
    {   strcpy(label_elseif[endifCtr], get_NewLabel());
    }
    else
    {   label_elseif[endifCtr][0] = '\0';
    }
}
/*------- end check_lsif -------*/


void check_else()				/* look ahead for an: elseif */
{   int line, tok=0, lse=0, newif=0;

    line = line_ndx;
    while((tok != 16) && (tok != 15) && (line < nrows))
    {   line++;
        tok = byte_array[line];
        if(tok == 13)					/* found an: if */
        {   newif++;
        }
        else if(tok == 15)				/* found an: else */
        {   if(newif == 0)
            {   lse++;
            }
            else
            {   tok = 0;				/* it's an embedded if */
            }
        }
        else if(tok == 16)				/* found an: endif */
        {   if(newif > 0)				/* is it an embedded if */
            {   newif--;
                tok = 0;
            }
        }
    }
    if(lse > 0)
    {   strcpy(label_else[endifCtr], get_NewLabel());
    }
    else
    {   label_else[endifCtr][0] = '\0';
    }
}
/*------- end check_else -------*/


void or_true(int mark_or)		/* does this statement contain an OR */
{   char block[LLEN];

    if(mark_or > 0)
    {   strcpy(block, label_block[endifCtr]);
        PostLabel(block);
    }
}
/*------- end or_true -------*/


int check_or()					/* look ahead for an: OR */
{   char temp[3];
    int mark_or;

    strcpy(temp, "| ");
    mark_or = find_strng(temp);
    mark_or--;
    if(mark_or > 0)
    {   strcpy(label_block[endifCtr], get_NewLabel());
        Or_pi = 0;			/* keep track of recurring OR position */
    }
    else
    {   label_block[endifCtr][0] = '\0';
    }
    return mark_or;
}
/*------- end check_or -------*/


int is_eof()
{   char fptr[4], varname[VAR_NAME];			/* num = EOF(f) */
    int pi, len, ival, op;
    double value;

    len = strlen(p_string);
    pi = e_pos;
    pi = get_digit(pi, len);
    e_pos = pi;
    value = get_avalue();
    ival = (int) value;
    ival--;
    sprintf(fptr, "%d", ival);
		/**/
    write_str(indent);
    write_str("mov  eax, ");
    writeln(fptr);
    write_str(indent);
    writeln("call getfilehandle");
    write_str(indent);
    writeln("invoke feof, eax");		/* integer value is in eax */
    write_str(indent);
    writeln("cmp  eax, 0");
		/**/
    getfilehandle = 1;
    pi = e_pos;
    pi++;
    e_pos = pi;
    op = 6;				/* IF EOF == true == [<> 0] */
    return op;
}
/*------- end is_eof ----------*/


$CCODE