$CCODE
/* bxbasm : Asminput.c : alpha version */
/* ----- function prototypes ----- */
//#include "prototyp.h"


void Header()
{
    open_destin();
	/**/
    writeln(";\t*************BxbAsm Compiler*************");
    writeln(";\tCopyright: sarbayo (c) 2004");
    writeln("; =========================================================================");
    writeln("  .386                       ; use 386 instructions");
    writeln("  .model flat, stdcall       ; Win32 memory model");
    writeln("  option casemap:none        ; case sensitive");
    writeln("; =========================================================================");
    writeln("; BXB Function Prototypes:");
    writeln("; =========================================================================");
    writeln("  dblArryElement   proto");
    writeln("  quadArryElement  proto");
    writeln("  freeArray  proto");
    writeln("    ;proto");
    writeln("; =========================================================================");
    writeln("  include \\Masm32\\Bxbasm\\BXB.inc");
    writeln("; -------------------------------------------------------------------------");
    writeln("; =========================================================================");
    writeln(";  INITIALIZED DATA");
    writeln("; =========================================================================");
    writeln(" .data");
	/**/
    Prolog();
    Build_arrays();
}
/*---------- end Header ----------*/


void Prolog()				/* Write the Prolog */
{
    ScanVars();				/* pre-scan for quoted strings */
	/**/
    writeln("; =========================================================================");
    writeln(";  UNINITIALIZED DATA");
    writeln("; =========================================================================");
    writeln(" .data?");
    writeln("\tsystem_time SYSTEMTIME  <>\t\t\t;current date & time");
    writeln("\tsa  SECURITY_ATTRIBUTES  <>");
    writeln("\tcsbi  CONSOLE_SCREEN_BUFFER_INFO  <>");
    writeln("\tiCOL\t\tdd\t?");
    writeln("\tiROW\t\tdd\t?");
    writeln("\tiYear\t\tdd\t?");
    writeln("\tiMonth\tdd\t?");
    writeln("\tiDay\t\tdd\t?");
    writeln("\tiHour\t\tdd\t?");
    writeln("\tiMinute\tdd\t?");
    writeln("\tiSecond\tdd\t?");
    writeln("\tiMilli\tdd\t?");
    writeln("\thStdHandle\t\tdd\t?");
    writeln("\tIntString\tdb\t12\t\tdup(?)\t; integer string");
    writeln("\tFltString\tdb\t28\t\tdup(?)");
    writeln("\tBffrInput\tdb\tBUFSIZE\tdup(?)");
    writeln("\tiohandles\tDD\t99\t\tdup(?)");
    writeln("\tiobuffers\tDD\t99\t\tdup(?)");
    writeln("\tiLVAR\t\tdd\t?");
    writeln("\tiRVAR\t\tdd\t?");
    writeln("\tqLVAR\t\tdq\t?");
    writeln("\tqRVAR\t\tdq\t?");
    writeln("\tarray_mtrx\t\tDW\t60\tdup(?)");
	/**/
    load_tmpdata();
	/**/
    writeln("; =========================================================================");
    writeln(" .code");
    writeln("; =========================================================================");
    writeln(" start:");
    writeln("; =========================================================================");
    writeln("  invoke Main");
    writeln("  invoke ExitProcess, NULL");
    writeln("; =========================================================================");
    writeln("; --------------------------------------------------");
    writeln("Main proc");
    writeln("; --------------------------------------------------");
    writeln("  pushad");
    writeln("  call Do_initialize");
}
/*---------- end Prolog ----------*/


void SystemConst()
{
    writeln("; --------------------------------------------------");
    writeln("; Do Not Delete !!!:  Constants and system variables");
    writeln("; --------------------------------------------------");
    writeln("\tinteger    dd  0");
    writeln("\tx87buff    dq  0");
    writeln("; --------------------------------------------------");
}
/*---------- end SystemConst ----------*/


void Epilog()			/* Write the Epilog */
{
    writeln(";");
    PostLabel("DONE");
    writeln("  ; --------------------------------------------------");
    writeln("  ; --------------------------------------------------");
    writeln("Alldone:");
    writeln("  invoke StdIn, addr BffrInput, BUFFR_SIZ   ; pause");
    writeln("  popad");
    writeln("  ret                                       ; return to windows");
    writeln("  ; --------------------------------------------------");
    writeln("Main endp");
    writeln("; =========================================================================");
		/**/
		/* --- write functions --- */
    Do_functions();
		/**/
		/* --- mark end of program --- */
    writeln("; =========================================================================");
    writeln("end start");
    writeln("; =========================================================================");
    writeln("; =========================================================================");
    fclose(f_out);
    printf("Lines compiled: %d\n", nrows);
    printf("Done.\n");
}
/*---------- end Epilog ----------*/


void open_destin()
{   char ch, dot='.', destin[PATH];
    int ii;

    strcpy(destin, s_holder);			/* copy source file name */
    ii = 0;
    ch = '\0';
    while(ch != dot)
    {   ch = s_holder[ii];			/* make source.bas = source. */
        ii++;
    }
    destin[ii] = '\0';
    strcat(destin, "asm");			/* append "asm" to filename */
    strcpy(t_holder, destin);			/* copy asm source filename */
		/**/
    f_out = fopen(destin,"w");	 /* open destination file (write) */
    printf("Destination file: %s\n",destin);
		/**/
    s_datatemp = fopen("sdatatmp.tmp","w");		/* open temp file */
    i_datatemp = fopen("idatatmp.tmp","w");		/* open temp file */
    f_datatemp = fopen("fdatatmp.tmp","w");		/* open temp file */
    x_datatemp = fopen("xdatatmp.tmp","w");		/* open temp file */
		/**/
    s_writeln("\t_var_start\tdd\t?");		/* string data */
    i_writeln("\t_int_start\tdd\t?");		/* integer data */
    f_writeln("\t_flt_start\tdd\t?");		/* float data */
    x_writeln("\t_arry_start\tdd\t?");		/* arrays data */
}
/*---------- end open_destin ----------*/


void ScanVars()				/* identify and write all variables */
{   char ch, varname[VAR_NAME];
    int pi, ii;
    
    line_ndx = 0;
    while(line_ndx < nrows)
    {   get_token();
        e_pos = 0;
        s_pos = 0;
		/**/
        switch(token)
        {   case 1:    			/* --- LET: statement --- */
                ScanLet();
                break;
            case 2:    			/* --- CLEAR: statement --- */
                ScanPrint();
                break;
            case 3:    			/* --- LOCATE: statement --- */
                ScanParam();
                break;
            case 4:	    		/* --- PRINT: statement --- */
                ScanPrint();
                break;
            case 5:    			/* --- GOTO: statement --- */
            case 9:    			/* --- GOSUB: statement --- */
                ScanJump();
                break;
            case 11:			/* --- FOR: statement --- */
                ScanFor();
                break;
            case 13:			/* --- IF: statement --- */
            case 14:			/* --- ELSEIF: statement --- */
                ScanIf();
                break;
            case 17:			/* --- INPUT: statement --- */
            case 18:			/* --- LINE INPUT: statement --- */
                ScanPrint();
                break;
            case 19:			/* --- OPEN: statement --- */
                ScanOpen();
                break;
            case 21:			/* --- WRITE: statement --- */
                ScanWrite();
                break;
            case 22:			/* --- FIELD: statement --- */
                ScanField();
                break;
            case 23:			/* --- LSET: statement --- */
            case 24:			/* --- RSET: statement --- */
                ScanLet();
                break;
            case 25:			/* --- PUT: statement --- */
            case 26:			/* --- GET: statement --- */
                ScanPut();
                break;
            case 27:			/* --- CHDIR: statement --- */
            case 28:			/* --- MKDIR: statement --- */
            case 29:			/* --- RMDIR: statement --- */
            case 30:			/* --- KILL: statement --- */
                ScanPrint();
                break;
            case 31:			/* --- NAME/RENAME: statement --- */
                ScanRename();
                break;
            case 32:			/* --- FILES: statement --- */
                ScanFiles();
                break;
            case 33:			/* --- SHELL: statement --- */
                ScanShell();
                break;
            case 34:	    		/* --- RANDOM: statement --- */
                ScanParam();
                break;
            case 35:	    		/* --- READ: statement --- */
                ScanFInput();
                break;
            case 37:	    		/* --- WHILE: statement --- */
                ScanIf();
                break;
            case 43:	    		/* --- LPRINT: statement --- */
                ScanLPrint();
                break;
            case 44:	    		/* --- COLOR: statement --- */
                ScanParam();
                break;
            case 46:	    		/* --- DIM: statement --- */
                ScanDim();
                break;
            case 47:	    		/* --- ERASE-FREE: statement --- */
                ScanErase();
                break;

        }
        line_ndx++;
    }
    SystemConst();				/* write system constants */
	/**/
    for(ii=0; ii < VarNdxCnt; ii++)		/* clear var name index */
    {   free(VarIndx[ii]);
    }
    free(VarIndx);
}
/*---------- end ScanVars ----------*/


void ScanLet()
{   char ch, varname[VAR_NAME];
    int pi, type, ab_code=5, x=line_ndx;

    pi = e_pos;
    strcpy(varname, get_varname());			/* get varname */
	/**/
    pi = e_pos;
    ch = p_string[pi];
    if(strchr("$%!#@&", ch))
    {   type = get_vtype(pi);				/* get variable type */
    /* printf("let1:varname=%s type=%d\n", varname, type); */
		/**/
        if(type == 0)					/* strings */
        {   ScanString(varname);
        }
        else if(type == 6)					/* string array */
        {   ScanStrArray(varname);
        }
        else if((type >= 7) && (type <= 10))		/* numeric array */
        {   ScanNumArray(varname, type);
        }
        else						/* numeric expressions */
        {   ScanNumeric(varname);
        }
    }
    else
    {   type = get_ObjectType(varname);	/* object type specifier */
    /* printf("let2:varname=%s type=%d\n", varname, type); */
		/**/
        if(type == 0)					/* strings */
        {   ScanString(varname);
        }
        else if(type == 6)					/* string array */
        {   ScanStrArray(varname);
        }
        else if((type >= 7) && (type <= 10))		/* numeric array */
        {   ScanNumArray(varname, type);
        }
        else						/* numeric expressions */
        {   ScanNumeric(varname);
        }
    }
}
/*---------- end ScanLet ----------*/


void ScanString(char *Name)
{   char ch, varname[VAR_NAME];
    int pi, len, type;

    strcpy(varname, Name);
    Fix_String(varname);
		/**/
    len = strlen(p_string);
    pi = e_pos;
    pi = get_rightExp(pi);			/* jump pi over this operator */
    ch = p_string[pi];
    while((ch != '\n') && (pi < len))
    {   e_pos = pi;
        if(ch == '\"')				/* found a quoted string */
        {   GetNewVar();				/* get new varname */
        }
        else if(isalpha(ch))
        {   strcpy(varname, get_varname());		/* get varname */
            type = get_ObjectType(varname);
			/**/
            if(type == 6)
            {   Fix_StrArray(varname);
                pi = e_pos;
                pi = get_paren(pi, len);
                ScanArrayParam();
            }
            else
            {   Fix_String(varname);
            }
        }
        else if(isdigit(ch))			/* a string function number */
        {   len = scanStr_funct(len);
        }
        pi = e_pos;
        pi = get_rightExp(pi);
        ch = p_string[pi];
    }
/* printf("%s", p_string); */
}
/*---------- end ScanString ----------*/


void ScanStrArray(char *Name)
{   char ch, varname[VAR_NAME];
    int pi, len, type;

    strcpy(varname, Name);
    len = strlen(p_string);
    pi = e_pos;
    ch = p_string[pi];
    if(ch == '$')
    {   Fix_StrArray(varname);
    }
	/**/
    pi = e_pos;
    pi = get_paren(pi, len);
    e_pos = pi;
    ScanArrayParam();			/* assign variables: abc$(1,3,n) */
		/**/
    pi = e_pos;
    pi = get_rightExp(pi);			/* jump pi over this operator */
    ch = p_string[pi];
    while((ch != '\n') && (pi < len))
    {   e_pos = pi;
        if(ch == '\"')				/* found a quoted string */
        {   GetNewVar();				/* get new varname */
        }
        else if(isalpha(ch))
        {   strcpy(varname, get_varname());		/* get varname */
            type = get_ObjectType(varname);
			/**/
            if(type == 6)
            {   Fix_StrArray(varname);
                pi = e_pos;
                pi = get_paren(pi, len);
                ScanArrayParam();
            }
            else
            {   Sav_String(varname);
            }
        }
        else if(isdigit(ch))			/* a string function number */
        {   len = scanStr_funct(len);
        }
        pi = e_pos;
        pi = get_rightExp(pi);
        ch = p_string[pi];
    }
/* printf("%s", p_string); */
}
/*---------- end ScanStrArray ----------*/


int scanStr_funct(int len)
{   char ch, varname[VAR_NAME];
    int pi, type;

    pi = e_pos;
    pi = get_paren(pi,len);
    if(pi >= len)
    {   e_pos = pi;				/* a$ = INKEY$, TIME$, DATE$ */
        return len;
    }
    pi++;
    pi = iswhite(pi);
    ch = p_string[pi];
    while((ch != ')') && (ch != '\n') && (pi < len))
    {   ch = p_string[pi];
        e_pos = pi;
        if(ch == '\"')				/* found a quoted string */
        {   GetNewVar();				/* get new varname */
        }
        else if((isdigit(ch)) || (strchr("-.", ch)))
        {   GetNewTmp();				/* get new temp varname */
        }
        else if(isalpha(ch))				/* a variable name */
        {   strcpy(varname, get_varname());	/* get varname */
            pi = e_pos;
            type = get_vtype(pi);			/* get variable type */
            if(type == 0)				/* string variables */
            {   Fix_String(varname);
            }
            else						/* numeric variables */
            {   len = strlen(varname);
                s_pos = pi - len;
                type = get_Nvtype(pi);
                Sav_Destin(type, varname);	/* save variable name */
            }
        }
        pi = e_pos;
        len = strlen(p_string);
        ch = p_string[pi];
  /* printf("ch=%c< pi=%d::%s", ch, pi, p_string); */

        if(strchr("$, %!#@&", ch))
        {   pi++;
        }
    }
    e_pos = pi;
    return len;

 /* printf("%s", p_string); */
}
/*---------- end scanStr_funct ----------*/


void ScanPrint()
{   char ch, varname[VAR_NAME];
    int pi, type, len, ival;

/* printf("ScanPrint::%s", p_string); */
    len = strlen(p_string);
    pi = e_pos;
    pi = iswhite(pi);
    ch = p_string[pi];
    if(ch == '#')
    {   if(token == 4)
        {   ScanFPrint();		/* PRINT# statement */
        }
        else
        {   ScanFInput();
        }
        return;
    }
    while((pi < len) && (ch != '\n'))
    {   e_pos = pi;

   /* printf("ch=%c pi=%d len=%d\n", ch, pi, len); */
		/**/
        if(ch == '\"')				/* found a quoted string */
        {   GetNewVar();			/* get new varname */
        }
        else if(ch == '?')			/* math function: ?1(num) */
        {   e_pos = pi + 1;
            ival = (int) get_avalue();
            if((ival == 10) || (ival == 11) || (ival == 29))
            {   pi = len;				/* LOC, LOF, EOF */
                e_pos = pi;
            }
            else					/* any other function */
            {   pi = get_paren(pi, len);	/* ?num(string$) */
                pi++;
                e_pos = pi;
                ScanMathFunc(len);
            }
        }
        else if(isalpha(ch))
        {   strcpy(varname, get_varname());	/* get varname */
            s_pos = pi;
            pi = e_pos;
            type = get_ObjectType(varname);
            if(type == -1)			/* an undeclared variable */
            {   type = get_vtype(pi);		/* ch == "$%@&!#" */
            }
      /* printf("name=%s type=%d pi=%d\n", varname, type, pi); */

            if(type == 0)				/* string variables */
            {   Fix_String(varname);
            }
            else if(type == 6)			/* string array */
            {   Fix_StrArray(varname);
                pi = get_paren(pi, len);
                ScanArrayParam();
            }
            else if((type >= 7) && (type <= 10))	/* numeric array */
            {   Fix_VarArray(varname);
                pi = get_paren(pi, len);
                ScanArrayParam();
            }
            else						/* numeric variables */
            {   len = strlen(varname);
                s_pos = pi - len;
                type = get_Nvtype(pi);
                Sav_Destin(type, varname);	/* save variable name */
            }
        }
        else if(isdigit(ch))			/* a string function number */
        {   pi = get_NextOp(pi);
            ch = p_string[pi];
      /* printf("ch=%c pi=%d len=%d\n", ch, pi, len); */

            if(ch == '(')			/* is it a: 2(string) */
            {   len = scanStr_funct(len);
            }
            else					/* or: 2+2 */
            {   GetNewTmp();			/* get new temp varname */
            }
        }
        pi = e_pos;
        ch = p_string[pi];
        len = strlen(p_string);
        if(strchr(":; ,)(", ch))		/* jump over punctuation */
        {   pi = get_rightExp(pi);		/* get to next alpha or string */
        }
        else if(strchr("$%!#@&", ch))	/* jump over var types */
        {   pi = get_rightExp(pi);		/* get to next alpha or string */
        }
        else if(strchr("+-*/^", ch))      /* jump over operators */
        {   pi = get_rightExp(pi);	/* get to next alpha or string */
        }
        e_pos = pi;
        ch = p_string[pi];
    }
/* printf("scanprint::%s", p_string); */
}
/*---------- end ScanPrint ----------*/


void ScanFor()
{   char ch, varname[VAR_NAME];
    int pi, type, len, ab_code=9, x=line_ndx;

    pi = 0;
    e_pos = pi;
    strcpy(varname, get_varname());			/* get varname */
	/**/
    type = get_vtype(pi);				/* get variable type */
    if(type == 1)						/* numeric expressions */
    {   LexFor(varname);
        pi = e_pos;
        e_pos = pi + 2;					/* skip over: TO */
        LexTo();
        pi = e_pos + 4;					/* skip over: STEP */
        len = strlen(p_string);
        if(len > pi)					/* if: STEP n */
        {   e_pos = pi;
            LexStep(len);
        }
        else
        {   e_pos = len;
            defaultStep(len);			/* create default STEP n */
        }
    }
    else
    {   a_bort(ab_code, x);
    }
}
/*---------- end ScanFor ----------*/


void ScanIf()
{   char ch, varname[VAR_NAME];
    int pi, len, type;

/* printf("ScanIf::%s", p_string); */
    pi = 0;
    ch = p_string[pi];
    len = strlen(p_string);
    while((ch != '\n') && (pi < len))
    {   pi = iswhite(pi);
        ch = p_string[pi];
        e_pos = pi;
        if(ch == '\"')				/* found a quoted string */
        {   GetNewVar();			/* get new varname */
        }
        else if(isalpha(ch))
        {   strcpy(varname, get_varname());	/* get varname */
            pi = e_pos;
            type = get_vtype(pi);			/* get variable type */
            if(type == 0)
            {   Fix_String(varname);
            }
            else
            {   if(strcmp(varname, "EOF") != 0)		/* not an EOF(f) */
                {   len = strlen(varname);
                    s_pos = pi - len;
                    type = get_Nvtype(pi);
                    Sav_Destin(type, varname);	/* save destination name */
                }
                else
                {   pi++;					/* it's an EOF(f) */
                    pi = get_paren(pi, len);
                    e_pos = pi;
                }
            }
        }
        else if(isdigit(ch))
        {   GetNewTmp();				/* get new temp varname */
        }
        pi = e_pos;
        len = strlen(p_string);
        pi = get_rightExp(pi);
        ch = p_string[pi];
    }
/* printf("scanif::%s", p_string); */
}
/*---------- end ScanIf ----------*/


void ScanFiles()
{   char ch, temp[BUFSIZE];
    int pi, len;

    strcpy(temp, "\"dir ");
    len = strlen(p_string);
    pi = e_pos;
    pi = iswhite(pi);
		/**/
    if(pi < len)
    {   ch = p_string[pi];
        if(ch == '\"')
        {   p_string[pi] = ' ';
            strcat(temp, p_string);
        }
        else
        {   strcat(temp, p_string);
        }
    }
    else
    {   strcat(temp, "\"\n");
    }
    strcpy(p_string, temp);
    e_pos = 0;
    GetNewVar();					/* get new varname */
}
/*---------- end ScanFiles ----------*/


void ScanShell()
{   char ch, temp[BUFSIZE];
    int pi, len;

    len = strlen(p_string);
    pi = e_pos;
    pi = iswhite(pi);
		/**/
    if(pi < len)
    {   strcpy(temp, p_string);
    }
    else
    {   strcpy(temp, "\"command\"");
    }
    strcpy(p_string, temp);
    e_pos = 0;
    GetNewVar();					/* get new varname */
}
/*---------- end ScanShell ----------*/


void ScanRename()
{   char temp[6];
    int pi, len, mark;

    len = strlen(p_string);
    pi = e_pos;
		/**/
    strcpy(temp, "AS ");
    s_pos = pi;
    mark = find_strng(temp);
    mark--;
    pi = mark;
    if(pi < len)
    {   p_string[pi] = ',';
        p_string[(pi+1)] = ' ';
    }
    e_pos = 0;
    ScanPrint();
}
/*---------- end ScanRename ----------*/

void load_tmpdata()
{   char tmp_string[BUFSIZE];
    int x;
    FILE *datatemp;

    f_writeln("\t_var_endzz\tdd\t?");
    f_writeln("\tStringBffr\tdb\tMBUFSIZE\tdup(?)");
    fclose(s_datatemp);
    fclose(i_datatemp);
    fclose(f_datatemp);
    fclose(x_datatemp);
		/**/
    datatemp = fopen("sdatatmp.tmp","r");		/* open temp file */
    while(!feof(datatemp))
    {   fgets(tmp_string, BUFSIZE, datatemp);
        if(!feof(datatemp))
        {   write_str(tmp_string);		/* write data to file */
        }
        tmp_string[0] = '\0';
    }
    fclose(datatemp);
		/**/
    datatemp = fopen("idatatmp.tmp","r");		/* open temp file */
    while(!feof(datatemp))
    {   fgets(tmp_string, BUFSIZE, datatemp);
        if(!feof(datatemp))
        {   write_str(tmp_string);		/* write data to file */
        }
        tmp_string[0] = '\0';
    }
    fclose(datatemp);
		/**/
    datatemp = fopen("fdatatmp.tmp","r");		/* open temp file */
    while(!feof(datatemp))
    {   fgets(tmp_string, BUFSIZE, datatemp);
        if(!feof(datatemp))
        {   write_str(tmp_string);		/* write data to file */
        }
        tmp_string[0] = '\0';
    }
    fclose(datatemp);
		/**/
    datatemp = fopen("xdatatmp.tmp","r");		/* open temp file */
    while(!feof(datatemp))
    {   fgets(tmp_string, BUFSIZE, datatemp);
        if(!feof(datatemp))
        {   write_str(tmp_string);		/* write data to file */
        }
        tmp_string[0] = '\0';
    }
    fclose(datatemp);
		/**/
    x = remove("sdatatmp.tmp");   		/* if '0', successful */
    x = remove("idatatmp.tmp");   		/* if '0', successful */
    x = remove("fdatatmp.tmp");   		/* if '0', successful */
    x = remove("xdatatmp.tmp");   		/* if '0', successful */
}
/*------- end load_tmpdata ----------*/


void ScanErase()
{   char ch, varname[VAR_NAME];
    int pi, type, len, ival, ab_code=22, x=line_ndx;

    len = strlen(p_string);
    pi = e_pos;
    pi = iswhite(pi);
    ch = p_string[pi];
    while((pi < len) && (ch != '\n'))
    {   e_pos = pi;
		/**/
        if(isalpha(ch))
        {   strcpy(varname, get_varname());	/* get varname */
            s_pos = pi;
            pi = e_pos;
            type = get_ObjectType(varname);
			/**/
            if(type == 6)			/* string array */
            {   Fix_StrArray(varname);
            }
            else if((type >= 7) && (type <= 10))	/* numeric array */
            {   Fix_VarArray(varname);
            }
            else
            {   a_bort(ab_code, x);
            }
        }
        else
        {   a_bort(ab_code, x);
        }
        pi = e_pos;
        ch = p_string[pi];
        len = strlen(p_string);
        if(strchr(",", ch))			/* jump over punctuation */
        {   pi = get_rightExp(pi);		/* get to next alpha or string */
        }
        e_pos = pi;
        ch = p_string[pi];
    }
}
/*---------- end ScanErase ----------*/

$CCODE