$CCODE
/* bxbasm : Asmrdp.c : alpha version */
/* special credits to: Jack Crenshaw's: "How to Build a Compiler" */
/* this is a very close implementation of his tutorial.           */

/* ----- function prototypes ----- */
//#include "prototyp.h"



void Assignment()		/* Recursive Descent Parser Main */
{
    writeln("  FINIT \t\t\t; initialize x87");
    Match('=');
    a_Expression();
}
/*---------- end Assignment ----------*/

void a_Expression()	/* Parse and Translate an Expression */
{   char ch;
    int pi;

    pi = e_pos;
    ch = p_string[pi];
    if(IsAddop(ch))
    {   writeln("  FLDZ\t\t\t\t; push 0 onto stack");
    }
    else
    {   a_Term();
        pi = e_pos;
        ch = p_string[pi];
    }
    while(IsAddop(ch))
    {   switch(ch)
        {   case '+':
                Add();		/* Recognize and Translate an Add */
                break;
            case '-':
                Subtract();	/* Recognize and Translate a Subtract */
                break;
            default:
                break;
        }
        pi = e_pos;
        ch = p_string[pi];
    }
}
/*---------- end a_Expression ----------*/

void a_Term()		/* Parse and Translate a Math Term */
{   char ch;
    int pi;

    a_Factor();
    pi = e_pos;
    ch = p_string[pi];
    while(IsMultop(ch))
    {   switch(ch)
        {   case '*':
                Multiply();	/* Recognize and Translate a Multiply */
                break;
            case '/':
                Divide();	/* Recognize and Translate a Divide */
                break;
            case '^':
                Power();	/* Recognize and Translate a Power Of */
                break;
            case '%':
                Modulo();	/* Recognize and Translate a Modulo */
                break;
            default:
                break;
        }
        pi = e_pos;
        ch = p_string[pi];
    }
}
/*---------- end a_Term ----------*/

void a_Factor()		/* Parse and Translate a Math Factor */
{   char ch, Value[10];
    int pi, ab_code=7, x=line_ndx;

    pi = e_pos;
    ch = p_string[pi];
    if(ch == '(')
    {   Match('(');
        a_Expression();
        Match(')');
    }
    else
    {   if(isalpha(ch))				/* variable name */
        {   Ident();
        }
        else if(ch == '?')			/* math function */
        {   math_functn();
        }
        else					/* error */
        {   a_bort(ab_code, x);
        }
    }
}
/*---------- end a_Factor ----------*/


void math_functn()
{   int pi, type;

    pi = e_pos;				/* enter: ?1(x) */
    pi++;					/*    ----^     */
    e_pos = pi;
    type = (int) get_avalue();
    switch(type)
    {   case 1:
            get_ABS();			/* a = ABS(exp) */
            break;
        case 2:
            get_ASC();			/* a = ASC(str$) */
            break;
        case 3:
            get_ATN();			/* a! = ATN(exp) */
            break;
        case 4:
            get_COS();			/* a! = COS(exp) */
            break;
        case 5:
            get_SIN();			/* a! = SIN(exp) */
            break;
        case 6:
            get_TAN();			/* a! = TAN(exp) */
            break;
        case 7:
            get_SQRT();			/* a! = SQRT(exp) */
            break;
        case 8:
            get_INT();			/* a = INT(exp) */
            break;
        case 9:
            get_LEN();			/* a = LEN(str$) */
            break;
        case 10:
            get_LOF();			/* a% = LOF(fp) */
            break;
        case 11:
            get_LOC();			/* a% = LOC(fp) */
            break;
        case 12:				/* a# = CVD(str$) */
        case 14:				/* a! = CVS(str$) */
            get_CVD();
            break;
        case 13:				/* a% = CVI(str$) */
            get_CVI();
            break;
        case 15:
            get_ATN2();			/* a! = ATN2(exp, exp) */
            break;
        case 16:
            get_COSH();			/* a! = COSH(exp) */
            break;
        case 17:
            get_SINH();			/* a! = SINH(exp) */
            break;
        case 18:
            get_TANH();			/* a! = TANH(exp) */
            break;
        case 19:
            get_ACOS();			/* a! = ACOS(exp) */
            break;
        case 20:
            get_ASIN();			/* a! = ASIN(exp) */
            break;
        case 21:
            get_CEIL();			/* a! = CEIL(exp) */
            break;
        case 22:
            get_FLOOR();		/* a! = FLOOR(exp) */
            break;
        case 23:
            get_HYPOT();		/* a! = HYPOT(exp,exp) */
            break;
        case 24:
            get_LOG();			/* a! = LOG(exp) */
            break;
        case 25:
            get_LOG10();		/* a! = LOG10(exp) */
            break;
        case 26:
            get_RAND();			/* a = RAND(void) */
            break;
        case 27:
            get_CLOCK();		/* a = CLOCK(void) */
            break;
        case 28:
            get_VAL();			/* a = VAL(string$) */
            break;
        case 29:
            get_EOF();			/* a = EOF(fp) */
            break;
        default:
            /* error */
            break;
    }
}
/*---------- end math_functn ----------*/


void asn_numarry(char *name, int type)	/* assign a numeric array */
{   char ch, varname[VAR_NAME];
    int pi, len, xcnt;

    strcpy(varname, name);			/* enter: abc% = array%(n,) */
		/**/
    len = strlen(p_string);
    pi = e_pos;
    pi = get_paren(pi, len);
 /*   xcnt = get_paramsCount(pi, len);	 get params count */
    xcnt = get_ObjectParm(varname);
		/**/
    get_offset(varname, len, xcnt);
    writeln("  mov  eax, [edi]");
		/**/
/* --- load integers --- */
    if(type == 7) 
    {   writeln("  FILD dword ptr [eax]\t\t\t; load integer");
    }
    else if(type == 10)
    {   writeln("  FILD qword ptr [eax]\t\t\t; load integer");
    }
    else if((type == 8) || (type == 9))
    {   writeln("  FLD qword ptr [eax]\t\t\t; load float");
    }
}
/*---------- end asn_numarry ----------*/


void Ident() 		/* Parse and Translate an Identifier */
{   char ch, varname[VAR_NAME];
    int pi, type, ab_code=5, x=line_ndx;

    strcpy(varname, get_varname());
    type = get_ObjectType(varname);		/* object type specifier */
 /* printf("varname=%s type=%d\n", varname, type); */

    pi = e_pos;
		/**/
    if((type >= 7) && (type <= 10))
    {   asn_numarry(varname, type);		/* source is a numeric array */
        pi = e_pos;
        pi++;
        pi = iswhiter(pi);
        e_pos = pi;
        return;
    }
/* --- get variable type --- */
    SkipWhite();
    pi = e_pos;
    ch = p_string[pi];
    if(ch == '(')		/* function call */
    {   Match('(');
        Match(')');
        write_str("  call  ");
        writeln(varname);
    }
/* --- load integers --- */
    else if((type == 1) || (type == 2) || (type == 5))
    {   write_str("  FILD  ");
        write_str(varname);
        writeln("\t\t\t; load integer");
    }
/* --- load floating pt. --- */
    else if((type == 3) || (type == 4))
    {   write_str("  FLD   ");
        write_str(varname);
        writeln("\t\t\t; load float");
    }
    else
    {   a_bort(ab_code, x);
    }
}
/*---------- end Ident ----------*/


void Add()			/* Recognize and Translate an Add */
{
    Match('+');
    a_Term();
    writeln("  FADDP ST(1), ST\t\t\t; add to ST(0) and pop");
}
/*---------- end Add ----------*/

void Subtract()		/* Recognize and Translate a Subtract */
{
    Match('-');
    a_Term();
    writeln("  FSUBP ST(1), ST\t\t; subtract and pop");
}
/*---------- end Subtract ----------*/

void Multiply()		/* Recognize and Translate a Multiply */
{
    Match('*');
    a_Factor();
    writeln("  FMULP ST(1), ST\t\t\t; multiply and pop");
}
/*---------- end Multiply ----------*/

void Divide()		/* Recognize and Translate a Divide */
{
    Match('/');
    a_Factor();
    writeln("  FDIVP ST(1), ST\t\t\t; divide and pop");
}
/*---------- end Divide ----------*/


void Power()		/* Recognize and Translate a Power Of */
{
    Match('^');
    writeln("  FSTP  qLVAR");
    a_Factor();
    writeln("  FSTP  qRVAR");
    writeln("  invoke pow, qLVAR, qRVAR"); /* double value is in ST(0) */
}
/*---------- end Power ----------*/


void Modulo()		/* Recognize and Translate a Modulo */
{
    Match('%');
    writeln("  FSTP  qLVAR");
    a_Factor();
    writeln("  FSTP  qRVAR");
    writeln("  invoke fmod, qLVAR, qRVAR"); /* double value is in ST(0) */
}
/*---------- end Modulo ----------*/


void Match(char x)	/* Match a Specific Input Character */
{   char ch, string[6];
    int pi, ab_code=12, ln=line_ndx;

    pi = e_pos;
    ch = p_string[pi];
    if(ch != x)
    {   strcpy(string, "\" \"");
        string[1] = x;
        strcpy(t_holder, string);
        a_bort(ab_code,ln);
    }
    else
    {   _GetChar();
        SkipWhite();
    }
}
/*---------- end Match ----------*/

int IsAddop(char ch) 		/* Recognize an Addop */
{   int _bool=0;

    if((ch == '+') || (ch == '-'))
    {   _bool = 1;
    }
    return _bool;
}
/*---------- end IsAddop ----------*/

int IsMultop(char ch) 		/* Recognize an Addop */
{   int _bool=0;

    if(strchr("*^/%", ch))
    {   _bool = 1;
    }
    return _bool;
}
/*---------- end IsMultop ----------*/

int Is_White(char ch)
{   int _bool=0;

    if((ch == ' ') || (ch == '\t'))
    {   _bool = -1;
    }
    return _bool;
}
/*---------- end Is_White ----------*/

void _GetChar()
{
    e_pos++;		/* advance pointer */
}
/*---------- end _GetChar ----------*/

void SkipWhite() 	/* Skip Over Leading White Space */
{   char ch;
    int pi;

    pi = e_pos;
    ch = p_string[pi];
    while(Is_White(ch))
    {   _GetChar();		/* advance & save pointer */
        pi = e_pos;
        ch = p_string[pi];
    }
}
/*---------- end SkipWhite ----------*/


void get_CVI()		    /* convert an I/O buffer string to a number */
{   char varname[VAR_NAME];				/* a% = CVI(string$) */
    int pi, len;


    len = strlen(p_string);
    pi = e_pos;
    pi = get_alpha(pi, len);
    e_pos = pi;
    strcpy(varname, get_varname());
		/**/
    write_str("  mov  esi, [");
    write_str(varname);
    writeln("]");
		/**/
    if(var_type == 5)			/* check global type variable */
    {   writeln("  mov  edi, offset qLVAR");
        writeln("  call mkqstr");
        writeln("  FILD   qLVAR");
		/**/
        asnmkqstr = 1;
    }
    else
    {   writeln("  mov  edi, offset iLVAR");
        writeln("  call mkistr");
        writeln("  FILD   iLVAR");
		/**/
        asnmkistr = 1;
    }
}
/*---------- end get_CVI ----------*/


void get_CVD()		    /* convert an I/O buffer string to a number */
{   char varname[VAR_NAME];				/* a# = CVD(string$) */
    int pi, len;						/* a! = CVS(string$) */

    len = strlen(p_string);
    pi = e_pos;
    pi = get_alpha(pi, len);
    e_pos = pi;
    strcpy(varname, get_varname());
		/**/
    write_str("  mov  esi, [");
    write_str(varname);
    writeln("]");
    writeln("  mov  edi, offset qLVAR");
    writeln("  call mkdstr");
    writeln("  FLD   qLVAR");
		/**/
    asnmkdstr = 1;
}
/*---------- end get_CVD ----------*/


void get_LEN()					/* get string length */
{   char varname[VAR_NAME];			/* num = LEN(string$) */
    int pi, len, type, xcnt;

    len = strlen(p_string);
    pi = e_pos;
    pi = get_alpha(pi, len);
    e_pos = pi;
    strcpy(varname, get_varname());
    type = get_ObjectType(varname);		/* object type specifier */
		/**/
    if(type == 6)					/* source is an array-string */
    {   pi = e_pos;
        pi = get_paren(pi, len);
        xcnt = get_ObjectParm(varname);
        get_offset(varname, len, xcnt);
        writeln("  mov  eax, [edi]");	/* load string address to EAX */
    }
    else
    {   write_str("  mov  eax, [");
        write_str(varname);
        writeln("]");
    }
    writeln("  invoke strlen, eax");
    writeln("  mov  iLVAR, eax");
    writeln("  FILD  iLVAR");
}
/*---------- end get_LEN ----------*/


void get_INT()			/* make a float number an integer */
{							/* a% = INT(float#) */
    a_Factor();
		/**/
    writeln("  invoke FpuTrunc, 0, 0, SRC1_FPU or DEST_FPU");
}
/*---------- end get_INT ----------*/


void get_SQRT()				/* get the square root of a number */
{						/* a! = SQRT(num) */
    a_Factor();
		/**/
    writeln("  FSTP  qLVAR");
    writeln("  invoke sqrt, qLVAR"); 	/* double value is in ST(0) */
}
/*---------- end get_SQRT ----------*/


void get_TANH()			/* get the hyperbolic tangent of a number */
{							/* a# = TANH(num) */
    a_Factor();
		/**/
    writeln("  FSTP  qLVAR");
    writeln("  invoke tanh, qLVAR"); 	/* double value is in ST(0) */
}
/*---------- end get_TANH ----------*/


void get_TAN()				/* get the tangent of a number */
{							/* a# = TAN(num) */
    a_Factor();
		/**/
    writeln("  FSTP  qLVAR");
    writeln("  invoke tan, qLVAR"); 	/* double value is in ST(0) */
}
/*---------- end get_TAN ----------*/


void get_SINH()			/* get the hyerbolic sine of a number */
{							/* a# = SINH(num) */
    a_Factor();
		/**/
    writeln("  FSTP  qLVAR");
    writeln("  invoke sinh, qLVAR"); 	/* double value is in ST(0) */
}
/*---------- end get_SINH ----------*/


void get_SIN()				/* get the sine of a number */
{							/* a# = SIN(num) */
    a_Factor();
		/**/
    writeln("  FSTP  qLVAR");
    writeln("  invoke sin, qLVAR"); 	/* double value is in ST(0) */
}
/*---------- end get_SIN ----------*/


void get_COSH()			/* get the hyperbolic cosine of a number */
{							/* a# = COSH(num) */
    a_Factor();
		/**/
    writeln("  FSTP  qLVAR");
    writeln("  invoke cosh, qLVAR"); 	/* double value is in ST(0) */
}
/*---------- end get_COSH ----------*/


void get_COS()				/* get the cosine of a number */
{							/* a# = COS(num) */
    a_Factor();
		/**/
    writeln("  FSTP  qLVAR");
    writeln("  invoke cos, qLVAR"); 	/* double value is in ST(0) */
}
/*---------- end get_COS ----------*/


void get_ATN2()			/* get the arctangent of 2 numbers */
{   char ch;						/* a# = ATN2(num,num) */
    int pi, len;

    pi = e_pos;
    ch = p_string[pi];
    len = strlen(p_string);
    pi = get_alpha(pi, len);
    e_pos = pi;
		/**/
    a_Factor();
    writeln("  FSTP  qLVAR");
		/**/
    pi = e_pos;
    ch = p_string[pi];
    len = strlen(p_string);
    pi = get_alpha(pi, len);
    e_pos = pi;
		/**/
    a_Factor();
    writeln("  FSTP  qRVAR");			/* double value is in ST(0) */
    writeln("  invoke atan2, qLVAR, qRVAR");
}
/*---------- end get_ATN2 ----------*/


void get_ATN()				/* get the arctangent of a number */
{							/* a# = ATN(num) */
    a_Factor();
		/**/
    writeln("  FSTP  qLVAR");
    writeln("  invoke atan, qLVAR"); 	/* double value is in ST(0) */
}
/*---------- end get_ATN ----------*/


void get_ASC()			/* get the ascii value of a character */
{   char ch, varname[VAR_NAME], temp[6];			/* a = ASC(chr$) */
    int pi, len, type, xcnt, mark;

    len = strlen(p_string);
    pi = e_pos;
    pi = get_alpha(pi, len);
    e_pos = pi;
    strcpy(varname, get_varname());
		/**/
    strcpy(temp, "VARX");
    s_pos = pi;
    mark = find_strng(temp);
    mark--;
		/**/
    type = get_ObjectType(varname);		/* object type specifier */
    if(type == 6)					/* source is an array-string */
    {   pi = e_pos;
        pi = get_paren(pi, len);
        xcnt = get_ObjectParm(varname);
        get_offset(varname, len, xcnt);
        writeln("  mov  esi, [edi]");	/* load string address to ESI */
    }
    else if(mark == pi)				/* this is a temp var-name */
    {   write_str("  mov  esi, offset ");
        write_str(varname);
        writeln("\t\t\t; load temp variable address");
    }
    else
    {   write_str("  mov  esi, [");
        write_str(varname);
        writeln("]");
    }
    writeln("  xor  eax, eax");
    writeln("  mov  al,  [esi]");
    writeln("  mov  iLVAR, eax");
    writeln("  FILD  iLVAR");
}
/*---------- end get_ASC ----------*/


void get_ABS()			/* get the absolute value of a number */
{							/* a% = ABS(num) */
    a_Factor();
		/**/
    writeln("  FISTP  iLVAR");
    writeln("  invoke abs, iLVAR");
    writeln("  mov   iLVAR, eax");		/* integer value is in eax */
    writeln("  FILD  iLVAR");
}
/*---------- end get_ABS ----------*/


void get_ASIN()				/* get the arc sine of a number */
{							/* a# = ASIN(num) */
    a_Factor();
		/**/
    writeln("  FSTP  qLVAR");
    writeln("  invoke asin, qLVAR"); 	/* double value is in ST(0) */
}
/*---------- end get_ASIN ----------*/


void get_ACOS()				/* get the arc cosine of a number */
{							/* a# = ACOS(num) */
    a_Factor();
		/**/
    writeln("  FSTP  qLVAR");
    writeln("  invoke acos, qLVAR"); 	/* double value is in ST(0) */
}
/*---------- end get_ACOS ----------*/


void get_CEIL()				/* get the ceiling of a number */
{							/* a# = CEIL(num) */
    a_Factor();
		/**/
    writeln("  FSTP  qLVAR");
    writeln("  invoke ceil, qLVAR"); 	/* double value is in ST(0) */
}
/*---------- end get_CEIL ----------*/


void get_FLOOR()				/* get the floor of a number */
{							/* a# = FLOOR(num) */
    a_Factor();
		/**/
    writeln("  FSTP  qLVAR");
    writeln("  invoke floor, qLVAR"); 	/* double value is in ST(0) */
}
/*---------- end get_FLOOR ----------*/


void get_HYPOT()				/* get the hypotenuse of 2 numbers */
{   char ch;						/* a# = HYPOT(num,num) */
    int pi, len;

    pi = e_pos;
    ch = p_string[pi];
    len = strlen(p_string);
    pi = get_alpha(pi, len);
    e_pos = pi;
		/**/
    a_Factor();
    writeln("  FSTP  qLVAR");
		/**/
    pi = e_pos;
    ch = p_string[pi];
    len = strlen(p_string);
    pi = get_alpha(pi, len);
    e_pos = pi;
		/**/
    a_Factor();
    writeln("  FSTP  qRVAR");			/* double value is in ST(0) */
    writeln("  invoke _hypot, qLVAR, qRVAR");
}
/*---------- end get_HYPOT ----------*/


void get_LOG()				/* get the log of a number */
{							/* a# = LOG(num) */
    a_Factor();
		/**/
    writeln("  FSTP  qLVAR");
    writeln("  invoke log, qLVAR"); 	/* double value is in ST(0) */
}
/*---------- end get_LOG ----------*/


void get_LOG10()				/* get the log10 of a number */
{							/* a# = LOG10(num) */
    a_Factor();
		/**/
    writeln("  FSTP  qLVAR");
    writeln("  invoke log10, qLVAR"); 	/* double value is in ST(0) */
}
/*---------- end get_LOG10 ----------*/


void get_RAND()						/* get a random number */
{   int pi;							/* a = RAND() */

    writeln("  call  rand");
    writeln("  mov   iLVAR, eax");		/* integer value is in eax */
    writeln("  FILD  iLVAR");
		/**/
    pi = e_pos;					/* xyz = RAND()... */
    pi += 2;					/* ----------^     */
    pi = iswhiter(pi);
    e_pos = pi;
}
/*---------- end get_RAND ----------*/


void seed_rand()				/* seed random number generator */
{								/* RANDOM(n) */
    a_Factor();
		/**/
    writeln("  FISTP  iLVAR");
    writeln("  invoke srand, iLVAR");
}
/*---------- end seed_rand ----------*/


void get_CLOCK()						/* get clock ticks */
{								/* a = CLOCK() */
    writeln("  call  clock");
    writeln("  mov   iLVAR, eax");		/* integer value is in eax */
    writeln("  FILD  iLVAR");
}
/*---------- end get_CLOCK ----------*/


void get_VAL()					/* get value of ascii string */
{   char varname[VAR_NAME];			/* num = VAL(string$) */
    int pi, len, type, xcnt;

    len = strlen(p_string);
    pi = e_pos;
    pi = get_alpha(pi, len);
    e_pos = pi;
		/**/
    strcpy(varname, get_varname());
    type = get_ObjectType(varname);		/* object type specifier */
		/**/
    if(type == 6)					/* source is an array-string */
    {   pi = e_pos;
        pi = get_paren(pi, len);
        xcnt = get_ObjectParm(varname);
        get_offset(varname, len, xcnt);
        writeln("  mov  eax, [edi]");	/* load string address to EAX */
    }
    else
    {   write_str("  mov  eax, [");
        write_str(varname);
        writeln("]");
    }
    writeln("  invoke StrToFloat, eax, addr qLVAR");
    writeln("  FLD  qLVAR");
}
/*---------- end get_VAL ----------*/


void get_LOC()
{   char fptr[4], varname[VAR_NAME];			/* num = LOC(1) */
    int pi, len, ival, ab_code=27, x=line_ndx;
    double value;

    len = strlen(p_string);
    pi = e_pos;
    pi = get_digit(pi, len);
    if(pi >= len)
    {   a_bort(ab_code, x);
    }
    e_pos = pi;
    value = get_avalue();
    ival = (int) value;
    ival--;
    sprintf(fptr, "%d", ival);
		/**/
    write_str("  mov  eax, ");
    writeln(fptr);
    writeln("  call getfilehandle");
    writeln("  invoke ftell, eax");
    writeln("  mov   iLVAR, eax");		/* integer value is in eax */
    writeln("  FILD  iLVAR");
		/**/
    getfilehandle = 1;
}
/*---------- end get_LOC ----------*/


void get_LOF()
{   char fptr[4], varname[VAR_NAME];			/* num = LOF(1) */
    int pi, len, ival, ab_code=27, x=line_ndx;
    double value;

    len = strlen(p_string);
    pi = e_pos;
    pi = get_digit(pi, len);
    if(pi >= len)
    {   a_bort(ab_code, x);
    }
    e_pos = pi;
    value = get_avalue();
    ival = (int) value;
    ival--;
    sprintf(fptr, "%d", ival);
		/**/
    write_str("  mov  eax, ");
    writeln(fptr);
    writeln("  call getfilelength");
		/**/
    getfilelength = 1;
    getfilehandle = 1;
}
/*---------- end get_LOF ----------*/


void get_EOF()
{   char fptr[4], varname[VAR_NAME];			/* num = EOF(1) */
    int pi, len, ival, ab_code=27, x=line_ndx;
    double value;

    len = strlen(p_string);
    pi = e_pos;
    pi = get_digit(pi, len);
    if(pi >= len)
    {   a_bort(ab_code, x);
    }
    e_pos = pi;
    value = get_avalue();
    ival = (int) value;
    ival--;
    sprintf(fptr, "%d", ival);
		/**/
    write_str("  mov  eax, ");
    writeln(fptr);
    writeln("  call getfilehandle");
    writeln("  invoke feof, eax");
    writeln("  mov   iLVAR, eax");		/* integer value is in eax */
    writeln("  FILD  iLVAR");
		/**/
    getfilehandle = 1;
}
/*---------- end get_EOF ----------*/


$CCODE