$CCODE

void line_cnt(char *argv[])
{   int pi, len, ii=0, x=0, ab_code=2;
    unsigned fnam_len;

    nrows = 0;
  /* --- get length of command line argument --- */
    fnam_len = strlen(argv[1]);
    len = fnam_len;
    fnam_len += 5;                      			/* add padding */
    prog_name = (char*)malloc(fnam_len * sizeof(char));
    strcpy(prog_name, argv[1]);

  /* --- does source filename end in: .bas --- */
    pi = (len-4);
    for(; pi < len; pi++)
    {   p_string[ii] = prog_name[pi];
        ii++;
    }
    if(strcmp(p_string, ".bas") != 0)         		/* if not, add it */
    {   strcat(prog_name, ".bas");
    }
    p_string[0] = '\0';
    strcpy(s_holder, prog_name);

  /* --- open filename.bas for Read --- */
    f_in = fopen(prog_name,"r");
    if(f_in == NULL)                		/* error:file not found */
    {   a_bort(ab_code, x);
    }
    else
    {   load_src();                /* read source-file, write temp-file */
        loader_1();                /* read temp-file, load temp arrays */
        loader_2();                /* load program arrays */
        free(prog_name);
        x = remove("source.tmp");   	/* if test is '0', successful */
    }
}
/*------- end line_cnt ----------*/

void load_src()
{   char *tmp="source.tmp";
    int pi, len;

    f_out = fopen(tmp,"w");                     /* open output file */
    while(!feof(f_in))
    {   fgets(p_string, BUFSIZE, f_in);
        pi = 0;
        pi = iswhite(pi);
        len = strlen(p_string);
        if((len > 2) && (pi < len))        /* skip over blank lines */
        {   if(!feof(f_in))
            {   save_tmp();                /* write data to file */
            }
        }
    }
    fclose(f_in);
    fclose(f_out);
}
/*------- end load_src ----------*/

void save_tmp()
{   char ch;
    int pi, len;

  /* --- setup xstring to write indented line --- */
    strcpy(xstring, "  ");
    strcat(xstring, p_string);
    pi = 0;
    ch = p_string[pi];

  /* --- test for a Label: --- */
    if(isupper(ch) != 0)
    {   len = (LLEN-2);
        pi = while_isalnum(pi);             /* loop thru "Label:" */
        ch = p_string[pi];
        if((ch == ':') && (pi <= len))
        {   pi++;
            p_string[pi] = '\0';
            strcat(p_string, "\n\0");
            fprintf(f_out,"%s", p_string);     	/* write block label */
            nrows++;
        }
        else
        {   fprintf(f_out,"%s", xstring);    	/* write indented line */
            nrows++;
        }
    }

  /* --- test for numbered line --- */
    else if(isdigit(ch))
    {   fprintf(f_out,"%s", p_string);        	/* write numbered line */
        nrows++;
    }
    else
    {   pi = iswhite(pi);
        ch = p_string[pi];
        if(ch != '\'')                 	 /* eliminate comment lines */
        {   fprintf(f_out,"%s", xstring);  /* write indented line */
            nrows++;
        }
    }
}
/*------- end save_tmp ----------*/

void loader_1()
{   char ch, ln_holder[LLEN], *tmp="source.tmp";
    int ii, len, pi;
    unsigned size=ncolumns;

/* --- create temp arrays --- */
    temp_prog = (char**)malloc(nrows * sizeof(char *));
    for(ii = 0; ii < nrows; ii++)
    {   temp_prog[ii] = (char*)malloc(size * sizeof(char));
    }
    temp_label = (char**)malloc(nrows * sizeof(char *));
    for(ii = 0; ii < nrows; ii++)
    {   temp_label[ii] = (char*)malloc(LLEN * sizeof(char));
    }
    temp_byte = (int*)malloc(nrows * sizeof(int));
		/**/
/* --- open source.tmp for Read --- */
    f_in = fopen(tmp,"r");
    ii = 0;
    while(!feof(f_in))             	/* p_string holds incoming-data */
    {   fgets(p_string, BUFSIZE, f_in);
        if(!feof(f_in))
        {   len = strlen(p_string);
			/**/
           /* ----- fill temp_label[] here ----- */
            tmp_label(ii);               		/* call label filter */
            pi = e_pos;
            ch = p_string[pi];
            if(ch == ':')                       /* found a label */
            {   temp_byte[ii] = -1;
                strcpy(temp_prog[ii], "\n\0");
            }
			/**/
           /* ----- fill temp_byte[] here ----- */
            else
            {   tmp_byte(ii);            		/* call byte filter */
                tmp_prog(ii);
            }
        }
        ii++;
    }
    fclose(f_in);
}
/*---------- end loader_1 ----------*/

void tmp_label(int ii)
{   char ch, ln_label[LLEN];
    int pi;

  /* --- fill temp_label[] here --- */
    pi = 0;
    ch = p_string[pi];
    if(isalnum(ch))
    {   while(isalnum(ch))
        {   ln_label[pi] = ch;
            pi++;
            ch = p_string[pi];
        }
        ln_label[pi] = '\0';
        strcpy(temp_label[ii], ln_label);
    }
    else
    {   strcpy(temp_label[ii], " \0");
    }
    e_pos = pi;
}
/*---------- end tmp_label ----------*/

void tmp_byte(int ii)
{   char ch;
    int pi, si, byte, x=ii, ab_code=4;

  /* ----- fill temp_byte[] here ----- */
    pi = e_pos;
    pi = iswhite(pi);
    ch = p_string[pi];
    if(ch == '\'')                  	/* it's a comment */
    {   byte = 0;
        strcpy(temp_prog[ii], "\n\0");
    }
    else
    {   if(isupper(ch))              	/* is this a keyword */
        {   e_pos = pi;
            byte = get_byte(ii);      	/* call get_byte */
            pi = e_pos;
        }
        else if(isalpha(ch))          	/* a possible assignment */
        {   si = pi;                 	/* save pointer position */
            pi = while_isalnum(pi);
            pi = iswhite(pi);
            ch = p_string[pi];
            if(strchr("=#%!$@&(", ch))      /* a variable assignment */
            {   byte = 1;
                get_MOD(pi);         	/* scan for a MOD expression */
                pi = si;
            }
            else
            {   a_bort(ab_code, x);       /* not an assignment */
            }
        }
        else 
        {   a_bort(ab_code, x);    		/* not a keyword or variable */
        }
    }
    temp_byte[ii] = byte;
    e_pos = pi;
}
/*---------- end tmp_byte ----------*/

void get_MOD(int pi)
{   char ch, temp[VAR_NAME];
    int i, si=0, xi, len;

    len = strlen(p_string);
    pi++;
    pi = iswhite(pi);
    ch = p_string[pi];
    while( pi < (len - 2))
    {   if(ch == 'M')                        /* is this a MOD */
        {   si = pi;
            i = 0;
            while(isalnum(ch))
            {   temp[i] = ch;
                pi++;
                i++;
                ch = p_string[pi];
            }
            temp[i] = '\0';
            if(strcmp(temp, "MOD") == 0)   /* compare(temp,"MOD") */
            {   p_string[si] = '%';
                si++;
                xi = si;                    /* save si pointer */
                while(pi < len)             /* squeeze p_string */
                {   p_string[si] = p_string[pi];
                    pi++;
                    si++;
                }
                p_string[si] = '\0';
                pi = xi;                    /* restore pi */
            }
            pi++;
        }
        else
        {   pi++;
        }
        ch = p_string[pi];
    }
}
/*---------- end get_MOD ----------*/

int get_byte(int ii)
{   char ch, keyword[TOKEN_LEN];
    int pi, si=0, byte, x=ii, ab_code=4;

    pi = e_pos;
    ch = p_string[pi];
    while(isalnum(ch))
    {   keyword[si] = ch;
        si++;
        pi++;
        ch = p_string[pi];
    }
    keyword[si] = '\0';

/* --- assign byte code --- */
    if(strcmp(keyword, "REM") == 0)         byte=0;
    else if(strcmp(keyword, "LET") == 0){   byte=1;  
        get_MOD(pi);             /* scan for a MOD expression */
    }
    else if(strcmp(keyword, "CLEAR") == 0)  byte=2;
    else if(strcmp(keyword, "LOCATE") == 0) byte=3;
    else if(strcmp(keyword, "PRINT") == 0)  byte=4;
    else if(strcmp(keyword, "GOTO") == 0)   byte=5;
    else if(strcmp(keyword, "BEEP") == 0)   byte=6;
    else if(strcmp(keyword, "CLS") == 0)    byte=7;
    else if(strcmp(keyword, "END") == 0)    byte=8;
    else if(strcmp(keyword, "STOP") == 0)   byte=8;
    else if(strcmp(keyword, "SYSTEM") == 0) byte=8;
    else if(strcmp(keyword, "GOSUB") == 0)  byte=9;
    else if(strcmp(keyword, "RETURN") == 0) byte=10;
    else if(strcmp(keyword, "FOR") == 0)    byte=11;
    else if(strcmp(keyword, "NEXT") == 0)   byte=12;
    else if(strcmp(keyword, "IF") == 0)     byte=13;
    else if(strcmp(keyword, "ELSEIF") == 0) byte=14;
    else if(strcmp(keyword, "ELSE") == 0)   byte=15;
    else if(strcmp(keyword, "ENDIF") == 0)  byte=16;
    else if(strcmp(keyword, "INPUT") == 0)  byte=17;
    else if(strcmp(keyword, "LINE") == 0)   byte=18;
    else if(strcmp(keyword, "OPEN") == 0)   byte=19;
    else if(strcmp(keyword, "CLOSE") == 0)  byte=20;
    else if(strcmp(keyword, "WRITE") == 0)  byte=21;
    else if(strcmp(keyword, "FIELD") == 0)  byte=22;
    else if(strcmp(keyword, "LSET") == 0)   byte=23;
    else if(strcmp(keyword, "RSET") == 0)   byte=24;
    else if(strcmp(keyword, "PUT") == 0)    byte=25;
    else if(strcmp(keyword, "GET") == 0)    byte=26;
    else if(strcmp(keyword, "CHDIR") == 0)  byte=27;
    else if(strcmp(keyword, "MKDIR") == 0)  byte=28;
    else if(strcmp(keyword, "RMDIR") == 0)  byte=29;
    else if(strcmp(keyword, "KILL") == 0)   byte=30;
    else if(strcmp(keyword, "NAME") == 0)   byte=31;
    else if(strcmp(keyword, "RENAME") == 0) byte=31;
    else if(strcmp(keyword, "FILES") == 0)  byte=32;
    else if(strcmp(keyword, "SHELL") == 0)  byte=33;
    else if(strcmp(keyword, "RANDOM") == 0) byte=34;
    else if(strcmp(keyword, "READ") == 0)   byte=35;
    else if(strcmp(keyword, "CHDRIVE") == 0) byte=36;
    else if(strcmp(keyword, "WHILE") == 0)  byte=37;
    else if(strcmp(keyword, "WEND") == 0)   byte=38;
    else if(strcmp(keyword, "LOOP") == 0)   byte=39;
    else if(strcmp(keyword, "ENDLOOP") == 0) byte=40;
    else if(strcmp(keyword, "BREAK") == 0)  byte=41;
    else if(strcmp(keyword, "DO") == 0)     byte=42;
    else if(strcmp(keyword, "LPRINT") == 0) byte=43;
    else if(strcmp(keyword, "COLOR") == 0)  byte=44;
    else if(strcmp(keyword, "ASM") == 0)    byte=45;
    else if(strcmp(keyword, "DIM") == 0)    byte=46;
    else if(strcmp(keyword, "ERASE") == 0)  byte=47;
    else if(strcmp(keyword, "FREE") == 0)   byte=47;

  /*xxx*/
    else if(strcmp(keyword, "DUMP") == 0)   byte=99;
    else
    {   pi = iswhite(pi);
        ch = p_string[pi];
        if(strchr("=#%!$@&(", ch))         /* a variable assignment */
        {   byte = 1;
            get_MOD(pi);             /* scan for a MOD expression */
            pi = e_pos;              /* push pointer back */
        }
        else
        {   a_bort(ab_code, x); /* not a keyword or variable */
        }
    }
    e_pos = pi;
    return byte;
}
/*---------- end get_byte ----------*/

void tmp_prog(int ii)
{   char ch, prog[BUFSIZE];
    int pi, si=0, len;

    len = strlen(p_string);
    pi = e_pos;
    pi = iswhite(pi);

/* --- correct: LINE INPUT --- */
    if(temp_byte[ii] == 18)
    {   ch = p_string[pi];
        while(isupper(ch))
        {   pi++;		/* advance past INPUT */
            ch = p_string[pi];
        }
        pi = iswhite(pi);
        ch = p_string[pi];
        while(ch != '\0')
        {   prog[si] = ch;
            si++;
            pi++;
            ch = p_string[pi];
        }
        prog[si] = '\0';
    }
    else if((pi < len) && (temp_byte[ii] != 0))
    {   ch = p_string[pi];
        while(ch != '\0')
        {   prog[si] = ch;
            si++;
            pi++;
            ch = p_string[pi];
        }
        prog[si] = '\0';
    }
    else
    {   strcpy(prog, "\n\0");
    }
    strcpy(temp_prog[ii], prog);
}
/*---------- end tmp_prog ----------*/


void loader_2()
{   int ndx, ii, line_count=0, lines=nrows;
    unsigned size;

/* --- re-count number of lines --- */
    for(ndx=0; ndx < nrows; ndx++)
    {   if(temp_byte[ndx] != 0)
        {   line_count++;
        }
        if((temp_byte[ndx] == 13) || (temp_byte[ndx] == 14))
        {   token_if(ndx); 				/* IF-ELSEIF */
        }						/* tokenize expression */
        else if(temp_byte[ndx] == 1)		/* LET */
        {   str_functn(ndx);	  		/* tokenize string functions */
        }
        else if(temp_byte[ndx] == 4)		/* PRINT */
        {   str_funct2(ndx);	  		/* tokenize string functions */
        }
        else if(temp_byte[ndx] == 23)		/* LSET */
        {   str_functn(ndx);	  		/* tokenize string functions */
        }
        else if(temp_byte[ndx] == 24)		/* RSET */
        {   str_functn(ndx);	  		/* tokenize string functions */
        }
        else if(temp_byte[ndx] == 37)
        {   token_if(ndx);			/* tokenize WHILE expression */
        }
        else if(temp_byte[ndx] == 46)
        {   var_types(ndx);		/* tokenize DIM: variable types */
        }
    }
    nrows = line_count;
		/**/
/* --- create program arrays --- */
    array1 = (char**)malloc(nrows * sizeof(char *));
    label_nam = (char**)malloc(nrows * sizeof(char *));
    for(ii = 0; ii < nrows; ii++)
    {   label_nam[ii] = (char*)malloc(LLEN * sizeof(char));
    }
    byte_array = (int*)malloc(nrows * sizeof(int));
		/**/
/* --- transfer temp_arrays to program_arrays --- */
    ndx = 0;
    for(ii=0; ii < lines; ii++)
    {   if(temp_byte[ii] != 0)
        {   strcpy(label_nam[ndx], temp_label[ii]);
            byte_array[ndx] = temp_byte[ii];
        /**/
            size = strlen(temp_prog[ii]);
            size++;
            array1[ndx] = (char*)malloc(size * sizeof(char));
            strcpy(array1[ndx], temp_prog[ii]);
            ndx++;
        }
    }
		/**/
/* --- free temp array memory --- */
    for(ii=0; ii < lines; ii++)
    {   free(temp_label[ii]);
        free(temp_prog[ii]);
    }
    free(temp_label);
    free(temp_byte);
    free(temp_prog);
}
/*---------- end loader_2 ----------*/


void token_if(int ndx)
{   char temp[TOKEN_LEN];
    int loc;

    strcpy(p_string, temp_prog[ndx]);
    s_pos = 0;
    strcpy(temp, "AND");
    loc = 0;
    while(loc >= 0)
    {   loc = find_strng(temp);
        loc--;
        if(loc > 0)
        {   p_string[loc] = '&';          /* replace AND w/token */
            p_string[(loc+1)] = ' ';
            p_string[(loc+2)] = ' ';
        }
    }
    strcpy(temp, "OR");
    loc = 0;
    while(loc >= 0)
    {   loc = find_strng(temp);
        loc--;
        if(loc > 0)
        {   p_string[loc] = '|';          /* replace OR w/token */
            p_string[(loc+1)] = ' ';
        }
    }
    strcpy(temp, "NOT");
    loc = 0;
    while(loc >= 0)
    {   loc = find_strng(temp);
        loc--;
        if(loc > 0)
        {   p_string[loc] = '^';          /* replace NOT w/token */
            p_string[(loc+1)] = ' ';
            p_string[(loc+2)] = ' ';
        }
    }
    strcpy(temp, "THEN");
    loc = 0;
    while(loc >= 0)
    {   loc = find_strng(temp);
        loc--;
        if(loc > 0)
        {   p_string[loc] = '\n';          /* replace THEN w/EOL */
            p_string[(loc+1)] = '\0';
        }
    }
    strcpy(temp_prog[ndx], p_string);
}
/*---------- end token_if ----------*/


void str_functn(int ndx)               /* isolate math/string functions */
{   char ch, temp[VAR_NAME]; 	         /* tokenize string functions */
    int pi=0, len;

    strcpy(p_string, temp_prog[ndx]);
    while(IsEqu(pi) == 0)				/* advance to '=' sign */
    {   pi = e_pos;
        pi++;
    }
    pi = e_pos;		/* <-- leave this here!!!, IsEqu() changes e_pos */
    len = strlen(p_string);
  /* --- loop --- */
    while(pi < len)
    {   pi = get_upper(pi, len);			/* advance to uppercase */
        if(pi < len)
        {   e_pos = pi;
            strcpy(temp, get_varname());		/* get varname */
            s_pos = e_pos;
            ch = p_string[s_pos];
            if(ch == '$')				/* valid '$' symbol */
            {   e_pos = pi;
                get_strfunc(temp,ndx);		/* identify function */
            }
            else
            {   e_pos = pi;
                get_mathfunc(temp,ndx);	   /* identify math function */
            }
            pi = e_pos;
            pi++;
        }
    }
}
/*---------- end str_functn ----------*/


void str_funct2(int ndx)		    /* Print */
{   char ch, temp[VAR_NAME]; 	    /* tokenize string functions */
    int pi=0, len;

    strcpy(p_string, temp_prog[ndx]);
    len = strlen(p_string);
    ch = p_string[pi];
	/**/
  /* --- loop --- */
    while((pi < len) && (ch != '\n'))
    {   if(ch == '\"')
        {   pi = get_quote(pi, len);
            pi = iswhite(pi);
        }
        else if(isupper(ch))
        {   if(pi < len)
            {   e_pos = pi;
                strcpy(temp, get_varname());		/* get varname */
                s_pos = e_pos;
                ch = p_string[s_pos];
                if(ch == '$')				/* valid '$' symbol */
                {   e_pos = pi;
                    get_strfunc(temp,ndx);	/* identify function */
                }
                else
                {   e_pos = pi;
                    get_mathfunc(temp,ndx);   /* identify math function */
                }
                len = strlen(p_string);
                pi = e_pos;
                pi = get_paren(pi, len);
                pi++;
                pi = get_paren(pi, len);
                e_pos = pi;
            }
        }
        else
        {   pi = while_isalnum(pi);
        }
        ch = p_string[pi];
        len = strlen(p_string);
        if(strchr(":; ,)(", ch))		/* jump over punctuation */
        {   pi = get_rightExp(pi);		/* get to next alpha or string */
            ch = p_string[pi];
        }
        else if(strchr("$%!#@&", ch))	/* jump over var types */
        {   pi = get_rightExp(pi);		/* get to next alpha or string */
            ch = p_string[pi];
        }
        else if(strchr("+-*/^", ch))	/* jump over operators */
        {   pi = get_rightExp(pi);		/* get to next alpha or string */
            ch = p_string[pi];
        }
   /* printf("%sch=%c pi=%d len=%d\n", p_string, ch, pi, len); */
    }
}
/*---------- end str_funct2 ----------*/


void get_strfunc(char *name,int ndx)		/* identify function */
{   char varname[VAR_NAME], temp[TOKEN_LEN];

    strcpy(varname, name);
    temp[0] = '\0';

/* --- now compare to functions --- */
    if(strcmp(varname, "CHR") == 0)
    {   strcpy(temp, "   1");	    		/* is this a CHR$(n) assnmnt */
    }
    else if(strcmp(varname, "LEFT") == 0)
    {   strcpy(temp, "    2");	      /* a LEFT$(a$,n) assnmnt */
    }
    else if(strcmp(varname, "RIGHT") == 0)
    {   strcpy(temp, "     3");	      /* a RIGHT$(a$,n) assnmnt */
    }
    else if(strcmp(varname, "MID") == 0)
    {   strcpy(temp, "   4");	       	/* a MID$(a$,s,n) assnmnt */
    }
    else if(strcmp(varname, "SPACE") == 0)
    {   strcpy(temp, "     5");	      /* a SPACE$(n) assnmnt */
    }
    else if(strcmp(varname, "STR") == 0)
    {   strcpy(temp, "   6");	            /* a STR$(x) assnmnt */
    }
    else if(strcmp(varname, "STRING") == 0)
    {   strcpy(temp, "      7");          /* a STRING$(n,a) assnmnt */
    }
    else if(strcmp(varname, "INKEY") == 0)
    {   strcpy(temp, "     8");           /* an INKEY$ assnmnt */
    }
    else if(strcmp(varname, "INPUT") == 0)
    {   strcpy(temp, "     9");           /* an INPUT$(n) assnmnt */
    }
    else if(strcmp(varname, "MKD") == 0)
    {   strcpy(temp, "  10");             /* a MKD$(n) assnmnt */
    }
    else if(strcmp(varname, "MKI") == 0)
    {   strcpy(temp, "  11");             /* a MKI$(n) assnmnt */
    }
    else if(strcmp(varname, "MKS") == 0)
    {   strcpy(temp, "  12");             /* a MKS$(n) assnmnt */
    }
    else if(strcmp(varname, "DATE") == 0)
    {   strcpy(temp, "   13");             /* a DATE$ assnmnt */
    }
    else if(strcmp(varname, "TIME") == 0)
    {   strcpy(temp, "   14");             /* a TIME$ assnmnt */
    }

    str_copy(temp,ndx);			/* replace function name w/token */
}
/*---------- end get_strfunc ----------*/


void get_mathfunc(char *name,int ndx)	   /* identify math function */
{   char varname[VAR_NAME], temp[TOKEN_LEN];

    strcpy(varname, name);
    temp[0] = '\0';

  /* --- now compare to functions --- */
    if(strcmp(varname, "ABS") == 0)
    {   strcpy(temp, " ?1");				/* a abs(n) assnmnt */
    }
    else if(strcmp(varname, "ASC") == 0)
    {   strcpy(temp, " ?2");				/* a asc(a$) assnmnt */
    }
    else if(strcmp(varname, "ATN") == 0)
    {   strcpy(temp, " ?3");				/* a atn(n) assnmnt */
    }
    else if(strcmp(varname, "COS") == 0)
    {   strcpy(temp, " ?4");				/* a cos(n) assnmnt */
    }
    else if(strcmp(varname, "SIN") == 0)
    {   strcpy(temp, " ?5");				/* a sin(n) assnmnt */
    }
    else if(strcmp(varname, "TAN") == 0)
    {   strcpy(temp, " ?6");				/* a tan(n) assnmnt */
    }
    else if(strcmp(varname, "SQRT") == 0)
    {   strcpy(temp, "  ?7");				/* a sqrt(n) assnmnt */
    }
    else if(strcmp(varname, "INT") == 0)
    {   strcpy(temp, " ?8");				/* a int(n) assnmnt */
    }
    else if(strcmp(varname, "LEN") == 0)
    {   strcpy(temp, " ?9");		         	/* a len($) assnmnt */
    }
    else if(strcmp(varname, "LOF") == 0)
    {   strcpy(temp, "?10");		         	/* a lof(n) assnmnt */
    }
    else if(strcmp(varname, "LOC") == 0)
    {   strcpy(temp, "?11");		         	/* a loc(n) assnmnt */
    }
    else if(strcmp(varname, "CVD") == 0)
    {   strcpy(temp, "?12");		         	/* a cvd($) assnmnt */
    }
    else if(strcmp(varname, "CVI") == 0)
    {   strcpy(temp, "?13");		         	/* a cvi($) assnmnt */
    }
    else if(strcmp(varname, "CVS") == 0)
    {   strcpy(temp, "?14");		         	/* a cvs($) assnmnt */
    }
    else if(strcmp(varname, "ATN2") == 0)
    {   strcpy(temp, " ?15");		         	/* a atn2(n,n) assnmnt */
    }
    else if(strcmp(varname, "COSH") == 0)
    {   strcpy(temp, " ?16");		         	/* a cosh(n) assnmnt */
    }
    else if(strcmp(varname, "SINH") == 0)
    {   strcpy(temp, " ?17");		         	/* a sinh(n) assnmnt */
    }
    else if(strcmp(varname, "TANH") == 0)
    {   strcpy(temp, " ?18");		         	/* a tanh(n) assnmnt */
    }
    else if(strcmp(varname, "ACOS") == 0)
    {   strcpy(temp, " ?19");		         	/* a acos(n) assnmnt */
    }
    else if(strcmp(varname, "ASIN") == 0)
    {   strcpy(temp, " ?20");		         	/* a asin(n) assnmnt */
    }
    else if(strcmp(varname, "CEIL") == 0)
    {   strcpy(temp, " ?21");		         	/* a ceil(n) assnmnt */
    }
    else if(strcmp(varname, "FLOOR") == 0)
    {   strcpy(temp, "  ?22");			/* a floor(n) assnmnt */
    }
    else if(strcmp(varname, "HYPOT") == 0)
    {   strcpy(temp, "  ?23");			/* a hypot(n,n) assnmnt */
    }
    else if(strcmp(varname, "LOG") == 0)
    {   strcpy(temp, "?24");				/* a log(n) assnmnt */
    }
    else if(strcmp(varname, "LOG10") == 0)
    {   strcpy(temp, "  ?25");			/* a log10(n) assnmnt */
    }
    else if(strcmp(varname, "RAND") == 0)
    {   strcpy(temp, " ?26");				/* a rand() assnmnt */
    }
    else if(strcmp(varname, "CLOCK") == 0)
    {   strcpy(temp, "  ?27");			/* a clock() assnmnt */
    }
    else if(strcmp(varname, "VAL") == 0)
    {   strcpy(temp, "?28");				/* a val($) assnmnt */
    }
    else if(strcmp(varname, "EOF") == 0)
    {   strcpy(temp, "?29");				/* a eof() assnmnt */
    }

    str_copy(temp, ndx);		/* replace function name w/token */
}
/*---------- end get_mathfunc ----------*/


void str_copy(char *temp,int ndx)
{   char ch, tok[TOKEN_LEN];		/* replace function name w/token */
    int pi, si=0;

    strcpy(tok, temp);
    pi = e_pos;
    ch = tok[si];
    if(ch != '\0')
    {   while(ch != '\0')
        {   p_string[pi] = ch;
            si++;
            pi++;
            ch = tok[si];
        }
        strcpy(temp_prog[ndx], p_string);
        e_pos = pi;
    }
    else
    {   e_pos = s_pos;				/* not a function */
    }
 /* printf("%s", p_string); */
}
/*---------- end str_copy ----------*/


int IsEqu(int pi)
{   char ch;					/* is equal sign */
    int _bool=0;

    pi = iswhite(pi);
    e_pos = pi;
    ch = p_string[pi];
    if(ch == '=')
    {   _bool = 1;
    }
    return _bool;
}
/*---------- end IsEqu ----------*/


void var_types(int ndx)				/* tokenize variable types */
{   char ch, token[VAR_NAME], temp[VAR_NAME], charx[3];
    int pi, len;
    
    strcpy(p_string, temp_prog[ndx]);
/* printf("vartypes::%s", p_string); */

    len = strlen(p_string);
    pi = 0;
    ch = p_string[pi];
    e_pos = pi;
    while((pi < len) && (ch != '\n'))
    {   strcpy(charx, " ");			/* clear symbol */
        pi = get_alpha(pi, len);		/* get token */

/*    ch = p_string[pi];
/*    printf("ch=%c pi=%d\n", ch, pi); */

        e_pos = pi;
        strcpy(token, get_varname());
        e_pos = pi;
        temp[0] = '\0';
		/**/
    /* --- now compare to tokens --- */
        if(strcmp(token, "AS") == 0)
        {   strcpy(temp, "  ");
        }
        else if(strcmp(token, "STRING") == 0)
        {   strcpy(temp, "     $");
        }
        else if(strcmp(token, "INTEGER") == 0)
        {   strcpy(temp, "      %");
        }
        else if(strcmp(token, "LONG") == 0)
        {   strcpy(temp, "   &");
        }
        else if(strcmp(token, "SINGLE") == 0)
        {   strcpy(temp, "     !");
        }
        else if(strcmp(token, "DOUBLE") == 0)
        {   strcpy(temp, "     #");
        }
        else
        {   pi = get_NextOp(pi);
        }
        if(temp[0] != '\0')
        {   str_copy(temp, ndx);
            pi = e_pos;
        }
        ch = p_string[pi];

/* printf("%s", p_string); */
    }
}
/*---------- end var_types ----------*/

$CCODE