// *********************************************************************
//   Created with Ubx 311.40 (2011/10/19)by James C. Fuller
//   Based on OSX port by Armando Rivera
//   Ported from BCX32 BASIC To C/C++ Translator (V) 5.12
//   BCX (c) 1999 - 2009 by Kevin Diggins
// *********************************************************************
//   Translated for compiling with the g++ Compiler
#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <commdlg.h>
#include <mmsystem.h>
#include <shellapi.h>
#include <shlobj.h>
#include <richedit.h>
#include <wchar.h>
#include <objbase.h>
#include <ocidl.h>
#include <winuser.h>
#include <olectl.h>
#include <oaidl.h>
#include <ole2.h>
#include <oleauto.h>
#include <conio.h>
#include <direct.h>
#include <ctype.h>
#include <io.h>
#include <math.h>
#include <stdio.h>
#include <string.h>
#include <stddef.h>
#include <stdlib.h>
#include <setjmp.h>
#include <time.h>
#include <stdarg.h>
#include <process.h>
#include <stdbool.h>
#include <iostream>
#include <fstream>


// ***************************************************
// Compiler Defines
// ***************************************************
  #define C_EXPORT extern "C"
  #define C_IMPORT extern "C"

#ifndef stat
  #define lstat stat
#endif
#ifndef _fcloseall
  #define _fcloseall _fcloseall
#endif
#ifndef MAX_PATH
  #define MAX_PATH 2048
#endif
#ifndef CALLBACK
  #define CALLBACK
#endif
#define println(a)  (std::cout << a << std::endl)
#define printl(a)  (std::cout << a)
#define fsout std::fstream::out
#define fsin std::fstream::in
#define fsapp std::fstream::out OR std::fstream::in OR std::fstream::app
#define stdstr std::string
#define stdfst  std::fstream
  typedef std::string CSTRING;
  typedef std::fstream CFILE;
// ***************************************************

/* --- declare constants --- */
#define BUFSIZE     256
#define TOKEN_LEN   21
#define VAR_NAME    33
#define LLEN        33
#define IOARRAY     99
#define PATH        129
#define REC_LEN     128



/* ------ global vars ------------ */
FILE *f_in, *f_out;      /* these are the i/o file handles    */
FILE *s_datatemp;        /* these are temp i/o file handles   */
FILE *i_datatemp;        /* these are temp i/o file handles   */
FILE *f_datatemp;        /* these are temp i/o file handles   */
FILE *x_datatemp;        /* these are temp i/o file handles   */
char *prog_name;         /* program source-file name          */
char p_string[BUFSIZE];  /* file input string                 */
char **array1;           /* program array                     */
char t_holder[20];       /* token data holder                 */
char s_holder[BUFSIZE];  /* xstring (print) data holder       */
int nrows;              /* numbers of lines in source file   */
int ncolumns=BUFSIZE;   /* dimension for array1[][columns]   */
int line_ndx;           /* current execution line            */
int s_pos, e_pos;       /* pointers to start & end of token  */
char xstring[BUFSIZE];   /* the print string                  */
char **temp_prog;        /* temp program array                */
char **temp_label;       /* temp label name array             */
int *temp_byte;         /* temp byte code array              */
int *byte_array;        /* byte code array                   */
char **label_nam;        /* labels name array                 */
int token;              /* token: current byte code          */
int var_type;           /* current variable type             */
int var_count=0;        /* variables counter                 */
char **VarIndx;          /* unique variables name index       */
int VarNdxCnt=0;        /* unique variables count            */
int UnqLblNdx=0;        /* unique labels count               */
char **ForArray;         /* FOR: nested FOR labels            */
int forLabelCtr=0;      /* FOR: nested label counter         */
char indent[BUFSIZE] = {0,0}; /* IF: indentation string       */
int indcnt=0;           /* IF: indentations for nested code  */
int opcntr=0;           /* IF: number of nested ANDs/ORs     */
char **label_endif;      /* IF: array, nested labels          */
int endifCtr=-1;        /* IF: nested ENDIF counter          */
char **label_block;      /* IF: array, nested blocks          */
char label_Or[LLEN];     /* IF: label, OR                     */
int Or_pi=0;            /* IF:                               */
char **label_elseif;     /* ELSEIF: array, nested ELSEIF's    */
char **label_else;       /* ELSE: array, nested ELSE's        */
char **WhileArray;       /* WHILE: nested While labels        */
int whileLblCtr=0;      /* WHILE: nested label counter       */
char wlabel_block[LLEN]; /* WHILE: block label                */
char **LoopArray;        /* LOOP: nested LOOP labels          */
int loopLblCtr=0;       /* LOOP: nested label counter        */
char **BreakArray;       /* BREAK: nested LOOP labels         */
int breakCtr=0;         /* BREAK: nested BREAK counter       */
int dowhileflag=0;      /* FLAG: DO-WHILE                    */
char **ObjIndx;          /* object/variables name index       */
int **ObjType;          /* object/variables type specifier   */
int ObjNdxCnt=0;        /* object/variables index count      */


/*------ dynamic arrays ------*/
char **ArryNdx;          /* Array: name array                 */
int *ArryParams;        /* Array: parameters count array     */
int ArryNdxCnt=0;       /* Array: counter                    */
/*------ all arrays are dynamic ------*/

/*------ File I/O structures ---------*/
struct field_buffer        /* File: Field Buffer structure      */
{   char *f_bffr;            /* I/O buffer */
unsigned bfr_size;           /* buffer length */
int *str_len;           /* string length */
char **str_name;         /* string name */
int fld_count;          /* number of strings */
long record;             /* current record number */
int flag;               /* PUT flag, to clear buffer */
};                      /* File: handles structure           */

struct field_buffer fld_bffr[IOARRAY];
int lset_ndx;           /* File: global Lset/Rset var_index  */

struct lset_rset
{    int ndx;
int cnt;
} lrs;
/*------ end File I/O structures ---------*/
/*--- FLAGS ---*/
int stringcopy=0;       /* Flag: string copy: function       */
int asnchrstr=0;        /* Flag: CHR$ function               */
int asnleftstr=0;       /* Flag: LEFT$ function              */
int asnrightstr=0;      /* Flag: RIGHT$ function             */
int asnmidstr=0;        /* Flag: MID$ function               */
int asnspacestr=0;      /* Flag: SPACE$ function             */
int asnstrsIval=0;      /* Flag: STR$(integer) function      */
int asnstrsFval=0;      /* Flag: STR$(double) function       */
int asnstringstr=0;     /* Flag: STRING$ function            */
int asninkeystr=0;      /* Flag: INKEY$  function            */
int asninputstr=0;      /* Flag: INPUT$  function            */
int asnmkdstr=0;        /* Flag: MKD$    function            */
int asnmkistr=0;        /* Flag: MKI$    function            */
int asnmkqstr=0;        /* Flag: MKI$ (quad) function        */
int resetcursor=0;      /* Flag: INPUT   function            */
int getsysdate=0;       /* Flag: DATE    function            */
int getsystime=0;       /* Flag: TIME    function            */
int asndatestr=0;       /* Flag: DATE$   function            */
int asntimestr=0;       /* Flag: DATE$   function            */
int filecloseall=0;     /* Flag: close all files function    */
int closeafile=0;       /* Flag: close a file function       */
int getfilehandle=0;    /* Flag: get file handle function    */
int clearstrngbffr=0;   /* Flag: clear I/O string function   */
int setupiobuffer=0;    /* Flag: file I/O buffer function    */
int asnlsetstr=0;       /* Flag: file LSET string function   */
int asnrsetstr=0;       /* Flag: file RSET string function   */
int clearallvars=0;     /* Flag: CLEAR variables function    */
int clearstrvar=0;      /* Flag: CLEAR string    function    */
int clearintvar=0;      /* Flag: CLEAR integer   function    */
int clearfltvar=0;      /* Flag: CLEAR float     function    */
int clearLngstrngbffr=0; /* Flag: clear i/o string function  */
int movstrngbffr=0;     /* Flag: move input string function  */
int readintstr=0;       /* Flag: move input integer function */
int readfltstr=0;       /* Flag: move input float function   */
int readQintstr=0;      /* Flag: move input integer function */
int getfilelength=0;    /* Flag: LOF function                */
int setcolortext=0;     /* Flag: COLOR function              */
int dimstrarray=0;      /* Flag: DIM type:string function    */
int getArryOffst=0;     /* Flag: array offset function       */
int dblArryElement=0;   /* Flag: array integer element       */
int quadArryElement=0;  /* Flag: array float element         */
int freeArray=0;        /* Flag: array erase function        */
/*--- FLAGS ---*/

/* ----- function prototypes ----- */
void pgm_parser(void);
void get_token(void);
void parser(void);
void num_label(void);
void dump(void);
#include "Prototyp.h"


// *************************************************
//                System Variables
// *************************************************


// *************************************************
//            User Global Variables
// *************************************************

static PCHAR   *G_argv;
static int     G_argc;



// *************************************************
//               Standard Macros
// *************************************************



// *************************************************
//               Standard Prototypes
// *************************************************




// *************************************************
//            User Global Initialized Arrays
// *************************************************


 using namespace std;
/*---functionincludes---*/;

void line_cnt(char *argv[])
{   int pi, len, ii=0, x=0, ab_code=2;
    unsigned fnam_len;

    nrows = 0;
  /* --- get length of command line argument --- */
    fnam_len = strlen(argv[1]);
    len = fnam_len;
    fnam_len += 5;                         /* add padding */
    prog_name = (char*)malloc(fnam_len * sizeof(char));
    strcpy(prog_name, argv[1]);

  /* --- does source filename end in: .bas --- */
    pi = (len-4);
    for(; pi < len; pi++)
    {   p_string[ii] = prog_name[pi];
        ii++;
    }
    if(strcmp(p_string, ".bas") != 0)           /* if not, add it */
    {   strcat(prog_name, ".bas");
    }
    p_string[0] = '\0';
    strcpy(s_holder, prog_name);

  /* --- open filename.bas for Read --- */
    f_in = fopen(prog_name,"r");
    if(f_in == NULL)                  /* error:file not found */
    {   a_bort(ab_code, x);
    }
    else
    {   load_src();                /* read source-file, write temp-file */
        loader_1();                /* read temp-file, load temp arrays */
        loader_2();                /* load program arrays */
        free(prog_name);
        x = remove("source.tmp");    /* if test is '0', successful */
    }
}
/*------- end line_cnt ----------*/

void load_src()
{   char *tmp="source.tmp";
    int pi, len;

    f_out = fopen(tmp,"w");                     /* open output file */
    while(!feof(f_in))
    {   fgets(p_string, BUFSIZE, f_in);
        pi = 0;
        pi = iswhite(pi);
        len = strlen(p_string);
        if((len > 2) && (pi < len))        /* skip over blank lines */
        {   if(!feof(f_in))
            {   save_tmp();                /* write data to file */
            }
        }
    }
    fclose(f_in);
    fclose(f_out);
}
/*------- end load_src ----------*/

void save_tmp()
{   char ch;
    int pi, len;

  /* --- setup xstring to write indented line --- */
    strcpy(xstring, "  ");
    strcat(xstring, p_string);
    pi = 0;
    ch = p_string[pi];

  /* --- test for a Label: --- */
    if(isupper(ch) != 0)
    {   len = (LLEN-2);
        pi = while_isalnum(pi);             /* loop thru "Label:" */
        ch = p_string[pi];
        if((ch == ':') && (pi <= len))
        {   pi++;
            p_string[pi] = '\0';
            strcat(p_string, "\n\0");
            fprintf(f_out,"%s", p_string);      /* write block label */
            nrows++;
        }
        else
        {   fprintf(f_out,"%s", xstring);     /* write indented line */
            nrows++;
        }
    }

  /* --- test for numbered line --- */
    else if(isdigit(ch))
    {   fprintf(f_out,"%s", p_string);         /* write numbered line */
        nrows++;
    }
    else
    {   pi = iswhite(pi);
        ch = p_string[pi];
        if(ch != '\'')                   /* eliminate comment lines */
        {   fprintf(f_out,"%s", xstring);  /* write indented line */
            nrows++;
        }
    }
}
/*------- end save_tmp ----------*/

void loader_1()
{   char ch, ln_holder[LLEN], *tmp="source.tmp";
    int ii, len, pi;
    unsigned size=ncolumns;

/* --- create temp arrays --- */
    temp_prog = (char**)malloc(nrows * sizeof(char *));
    for(ii = 0; ii < nrows; ii++)
    {   temp_prog[ii] = (char*)malloc(size * sizeof(char));
    }
    temp_label = (char**)malloc(nrows * sizeof(char *));
    for(ii = 0; ii < nrows; ii++)
    {   temp_label[ii] = (char*)malloc(LLEN * sizeof(char));
    }
    temp_byte = (int*)malloc(nrows * sizeof(int));
  /**/
/* --- open source.tmp for Read --- */
    f_in = fopen(tmp,"r");
    ii = 0;
    while(!feof(f_in))              /* p_string holds incoming-data */
    {   fgets(p_string, BUFSIZE, f_in);
        if(!feof(f_in))
        {   len = strlen(p_string);
   /**/
           /* ----- fill temp_label[] here ----- */
            tmp_label(ii);                 /* call label filter */
            pi = e_pos;
            ch = p_string[pi];
            if(ch == ':')                       /* found a label */
            {   temp_byte[ii] = -1;
                strcpy(temp_prog[ii], "\n\0");
            }
   /**/
           /* ----- fill temp_byte[] here ----- */
            else
            {   tmp_byte(ii);              /* call byte filter */
                tmp_prog(ii);
            }
        }
        ii++;
    }
    fclose(f_in);
}
/*---------- end loader_1 ----------*/

void tmp_label(int ii)
{   char ch, ln_label[LLEN];
    int pi;

  /* --- fill temp_label[] here --- */
    pi = 0;
    ch = p_string[pi];
    if(isalnum(ch))
    {   while(isalnum(ch))
        {   ln_label[pi] = ch;
            pi++;
            ch = p_string[pi];
        }
        ln_label[pi] = '\0';
        strcpy(temp_label[ii], ln_label);
    }
    else
    {   strcpy(temp_label[ii], " \0");
    }
    e_pos = pi;
}
/*---------- end tmp_label ----------*/

void tmp_byte(int ii)
{   char ch;
    int pi, si, byte, x=ii, ab_code=4;

  /* ----- fill temp_byte[] here ----- */
    pi = e_pos;
    pi = iswhite(pi);
    ch = p_string[pi];
    if(ch == '\'')                   /* it's a comment */
    {   byte = 0;
        strcpy(temp_prog[ii], "\n\0");
    }
    else
    {   if(isupper(ch))               /* is this a keyword */
        {   e_pos = pi;
            byte = get_byte(ii);       /* call get_byte */
            pi = e_pos;
        }
        else if(isalpha(ch))           /* a possible assignment */
        {   si = pi;                  /* save pointer position */
            pi = while_isalnum(pi);
            pi = iswhite(pi);
            ch = p_string[pi];
            if(strchr("=#%!$@&(", ch))      /* a variable assignment */
            {   byte = 1;
                get_MOD(pi);          /* scan for a MOD expression */
                pi = si;
            }
            else
            {   a_bort(ab_code, x);       /* not an assignment */
            }
        }
        else
        {   a_bort(ab_code, x);      /* not a keyword or variable */
        }
    }
    temp_byte[ii] = byte;
    e_pos = pi;
}
/*---------- end tmp_byte ----------*/

void get_MOD(int pi)
{   char ch, temp[VAR_NAME];
    int i, si=0, xi, len;

    len = strlen(p_string);
    pi++;
    pi = iswhite(pi);
    ch = p_string[pi];
    while( pi < (len - 2))
    {   if(ch == 'M')                        /* is this a MOD */
        {   si = pi;
            i = 0;
            while(isalnum(ch))
            {   temp[i] = ch;
                pi++;
                i++;
                ch = p_string[pi];
            }
            temp[i] = '\0';
            if(strcmp(temp, "MOD") == 0)   /* compare(temp,"MOD") */
            {   p_string[si] = '%';
                si++;
                xi = si;                    /* save si pointer */
                while(pi < len)             /* squeeze p_string */
                {   p_string[si] = p_string[pi];
                    pi++;
                    si++;
                }
                p_string[si] = '\0';
                pi = xi;                    /* restore pi */
            }
            pi++;
        }
        else
        {   pi++;
        }
        ch = p_string[pi];
    }
}
/*---------- end get_MOD ----------*/

int get_byte(int ii)
{   char ch, keyword[TOKEN_LEN];
    int pi, si=0, byte, x=ii, ab_code=4;

    pi = e_pos;
    ch = p_string[pi];
    while(isalnum(ch))
    {   keyword[si] = ch;
        si++;
        pi++;
        ch = p_string[pi];
    }
    keyword[si] = '\0';

/* --- assign byte code --- */
    if(strcmp(keyword, "REM") == 0)         byte=0;
    else if(strcmp(keyword, "LET") == 0){   byte=1;
        get_MOD(pi);             /* scan for a MOD expression */
    }
    else if(strcmp(keyword, "CLEAR") == 0)  byte=2;
    else if(strcmp(keyword, "LOCATE") == 0) byte=3;
    else if(strcmp(keyword, "PRINT") == 0)  byte=4;
    else if(strcmp(keyword, "GOTO") == 0)   byte=5;
    else if(strcmp(keyword, "BEEP") == 0)   byte=6;
    else if(strcmp(keyword, "CLS") == 0)    byte=7;
    else if(strcmp(keyword, "END") == 0)    byte=8;
    else if(strcmp(keyword, "STOP") == 0)   byte=8;
    else if(strcmp(keyword, "SYSTEM") == 0) byte=8;
    else if(strcmp(keyword, "GOSUB") == 0)  byte=9;
    else if(strcmp(keyword, "RETURN") == 0) byte=10;
    else if(strcmp(keyword, "FOR") == 0)    byte=11;
    else if(strcmp(keyword, "NEXT") == 0)   byte=12;
    else if(strcmp(keyword, "IF") == 0)     byte=13;
    else if(strcmp(keyword, "ELSEIF") == 0) byte=14;
    else if(strcmp(keyword, "ELSE") == 0)   byte=15;
    else if(strcmp(keyword, "ENDIF") == 0)  byte=16;
    else if(strcmp(keyword, "INPUT") == 0)  byte=17;
    else if(strcmp(keyword, "LINE") == 0)   byte=18;
    else if(strcmp(keyword, "OPEN") == 0)   byte=19;
    else if(strcmp(keyword, "CLOSE") == 0)  byte=20;
    else if(strcmp(keyword, "WRITE") == 0)  byte=21;
    else if(strcmp(keyword, "FIELD") == 0)  byte=22;
    else if(strcmp(keyword, "LSET") == 0)   byte=23;
    else if(strcmp(keyword, "RSET") == 0)   byte=24;
    else if(strcmp(keyword, "PUT") == 0)    byte=25;
    else if(strcmp(keyword, "GET") == 0)    byte=26;
    else if(strcmp(keyword, "CHDIR") == 0)  byte=27;
    else if(strcmp(keyword, "MKDIR") == 0)  byte=28;
    else if(strcmp(keyword, "RMDIR") == 0)  byte=29;
    else if(strcmp(keyword, "KILL") == 0)   byte=30;
    else if(strcmp(keyword, "NAME") == 0)   byte=31;
    else if(strcmp(keyword, "RENAME") == 0) byte=31;
    else if(strcmp(keyword, "FILES") == 0)  byte=32;
    else if(strcmp(keyword, "SHELL") == 0)  byte=33;
    else if(strcmp(keyword, "RANDOM") == 0) byte=34;
    else if(strcmp(keyword, "READ") == 0)   byte=35;
    else if(strcmp(keyword, "CHDRIVE") == 0) byte=36;
    else if(strcmp(keyword, "WHILE") == 0)  byte=37;
    else if(strcmp(keyword, "WEND") == 0)   byte=38;
    else if(strcmp(keyword, "LOOP") == 0)   byte=39;
    else if(strcmp(keyword, "ENDLOOP") == 0) byte=40;
    else if(strcmp(keyword, "BREAK") == 0)  byte=41;
    else if(strcmp(keyword, "DO") == 0)     byte=42;
    else if(strcmp(keyword, "LPRINT") == 0) byte=43;
    else if(strcmp(keyword, "COLOR") == 0)  byte=44;
    else if(strcmp(keyword, "ASM") == 0)    byte=45;
    else if(strcmp(keyword, "DIM") == 0)    byte=46;
    else if(strcmp(keyword, "ERASE") == 0)  byte=47;
    else if(strcmp(keyword, "FREE") == 0)   byte=47;

  /*xxx*/
    else if(strcmp(keyword, "DUMP") == 0)   byte=99;
    else
    {   pi = iswhite(pi);
        ch = p_string[pi];
        if(strchr("=#%!$@&(", ch))         /* a variable assignment */
        {   byte = 1;
            get_MOD(pi);             /* scan for a MOD expression */
            pi = e_pos;              /* push pointer back */
        }
        else
        {   a_bort(ab_code, x); /* not a keyword or variable */
        }
    }
    e_pos = pi;
    return byte;
}
/*---------- end get_byte ----------*/

void tmp_prog(int ii)
{   char ch, prog[BUFSIZE];
    int pi, si=0, len;

    len = strlen(p_string);
    pi = e_pos;
    pi = iswhite(pi);

/* --- correct: LINE INPUT --- */
    if(temp_byte[ii] == 18)
    {   ch = p_string[pi];
        while(isupper(ch))
        {   pi++;  /* advance past INPUT */
            ch = p_string[pi];
        }
        pi = iswhite(pi);
        ch = p_string[pi];
        while(ch != '\0')
        {   prog[si] = ch;
            si++;
            pi++;
            ch = p_string[pi];
        }
        prog[si] = '\0';
    }
    else if((pi < len) && (temp_byte[ii] != 0))
    {   ch = p_string[pi];
        while(ch != '\0')
        {   prog[si] = ch;
            si++;
            pi++;
            ch = p_string[pi];
        }
        prog[si] = '\0';
    }
    else
    {   strcpy(prog, "\n\0");
    }
    strcpy(temp_prog[ii], prog);
}
/*---------- end tmp_prog ----------*/


void loader_2()
{   int ndx, ii, line_count=0, lines=nrows;
    unsigned size;

/* --- re-count number of lines --- */
    for(ndx=0; ndx < nrows; ndx++)
    {   if(temp_byte[ndx] != 0)
        {   line_count++;
        }
        if((temp_byte[ndx] == 13) || (temp_byte[ndx] == 14))
        {   token_if(ndx);     /* IF-ELSEIF */
        }      /* tokenize expression */
        else if(temp_byte[ndx] == 1)  /* LET */
        {   str_functn(ndx);     /* tokenize string functions */
        }
        else if(temp_byte[ndx] == 4)  /* PRINT */
        {   str_funct2(ndx);     /* tokenize string functions */
        }
        else if(temp_byte[ndx] == 23)  /* LSET */
        {   str_functn(ndx);     /* tokenize string functions */
        }
        else if(temp_byte[ndx] == 24)  /* RSET */
        {   str_functn(ndx);     /* tokenize string functions */
        }
        else if(temp_byte[ndx] == 37)
        {   token_if(ndx);   /* tokenize WHILE expression */
        }
        else if(temp_byte[ndx] == 46)
        {   var_types(ndx);  /* tokenize DIM: variable types */
        }
    }
    nrows = line_count;
  /**/
/* --- create program arrays --- */
    array1 = (char**)malloc(nrows * sizeof(char *));
    label_nam = (char**)malloc(nrows * sizeof(char *));
    for(ii = 0; ii < nrows; ii++)
    {   label_nam[ii] = (char*)malloc(LLEN * sizeof(char));
    }
    byte_array = (int*)malloc(nrows * sizeof(int));
  /**/
/* --- transfer temp_arrays to program_arrays --- */
    ndx = 0;
    for(ii=0; ii < lines; ii++)
    {   if(temp_byte[ii] != 0)
        {   strcpy(label_nam[ndx], temp_label[ii]);
            byte_array[ndx] = temp_byte[ii];
        /**/
            size = strlen(temp_prog[ii]);
            size++;
            array1[ndx] = (char*)malloc(size * sizeof(char));
            strcpy(array1[ndx], temp_prog[ii]);
            ndx++;
        }
    }
  /**/
/* --- free temp array memory --- */
    for(ii=0; ii < lines; ii++)
    {   free(temp_label[ii]);
        free(temp_prog[ii]);
    }
    free(temp_label);
    free(temp_byte);
    free(temp_prog);
}
/*---------- end loader_2 ----------*/


void token_if(int ndx)
{   char temp[TOKEN_LEN];
    int loc;

    strcpy(p_string, temp_prog[ndx]);
    s_pos = 0;
    strcpy(temp, "AND");
    loc = 0;
    while(loc >= 0)
    {   loc = find_strng(temp);
        loc--;
        if(loc > 0)
        {   p_string[loc] = '&';          /* replace AND w/token */
            p_string[(loc+1)] = ' ';
            p_string[(loc+2)] = ' ';
        }
    }
    strcpy(temp, "OR");
    loc = 0;
    while(loc >= 0)
    {   loc = find_strng(temp);
        loc--;
        if(loc > 0)
        {   p_string[loc] = '|';          /* replace OR w/token */
            p_string[(loc+1)] = ' ';
        }
    }
    strcpy(temp, "NOT");
    loc = 0;
    while(loc >= 0)
    {   loc = find_strng(temp);
        loc--;
        if(loc > 0)
        {   p_string[loc] = '^';          /* replace NOT w/token */
            p_string[(loc+1)] = ' ';
            p_string[(loc+2)] = ' ';
        }
    }
    strcpy(temp, "THEN");
    loc = 0;
    while(loc >= 0)
    {   loc = find_strng(temp);
        loc--;
        if(loc > 0)
        {   p_string[loc] = '\n';          /* replace THEN w/EOL */
            p_string[(loc+1)] = '\0';
        }
    }
    strcpy(temp_prog[ndx], p_string);
}
/*---------- end token_if ----------*/


void str_functn(int ndx)               /* isolate math/string functions */
{   char ch, temp[VAR_NAME];           /* tokenize string functions */
    int pi=0, len;

    strcpy(p_string, temp_prog[ndx]);
    while(IsEqu(pi) == 0)    /* advance to '=' sign */
    {   pi = e_pos;
        pi++;
    }
    pi = e_pos;  /* <-- leave this here!!!, IsEqu() changes e_pos */
    len = strlen(p_string);
  /* --- loop --- */
    while(pi < len)
    {   pi = get_upper(pi, len);   /* advance to uppercase */
        if(pi < len)
        {   e_pos = pi;
            strcpy(temp, get_varname());  /* get varname */
            s_pos = e_pos;
            ch = p_string[s_pos];
            if(ch == '$')    /* valid '$' symbol */
            {   e_pos = pi;
                get_strfunc(temp,ndx);  /* identify function */
            }
            else
            {   e_pos = pi;
                get_mathfunc(temp,ndx);    /* identify math function */
            }
            pi = e_pos;
            pi++;
        }
    }
}
/*---------- end str_functn ----------*/


void str_funct2(int ndx)      /* Print */
{   char ch, temp[VAR_NAME];      /* tokenize string functions */
    int pi=0, len;

    strcpy(p_string, temp_prog[ndx]);
    len = strlen(p_string);
    ch = p_string[pi];
 /**/
  /* --- loop --- */
    while((pi < len) && (ch != '\n'))
    {   if(ch == '\"')
        {   pi = get_quote(pi, len);
            pi = iswhite(pi);
        }
        else if(isupper(ch))
        {   if(pi < len)
            {   e_pos = pi;
                strcpy(temp, get_varname());  /* get varname */
                s_pos = e_pos;
                ch = p_string[s_pos];
                if(ch == '$')    /* valid '$' symbol */
                {   e_pos = pi;
                    get_strfunc(temp,ndx); /* identify function */
                }
                else
                {   e_pos = pi;
                    get_mathfunc(temp,ndx);   /* identify math function */
                }
                len = strlen(p_string);
                pi = e_pos;
                pi = get_paren(pi, len);
                pi++;
                pi = get_paren(pi, len);
                e_pos = pi;
            }
        }
        else
        {   pi = while_isalnum(pi);
        }
        ch = p_string[pi];
        len = strlen(p_string);
        if(strchr(":; ,)(", ch))  /* jump over punctuation */
        {   pi = get_rightExp(pi);  /* get to next alpha or string */
            ch = p_string[pi];
        }
        else if(strchr("$%!#@&", ch)) /* jump over var types */
        {   pi = get_rightExp(pi);  /* get to next alpha or string */
            ch = p_string[pi];
        }
        else if(strchr("+-*/^", ch)) /* jump over operators */
        {   pi = get_rightExp(pi);  /* get to next alpha or string */
            ch = p_string[pi];
        }
   /* printf("%sch=%c pi=%d len=%d\n", p_string, ch, pi, len); */
    }
}
/*---------- end str_funct2 ----------*/


void get_strfunc(char *name,int ndx)  /* identify function */
{   char varname[VAR_NAME], temp[TOKEN_LEN];

    strcpy(varname, name);
    temp[0] = '\0';

/* --- now compare to functions --- */
    if(strcmp(varname, "CHR") == 0)
    {   strcpy(temp, "   1");       /* is this a CHR$(n) assnmnt */
    }
    else if(strcmp(varname, "LEFT") == 0)
    {   strcpy(temp, "    2");       /* a LEFT$(a$,n) assnmnt */
    }
    else if(strcmp(varname, "RIGHT") == 0)
    {   strcpy(temp, "     3");       /* a RIGHT$(a$,n) assnmnt */
    }
    else if(strcmp(varname, "MID") == 0)
    {   strcpy(temp, "   4");         /* a MID$(a$,s,n) assnmnt */
    }
    else if(strcmp(varname, "SPACE") == 0)
    {   strcpy(temp, "     5");       /* a SPACE$(n) assnmnt */
    }
    else if(strcmp(varname, "STR") == 0)
    {   strcpy(temp, "   6");             /* a STR$(x) assnmnt */
    }
    else if(strcmp(varname, "STRING") == 0)
    {   strcpy(temp, "      7");          /* a STRING$(n,a) assnmnt */
    }
    else if(strcmp(varname, "INKEY") == 0)
    {   strcpy(temp, "     8");           /* an INKEY$ assnmnt */
    }
    else if(strcmp(varname, "INPUT") == 0)
    {   strcpy(temp, "     9");           /* an INPUT$(n) assnmnt */
    }
    else if(strcmp(varname, "MKD") == 0)
    {   strcpy(temp, "  10");             /* a MKD$(n) assnmnt */
    }
    else if(strcmp(varname, "MKI") == 0)
    {   strcpy(temp, "  11");             /* a MKI$(n) assnmnt */
    }
    else if(strcmp(varname, "MKS") == 0)
    {   strcpy(temp, "  12");             /* a MKS$(n) assnmnt */
    }
    else if(strcmp(varname, "DATE") == 0)
    {   strcpy(temp, "   13");             /* a DATE$ assnmnt */
    }
    else if(strcmp(varname, "TIME") == 0)
    {   strcpy(temp, "   14");             /* a TIME$ assnmnt */
    }

    str_copy(temp,ndx);   /* replace function name w/token */
}
/*---------- end get_strfunc ----------*/


void get_mathfunc(char *name,int ndx)    /* identify math function */
{   char varname[VAR_NAME], temp[TOKEN_LEN];

    strcpy(varname, name);
    temp[0] = '\0';

  /* --- now compare to functions --- */
    if(strcmp(varname, "ABS") == 0)
    {   strcpy(temp, " ?1");    /* a abs(n) assnmnt */
    }
    else if(strcmp(varname, "ASC") == 0)
    {   strcpy(temp, " ?2");    /* a asc(a$) assnmnt */
    }
    else if(strcmp(varname, "ATN") == 0)
    {   strcpy(temp, " ?3");    /* a atn(n) assnmnt */
    }
    else if(strcmp(varname, "COS") == 0)
    {   strcpy(temp, " ?4");    /* a cos(n) assnmnt */
    }
    else if(strcmp(varname, "SIN") == 0)
    {   strcpy(temp, " ?5");    /* a sin(n) assnmnt */
    }
    else if(strcmp(varname, "TAN") == 0)
    {   strcpy(temp, " ?6");    /* a tan(n) assnmnt */
    }
    else if(strcmp(varname, "SQRT") == 0)
    {   strcpy(temp, "  ?7");    /* a sqrt(n) assnmnt */
    }
    else if(strcmp(varname, "INT") == 0)
    {   strcpy(temp, " ?8");    /* a int(n) assnmnt */
    }
    else if(strcmp(varname, "LEN") == 0)
    {   strcpy(temp, " ?9");            /* a len($) assnmnt */
    }
    else if(strcmp(varname, "LOF") == 0)
    {   strcpy(temp, "?10");            /* a lof(n) assnmnt */
    }
    else if(strcmp(varname, "LOC") == 0)
    {   strcpy(temp, "?11");            /* a loc(n) assnmnt */
    }
    else if(strcmp(varname, "CVD") == 0)
    {   strcpy(temp, "?12");            /* a cvd($) assnmnt */
    }
    else if(strcmp(varname, "CVI") == 0)
    {   strcpy(temp, "?13");            /* a cvi($) assnmnt */
    }
    else if(strcmp(varname, "CVS") == 0)
    {   strcpy(temp, "?14");            /* a cvs($) assnmnt */
    }
    else if(strcmp(varname, "ATN2") == 0)
    {   strcpy(temp, " ?15");            /* a atn2(n,n) assnmnt */
    }
    else if(strcmp(varname, "COSH") == 0)
    {   strcpy(temp, " ?16");            /* a cosh(n) assnmnt */
    }
    else if(strcmp(varname, "SINH") == 0)
    {   strcpy(temp, " ?17");            /* a sinh(n) assnmnt */
    }
    else if(strcmp(varname, "TANH") == 0)
    {   strcpy(temp, " ?18");            /* a tanh(n) assnmnt */
    }
    else if(strcmp(varname, "ACOS") == 0)
    {   strcpy(temp, " ?19");            /* a acos(n) assnmnt */
    }
    else if(strcmp(varname, "ASIN") == 0)
    {   strcpy(temp, " ?20");            /* a asin(n) assnmnt */
    }
    else if(strcmp(varname, "CEIL") == 0)
    {   strcpy(temp, " ?21");            /* a ceil(n) assnmnt */
    }
    else if(strcmp(varname, "FLOOR") == 0)
    {   strcpy(temp, "  ?22");   /* a floor(n) assnmnt */
    }
    else if(strcmp(varname, "HYPOT") == 0)
    {   strcpy(temp, "  ?23");   /* a hypot(n,n) assnmnt */
    }
    else if(strcmp(varname, "LOG") == 0)
    {   strcpy(temp, "?24");    /* a log(n) assnmnt */
    }
    else if(strcmp(varname, "LOG10") == 0)
    {   strcpy(temp, "  ?25");   /* a log10(n) assnmnt */
    }
    else if(strcmp(varname, "RAND") == 0)
    {   strcpy(temp, " ?26");    /* a rand() assnmnt */
    }
    else if(strcmp(varname, "CLOCK") == 0)
    {   strcpy(temp, "  ?27");   /* a clock() assnmnt */
    }
    else if(strcmp(varname, "VAL") == 0)
    {   strcpy(temp, "?28");    /* a val($) assnmnt */
    }
    else if(strcmp(varname, "EOF") == 0)
    {   strcpy(temp, "?29");    /* a eof() assnmnt */
    }

    str_copy(temp, ndx);  /* replace function name w/token */
}
/*---------- end get_mathfunc ----------*/


void str_copy(char *temp,int ndx)
{   char ch, tok[TOKEN_LEN];  /* replace function name w/token */
    int pi, si=0;

    strcpy(tok, temp);
    pi = e_pos;
    ch = tok[si];
    if(ch != '\0')
    {   while(ch != '\0')
        {   p_string[pi] = ch;
            si++;
            pi++;
            ch = tok[si];
        }
        strcpy(temp_prog[ndx], p_string);
        e_pos = pi;
    }
    else
    {   e_pos = s_pos;    /* not a function */
    }
 /* printf("%s", p_string); */
}
/*---------- end str_copy ----------*/


int IsEqu(int pi)
{   char ch;     /* is equal sign */
    int _bool=0;

    pi = iswhite(pi);
    e_pos = pi;
    ch = p_string[pi];
    if(ch == '=')
    {   _bool = 1;
    }
    return _bool;
}
/*---------- end IsEqu ----------*/


void var_types(int ndx)    /* tokenize variable types */
{   char ch, token[VAR_NAME], temp[VAR_NAME], charx[3];
    int pi, len;

    strcpy(p_string, temp_prog[ndx]);
/* printf("vartypes::%s", p_string); */

    len = strlen(p_string);
    pi = 0;
    ch = p_string[pi];
    e_pos = pi;
    while((pi < len) && (ch != '\n'))
    {   strcpy(charx, " ");   /* clear symbol */
        pi = get_alpha(pi, len);  /* get token */

/*    ch = p_string[pi];
/*    printf("ch=%c pi=%d\n", ch, pi); */

        e_pos = pi;
        strcpy(token, get_varname());
        e_pos = pi;
        temp[0] = '\0';
  /**/
    /* --- now compare to tokens --- */
        if(strcmp(token, "AS") == 0)
        {   strcpy(temp, "  ");
        }
        else if(strcmp(token, "STRING") == 0)
        {   strcpy(temp, "     $");
        }
        else if(strcmp(token, "INTEGER") == 0)
        {   strcpy(temp, "      %");
        }
        else if(strcmp(token, "LONG") == 0)
        {   strcpy(temp, "   &");
        }
        else if(strcmp(token, "SINGLE") == 0)
        {   strcpy(temp, "     !");
        }
        else if(strcmp(token, "DOUBLE") == 0)
        {   strcpy(temp, "     #");
        }
        else
        {   pi = get_NextOp(pi);
        }
        if(temp[0] != '\0')
        {   str_copy(temp, ndx);
            pi = e_pos;
        }
        ch = p_string[pi];

/* printf("%s", p_string); */
    }
}
/*---------- end var_types ----------*/

/* bxbasm : Utility.c : alpha version */
/* ----- function prototypes ----- */
//#include "prototyp.h"



int get_Dvtype(int pi)
{   char ch, chx;
    int type;

    ch = p_string[pi];
/* printf("Dvtype:ch=>%c< pi=%d\n", ch, pi); */

    if(ch == '$')
    {   type = 0;      /* a string variable */
        ch = p_string[(pi+1)];
        if(ch == '(')     /* an array subscript */
        {   type = 6;     /* abc$(1,2,3)        */
        }
    }
    else if(strchr("%!#@&", ch))
    {   type = get_Nvtype(pi);
        chx = p_string[(pi+1)];
        if(chx == '(')    /* an array subscript */
        {   switch(ch)
            {   case '%':
                    type = 7;   /* integer array */
                    break;
                case '!':
                    type = 8;   /* float array */
                    break;
                case '#':
                    type = 9;   /* double array */
                    break;
                case '@':
                case '&':
                    type = 10;   /* long integer */
                    break;
            }
        }
    }
    else if(ch == '(')
    {   type = 11;
    }
    else
    {   type = 1;
    }
    return type;
}
/*------- end get_Dvtype --------*/


int get_vtype(int pi)
{   char ch, chx;
    int type=-1;

    ch = p_string[pi];
    while(isalnum(ch))
    {   pi++;
        ch = p_string[pi];
    }
    if(ch == '$')
    {   type = 0;      /* a string variable */
        ch = p_string[(pi+1)];
        if(ch == '(')     /* an array subscript */
        {   type = 6;     /* abc$(1,2,3)        */
        }
    }
    else if(strchr("\n =<>%!#@&", ch))
    {   type = 1;    /* a numeric or unspecified variable */
        if(strchr("%!#@&", ch))
        {   chx = p_string[(pi+1)];
            if(chx == '(')    /* an array subscript */
            {   switch(ch)
                {   case '%':
                        type = 7;   /* integer array */
                        break;
                    case '!':
                        type = 8;   /* float array */
                        break;
                    case '#':
                        type = 9;   /* double array */
                        break;
                    case '@':
                    case '&':
                        type = 10;   /* long integer */
                        break;
                }
            }
        }
    }
    else if(ch == '(')                    /* a function */
    {   type = 11;                /* it's an: EOF(fp) */
    }
    return type;
}
/*------- end get_vtype --------*/


int get_Nvtype(int pi)
{   char ch;
    int type=0;

    pi = while_isalnum(pi);
    ch = p_string[pi];
    if(strchr(",; )=+*-/\n", ch))
    {   type = 1;     /* a 16 Bit Word Integer */
    }
    else if(ch == '%')
    {   type = 2;     /* a 32 Bit Long Integer */
    }
    else if(ch == '!')
    {   type = 3;     /* a 32 Bit Floating Point */
    }
    else if(ch == '#')
    {   type = 4;     /* a 64 Bit Double Float */
    }
    else if(ch == '@')
    {   type = 5;     /* a 64 Bit Long Integer */
    }
    else if(ch == '&')
    {   type = 5;     /* a 64 Bit Long Integer */
    }
    return type;
}
/*------- end get_Nvtype --------*/


int get_rightExp(int pi) /* get to rightside expression */
{   char ch;

    ch = p_string[pi];
    while((isalnum(ch) == 0) && (ch != '\"') && (ch != '\n'))
    {   pi++;
        ch = p_string[pi];
    }
    return pi;
}
/*---------- end get_rightExp ----------*/


int get_NextOp(int pi)
{
    pi = while_isalnum(pi);  /* skip over any variable or string */
    pi = iswhiter(pi);
    return pi;
}
/*---------- end get_NextOp ----------*/


int get_paren(int pi, int stlen)
{   char ch;

    ch = p_string[pi];
    while((strchr("()", ch) == 0) && (pi < stlen))
    {   pi++;
        ch = p_string[pi];
    }
    return pi;
}
/*---------- end get_paren ----------*/


int get_upper(int pi, int stlen)
{   char ch;

    ch = p_string[pi];
    while((isupper(ch) == 0) && (pi < stlen))
    {   pi++;
        ch = p_string[pi];
    }
    return pi;
}
/*---------- end get_upper ----------*/


int get_alpha(int pi, int stlen)
{   char ch;

    ch = p_string[pi];
    while((isalpha(ch) == 0) && (pi < stlen))
    {   pi++;
        ch = p_string[pi];
    }
    return pi;
}
/*---------- end get_alpha ----------*/


int get_digit(int pi, int stlen)
{   char ch;

    ch = p_string[pi];
    while((isdigit(ch) == 0) && (pi < stlen))
    {   pi++;
        ch = p_string[pi];
    }
    return pi;
}
/*---------- end get_digit ----------*/


int get_alnum(int pi, int len)
{   char ch;

    ch = p_string[pi];
    while((isalnum(ch) == 0) && (pi < len))
    {   pi++;
        ch = p_string[pi];
    }
    return pi;
}
/*---------- end get_alnum ---------*/


int iswhite(int pi)
{   char ch;

    ch = p_string[pi];                  /* if next char is "whitespace" */
    while(isspace(ch) != 0)                            /* get rid of it */
    {   pi++;
        ch = p_string[pi];
    }
    return pi;
}
/*-------- end iswhite ----------*/


int iswhiter(int pi)
{   char ch, space=32;

    ch = p_string[pi];                   /* if next char is "space" */
    while(ch == space)                             /* get rid of it */
    {   pi++;
        ch = p_string[pi];
    }
    return pi;
}
/*-------- end iswhiter ---------*/


int while_isalnum(int pi)
{   char ch;

    ch = p_string[pi];
    while(isalnum(ch))
    {   pi++;
        ch = p_string[pi];
    }
    return pi;
}
/*-------- end while_isalnum ---------*/


int get_quote(int pi, int len)
{   char ch, quote='\"';

    pi++;
    ch = p_string[pi];
    while((ch != quote) && (pi < len))
    {   pi++;
        ch = p_string[pi];
    }
    if(ch == quote)
    {   pi++;
    }
    return pi;
}
/*-------- end get_quote ---------*/


void clr_arrays()
{   int ii;

    for(ii=0; ii < nrows; ii++)  /* free program array memory */
    {   free(label_nam[ii]);
        free(array1[ii]);
    }
    free(label_nam);
    free(byte_array);
    free(array1);
 /**/
    Kill_arrays();     /* For/Next loops */
}
/*-------- end clr_arrays ----------*/


int find_strng(char *tmp)
{   char ch, cx, quote='\"';
    char temp[TOKEN_LEN], xxstring[TOKEN_LEN];
    int pi, i, mark, len, len2;

    strcpy(xxstring, tmp);
    len = strlen(p_string);        /* locate xxstring within p_string */
    len2 = strlen(xxstring);
    pi = s_pos;                    /* plant pi w/starting position */
    ch = p_string[pi];
    cx = xxstring[0];              /* plant cx with 1st char in xxstring */
    while(pi < len)
    {   while((ch != cx) && (pi < len))  /* find cx in p_string */
        {   if(ch == quote)            /* line contains a quoted string */
            {   pi++;                  /* advance past quoted strings */
                ch = p_string[pi];
                while(ch != quote)
                {   pi++;
                    ch = p_string[pi];
                }
            }
            pi++;
            ch = p_string[pi];
        }
        if((pi == len) || (pi > len))
        {   mark = 0;        /* an error trap, in case string not found */
            return mark;
        }
        mark = pi;         /* this marks the beginning of search string */
        for(i=0; i < len2; i++)         /* load temp with test string */
        {   temp[i] = ch;
            pi++;
            ch = p_string[pi];
        }
        temp[i] = '\0';
        if(strcmp(temp, xxstring) != 0)      /* test failed, loop again */
        {   pi = (mark+1);               /* advance pi by 1 from "mark" */
            ch = p_string[pi];
        }
        else
        {   mark++;
            pi = len;
        }
    }
    return mark;
}
/*-------- end find_strng ---------*/


void Build_arrays()
{   int ii;
    unsigned size=128;

    ForArray = (char**)malloc(size * sizeof(char *));
    for(ii=0; ii < size; ii++)
    {   ForArray[ii] = (char*)malloc(LLEN * sizeof(char));
    }
  /**/
    label_endif = (char**)malloc(size * sizeof(char *));
    for(ii=0; ii < size; ii++)
    {   label_endif[ii] = (char*)malloc(LLEN * sizeof(char));
    }
  /**/
    label_block = (char**)malloc(size * sizeof(char *));
    for(ii=0; ii < size; ii++)
    {   label_block[ii] = (char*)malloc(LLEN * sizeof(char));
    }
  /**/
    label_elseif = (char**)malloc(size * sizeof(char *));
    for(ii=0; ii < size; ii++)
    {   label_elseif[ii] = (char*)malloc(LLEN * sizeof(char));
    }
  /**/
    label_else = (char**)malloc(size * sizeof(char *));
    for(ii=0; ii < size; ii++)
    {   label_else[ii] = (char*)malloc(LLEN * sizeof(char));
    }
  /**/
    WhileArray = (char**)malloc(size * sizeof(char *));
    for(ii=0; ii < size; ii++)
    {   WhileArray[ii] = (char*)malloc(LLEN * sizeof(char));
    }
  /**/
    LoopArray = (char**)malloc(size * sizeof(char *));
    for(ii=0; ii < size; ii++)
    {   LoopArray[ii] = (char*)malloc(LLEN * sizeof(char));
    }
    BreakArray = (char**)malloc(size * sizeof(char *));
    for(ii=0; ii < size; ii++)
    {   BreakArray[ii] = (char*)malloc(LLEN * sizeof(char));
    }

    /* ... */

}
/*-------- end Build_arrays ---------*/


void Kill_arrays()
{   int ii;
    unsigned size=128;

    for(ii=0; ii < size; ii++)
    {   free(ForArray[ii]);
    }
    free(ForArray);
  /**/
    for(ii=0; ii < size; ii++)
    {   free(label_endif[ii]);
    }
    free(label_endif);
  /**/
    for(ii=0; ii < size; ii++)
    {   free(label_block[ii]);
    }
    free(label_block);
  /**/
    for(ii=0; ii < size; ii++)
    {   free(label_elseif[ii]);
    }
    free(label_elseif);
  /**/
    for(ii=0; ii < size; ii++)
    {   free(label_else[ii]);
    }
    free(label_else);
  /**/
    for(ii=0; ii < size; ii++)
    {   free(WhileArray[ii]);
    }
    free(WhileArray);
  /**/
    for(ii=0; ii < size; ii++)
    {   free(LoopArray[ii]);
    }
    free(LoopArray);
  /**/
    for(ii=0; ii < size; ii++)
    {   free(BreakArray[ii]);
    }
    free(BreakArray);
  /**/
    /* ... */

}
/*-------- end Kill_arrays ---------*/




/* bxbasm : Asminput.c : alpha version */
/* ----- function prototypes ----- */
//#include "prototyp.h"


void Header()
{
    open_destin();
 /**/
    writeln(";\t*************BxbAsm Compiler*************");
    writeln(";\tCopyright: sarbayo (c) 2004");
    writeln("; =========================================================================");
    writeln("  .386                       ; use 386 instructions");
    writeln("  .model flat, stdcall       ; Win32 memory model");
    writeln("  option casemap:none        ; case sensitive");
    writeln("; =========================================================================");
    writeln("; BXB Function Prototypes:");
    writeln("; =========================================================================");
    writeln("  dblArryElement   proto");
    writeln("  quadArryElement  proto");
    writeln("  freeArray  proto");
    writeln("    ;proto");
    writeln("; =========================================================================");
    writeln("  include \\Masm32\\Bxbasm\\BXB.inc");
    writeln("; -------------------------------------------------------------------------");
    writeln("; =========================================================================");
    writeln(";  INITIALIZED DATA");
    writeln("; =========================================================================");
    writeln(" .data");
 /**/
    Prolog();
    Build_arrays();
}
/*---------- end Header ----------*/


void Prolog()    /* Write the Prolog */
{
    ScanVars();    /* pre-scan for quoted strings */
 /**/
    writeln("; =========================================================================");
    writeln(";  UNINITIALIZED DATA");
    writeln("; =========================================================================");
    writeln(" .data?");
    writeln("\tsystem_time SYSTEMTIME  <>\t\t\t;current date & time");
    writeln("\tsa  SECURITY_ATTRIBUTES  <>");
    writeln("\tcsbi  CONSOLE_SCREEN_BUFFER_INFO  <>");
    writeln("\tiCOL\t\tdd\t?");
    writeln("\tiROW\t\tdd\t?");
    writeln("\tiYear\t\tdd\t?");
    writeln("\tiMonth\tdd\t?");
    writeln("\tiDay\t\tdd\t?");
    writeln("\tiHour\t\tdd\t?");
    writeln("\tiMinute\tdd\t?");
    writeln("\tiSecond\tdd\t?");
    writeln("\tiMilli\tdd\t?");
    writeln("\thStdHandle\t\tdd\t?");
    writeln("\tIntString\tdb\t12\t\tdup(?)\t; integer string");
    writeln("\tFltString\tdb\t28\t\tdup(?)");
    writeln("\tBffrInput\tdb\tBUFSIZE\tdup(?)");
    writeln("\tiohandles\tDD\t99\t\tdup(?)");
    writeln("\tiobuffers\tDD\t99\t\tdup(?)");
    writeln("\tiLVAR\t\tdd\t?");
    writeln("\tiRVAR\t\tdd\t?");
    writeln("\tqLVAR\t\tdq\t?");
    writeln("\tqRVAR\t\tdq\t?");
    writeln("\tarray_mtrx\t\tDW\t60\tdup(?)");
 /**/
    load_tmpdata();
 /**/
    writeln("; =========================================================================");
    writeln(" .code");
    writeln("; =========================================================================");
    writeln(" start:");
    writeln("; =========================================================================");
    writeln("  invoke Main");
    writeln("  invoke ExitProcess, NULL");
    writeln("; =========================================================================");
    writeln("; --------------------------------------------------");
    writeln("Main proc");
    writeln("; --------------------------------------------------");
    writeln("  pushad");
    writeln("  call Do_initialize");
}
/*---------- end Prolog ----------*/


void SystemConst()
{
    writeln("; --------------------------------------------------");
    writeln("; Do Not Delete !!!:  Constants and system variables");
    writeln("; --------------------------------------------------");
    writeln("\tinteger    dd  0");
    writeln("\tx87buff    dq  0");
    writeln("; --------------------------------------------------");
}
/*---------- end SystemConst ----------*/


void Epilog()   /* Write the Epilog */
{
    writeln(";");
    PostLabel("DONE");
    writeln("  ; --------------------------------------------------");
    writeln("  ; --------------------------------------------------");
    writeln("Alldone:");
    writeln("  invoke StdIn, addr BffrInput, BUFFR_SIZ   ; pause");
    writeln("  popad");
    writeln("  ret                                       ; return to windows");
    writeln("  ; --------------------------------------------------");
    writeln("Main endp");
    writeln("; =========================================================================");
  /**/
  /* --- write functions --- */
    Do_functions();
  /**/
  /* --- mark end of program --- */
    writeln("; =========================================================================");
    writeln("end start");
    writeln("; =========================================================================");
    writeln("; =========================================================================");
    fclose(f_out);
    printf("Lines compiled: %d\n", nrows);
    printf("Done.\n");
}
/*---------- end Epilog ----------*/


void open_destin()
{   char ch, dot='.', destin[PATH];
    int ii;

    strcpy(destin, s_holder);   /* copy source file name */
    ii = 0;
    ch = '\0';
    while(ch != dot)
    {   ch = s_holder[ii];   /* make source.bas = source. */
        ii++;
    }
    destin[ii] = '\0';
    strcat(destin, "asm");   /* append "asm" to filename */
    strcpy(t_holder, destin);   /* copy asm source filename */
  /**/
    f_out = fopen(destin,"w");  /* open destination file (write) */
    printf("Destination file: %s\n",destin);
  /**/
    s_datatemp = fopen("sdatatmp.tmp","w");  /* open temp file */
    i_datatemp = fopen("idatatmp.tmp","w");  /* open temp file */
    f_datatemp = fopen("fdatatmp.tmp","w");  /* open temp file */
    x_datatemp = fopen("xdatatmp.tmp","w");  /* open temp file */
  /**/
    s_writeln("\t_var_start\tdd\t?");  /* string data */
    i_writeln("\t_int_start\tdd\t?");  /* integer data */
    f_writeln("\t_flt_start\tdd\t?");  /* float data */
    x_writeln("\t_arry_start\tdd\t?");  /* arrays data */
}
/*---------- end open_destin ----------*/


void ScanVars()    /* identify and write all variables */
{   char ch, varname[VAR_NAME];
    int pi, ii;

    line_ndx = 0;
    while(line_ndx < nrows)
    {   get_token();
        e_pos = 0;
        s_pos = 0;
  /**/
        switch(token)
        {   case 1:       /* --- LET: statement --- */
                ScanLet();
                break;
            case 2:       /* --- CLEAR: statement --- */
                ScanPrint();
                break;
            case 3:       /* --- LOCATE: statement --- */
                ScanParam();
                break;
            case 4:       /* --- PRINT: statement --- */
                ScanPrint();
                break;
            case 5:       /* --- GOTO: statement --- */
            case 9:       /* --- GOSUB: statement --- */
                ScanJump();
                break;
            case 11:   /* --- FOR: statement --- */
                ScanFor();
                break;
            case 13:   /* --- IF: statement --- */
            case 14:   /* --- ELSEIF: statement --- */
                ScanIf();
                break;
            case 17:   /* --- INPUT: statement --- */
            case 18:   /* --- LINE INPUT: statement --- */
                ScanPrint();
                break;
            case 19:   /* --- OPEN: statement --- */
                ScanOpen();
                break;
            case 21:   /* --- WRITE: statement --- */
                ScanWrite();
                break;
            case 22:   /* --- FIELD: statement --- */
                ScanField();
                break;
            case 23:   /* --- LSET: statement --- */
            case 24:   /* --- RSET: statement --- */
                ScanLet();
                break;
            case 25:   /* --- PUT: statement --- */
            case 26:   /* --- GET: statement --- */
                ScanPut();
                break;
            case 27:   /* --- CHDIR: statement --- */
            case 28:   /* --- MKDIR: statement --- */
            case 29:   /* --- RMDIR: statement --- */
            case 30:   /* --- KILL: statement --- */
                ScanPrint();
                break;
            case 31:   /* --- NAME/RENAME: statement --- */
                ScanRename();
                break;
            case 32:   /* --- FILES: statement --- */
                ScanFiles();
                break;
            case 33:   /* --- SHELL: statement --- */
                ScanShell();
                break;
            case 34:       /* --- RANDOM: statement --- */
                ScanParam();
                break;
            case 35:       /* --- READ: statement --- */
                ScanFInput();
                break;
            case 37:       /* --- WHILE: statement --- */
                ScanIf();
                break;
            case 43:       /* --- LPRINT: statement --- */
                ScanLPrint();
                break;
            case 44:       /* --- COLOR: statement --- */
                ScanParam();
                break;
            case 46:       /* --- DIM: statement --- */
                ScanDim();
                break;
            case 47:       /* --- ERASE-FREE: statement --- */
                ScanErase();
                break;

        }
        line_ndx++;
    }
    SystemConst();    /* write system constants */
 /**/
    for(ii=0; ii < VarNdxCnt; ii++)  /* clear var name index */
    {   free(VarIndx[ii]);
    }
    free(VarIndx);
}
/*---------- end ScanVars ----------*/


void ScanLet()
{   char ch, varname[VAR_NAME];
    int pi, type, ab_code=5, x=line_ndx;

    pi = e_pos;
    strcpy(varname, get_varname());   /* get varname */
 /**/
    pi = e_pos;
    ch = p_string[pi];
    if(strchr("$%!#@&", ch))
    {   type = get_vtype(pi);    /* get variable type */
    /* printf("let1:varname=%s type=%d\n", varname, type); */
  /**/
        if(type == 0)     /* strings */
        {   ScanString(varname);
        }
        else if(type == 6)     /* string array */
        {   ScanStrArray(varname);
        }
        else if((type >= 7) && (type <= 10))  /* numeric array */
        {   ScanNumArray(varname, type);
        }
        else      /* numeric expressions */
        {   ScanNumeric(varname);
        }
    }
    else
    {   type = get_ObjectType(varname); /* object type specifier */
    /* printf("let2:varname=%s type=%d\n", varname, type); */
  /**/
        if(type == 0)     /* strings */
        {   ScanString(varname);
        }
        else if(type == 6)     /* string array */
        {   ScanStrArray(varname);
        }
        else if((type >= 7) && (type <= 10))  /* numeric array */
        {   ScanNumArray(varname, type);
        }
        else      /* numeric expressions */
        {   ScanNumeric(varname);
        }
    }
}
/*---------- end ScanLet ----------*/


void ScanString(char *Name)
{   char ch, varname[VAR_NAME];
    int pi, len, type;

    strcpy(varname, Name);
    Fix_String(varname);
  /**/
    len = strlen(p_string);
    pi = e_pos;
    pi = get_rightExp(pi);   /* jump pi over this operator */
    ch = p_string[pi];
    while((ch != '\n') && (pi < len))
    {   e_pos = pi;
        if(ch == '\"')    /* found a quoted string */
        {   GetNewVar();    /* get new varname */
        }
        else if(isalpha(ch))
        {   strcpy(varname, get_varname());  /* get varname */
            type = get_ObjectType(varname);
   /**/
            if(type == 6)
            {   Fix_StrArray(varname);
                pi = e_pos;
                pi = get_paren(pi, len);
                ScanArrayParam();
            }
            else
            {   Fix_String(varname);
            }
        }
        else if(isdigit(ch))   /* a string function number */
        {   len = scanStr_funct(len);
        }
        pi = e_pos;
        pi = get_rightExp(pi);
        ch = p_string[pi];
    }
/* printf("%s", p_string); */
}
/*---------- end ScanString ----------*/


void ScanStrArray(char *Name)
{   char ch, varname[VAR_NAME];
    int pi, len, type;

    strcpy(varname, Name);
    len = strlen(p_string);
    pi = e_pos;
    ch = p_string[pi];
    if(ch == '$')
    {   Fix_StrArray(varname);
    }
 /**/
    pi = e_pos;
    pi = get_paren(pi, len);
    e_pos = pi;
    ScanArrayParam();   /* assign variables: abc$(1,3,n) */
  /**/
    pi = e_pos;
    pi = get_rightExp(pi);   /* jump pi over this operator */
    ch = p_string[pi];
    while((ch != '\n') && (pi < len))
    {   e_pos = pi;
        if(ch == '\"')    /* found a quoted string */
        {   GetNewVar();    /* get new varname */
        }
        else if(isalpha(ch))
        {   strcpy(varname, get_varname());  /* get varname */
            type = get_ObjectType(varname);
   /**/
            if(type == 6)
            {   Fix_StrArray(varname);
                pi = e_pos;
                pi = get_paren(pi, len);
                ScanArrayParam();
            }
            else
            {   Sav_String(varname);
            }
        }
        else if(isdigit(ch))   /* a string function number */
        {   len = scanStr_funct(len);
        }
        pi = e_pos;
        pi = get_rightExp(pi);
        ch = p_string[pi];
    }
/* printf("%s", p_string); */
}
/*---------- end ScanStrArray ----------*/


int scanStr_funct(int len)
{   char ch, varname[VAR_NAME];
    int pi, type;

    pi = e_pos;
    pi = get_paren(pi,len);
    if(pi >= len)
    {   e_pos = pi;    /* a$ = INKEY$, TIME$, DATE$ */
        return len;
    }
    pi++;
    pi = iswhite(pi);
    ch = p_string[pi];
    while((ch != ')') && (ch != '\n') && (pi < len))
    {   ch = p_string[pi];
        e_pos = pi;
        if(ch == '\"')    /* found a quoted string */
        {   GetNewVar();    /* get new varname */
        }
        else if((isdigit(ch)) || (strchr("-.", ch)))
        {   GetNewTmp();    /* get new temp varname */
        }
        else if(isalpha(ch))    /* a variable name */
        {   strcpy(varname, get_varname()); /* get varname */
            pi = e_pos;
            type = get_vtype(pi);   /* get variable type */
            if(type == 0)    /* string variables */
            {   Fix_String(varname);
            }
            else      /* numeric variables */
            {   len = strlen(varname);
                s_pos = pi - len;
                type = get_Nvtype(pi);
                Sav_Destin(type, varname); /* save variable name */
            }
        }
        pi = e_pos;
        len = strlen(p_string);
        ch = p_string[pi];
  /* printf("ch=%c< pi=%d::%s", ch, pi, p_string); */

        if(strchr("$, %!#@&", ch))
        {   pi++;
        }
    }
    e_pos = pi;
    return len;

 /* printf("%s", p_string); */
}
/*---------- end scanStr_funct ----------*/


void ScanPrint()
{   char ch, varname[VAR_NAME];
    int pi, type, len, ival;

/* printf("ScanPrint::%s", p_string); */
    len = strlen(p_string);
    pi = e_pos;
    pi = iswhite(pi);
    ch = p_string[pi];
    if(ch == '#')
    {   if(token == 4)
        {   ScanFPrint();  /* PRINT# statement */
        }
        else
        {   ScanFInput();
        }
        return;
    }
    while((pi < len) && (ch != '\n'))
    {   e_pos = pi;

   /* printf("ch=%c pi=%d len=%d\n", ch, pi, len); */
  /**/
        if(ch == '\"')    /* found a quoted string */
        {   GetNewVar();   /* get new varname */
        }
        else if(ch == '?')   /* math function: ?1(num) */
        {   e_pos = pi + 1;
            ival = (int) get_avalue();
            if((ival == 10) || (ival == 11) || (ival == 29))
            {   pi = len;    /* LOC, LOF, EOF */
                e_pos = pi;
            }
            else     /* any other function */
            {   pi = get_paren(pi, len); /* ?num(string$) */
                pi++;
                e_pos = pi;
                ScanMathFunc(len);
            }
        }
        else if(isalpha(ch))
        {   strcpy(varname, get_varname()); /* get varname */
            s_pos = pi;
            pi = e_pos;
            type = get_ObjectType(varname);
            if(type == -1)   /* an undeclared variable */
            {   type = get_vtype(pi);  /* ch == "$%@&!#" */
            }
      /* printf("name=%s type=%d pi=%d\n", varname, type, pi); */

            if(type == 0)    /* string variables */
            {   Fix_String(varname);
            }
            else if(type == 6)   /* string array */
            {   Fix_StrArray(varname);
                pi = get_paren(pi, len);
                ScanArrayParam();
            }
            else if((type >= 7) && (type <= 10)) /* numeric array */
            {   Fix_VarArray(varname);
                pi = get_paren(pi, len);
                ScanArrayParam();
            }
            else      /* numeric variables */
            {   len = strlen(varname);
                s_pos = pi - len;
                type = get_Nvtype(pi);
                Sav_Destin(type, varname); /* save variable name */
            }
        }
        else if(isdigit(ch))   /* a string function number */
        {   pi = get_NextOp(pi);
            ch = p_string[pi];
      /* printf("ch=%c pi=%d len=%d\n", ch, pi, len); */

            if(ch == '(')   /* is it a: 2(string) */
            {   len = scanStr_funct(len);
            }
            else     /* or: 2+2 */
            {   GetNewTmp();   /* get new temp varname */
            }
        }
        pi = e_pos;
        ch = p_string[pi];
        len = strlen(p_string);
        if(strchr(":; ,)(", ch))  /* jump over punctuation */
        {   pi = get_rightExp(pi);  /* get to next alpha or string */
        }
        else if(strchr("$%!#@&", ch)) /* jump over var types */
        {   pi = get_rightExp(pi);  /* get to next alpha or string */
        }
        else if(strchr("+-*/^", ch))      /* jump over operators */
        {   pi = get_rightExp(pi); /* get to next alpha or string */
        }
        e_pos = pi;
        ch = p_string[pi];
    }
/* printf("scanprint::%s", p_string); */
}
/*---------- end ScanPrint ----------*/


void ScanFor()
{   char ch, varname[VAR_NAME];
    int pi, type, len, ab_code=9, x=line_ndx;

    pi = 0;
    e_pos = pi;
    strcpy(varname, get_varname());   /* get varname */
 /**/
    type = get_vtype(pi);    /* get variable type */
    if(type == 1)      /* numeric expressions */
    {   LexFor(varname);
        pi = e_pos;
        e_pos = pi + 2;     /* skip over: TO */
        LexTo();
        pi = e_pos + 4;     /* skip over: STEP */
        len = strlen(p_string);
        if(len > pi)     /* if: STEP n */
        {   e_pos = pi;
            LexStep(len);
        }
        else
        {   e_pos = len;
            defaultStep(len);   /* create default STEP n */
        }
    }
    else
    {   a_bort(ab_code, x);
    }
}
/*---------- end ScanFor ----------*/


void ScanIf()
{   char ch, varname[VAR_NAME];
    int pi, len, type;

/* printf("ScanIf::%s", p_string); */
    pi = 0;
    ch = p_string[pi];
    len = strlen(p_string);
    while((ch != '\n') && (pi < len))
    {   pi = iswhite(pi);
        ch = p_string[pi];
        e_pos = pi;
        if(ch == '\"')    /* found a quoted string */
        {   GetNewVar();   /* get new varname */
        }
        else if(isalpha(ch))
        {   strcpy(varname, get_varname()); /* get varname */
            pi = e_pos;
            type = get_vtype(pi);   /* get variable type */
            if(type == 0)
            {   Fix_String(varname);
            }
            else
            {   if(strcmp(varname, "EOF") != 0)  /* not an EOF(f) */
                {   len = strlen(varname);
                    s_pos = pi - len;
                    type = get_Nvtype(pi);
                    Sav_Destin(type, varname); /* save destination name */
                }
                else
                {   pi++;     /* it's an EOF(f) */
                    pi = get_paren(pi, len);
                    e_pos = pi;
                }
            }
        }
        else if(isdigit(ch))
        {   GetNewTmp();    /* get new temp varname */
        }
        pi = e_pos;
        len = strlen(p_string);
        pi = get_rightExp(pi);
        ch = p_string[pi];
    }
/* printf("scanif::%s", p_string); */
}
/*---------- end ScanIf ----------*/


void ScanFiles()
{   char ch, temp[BUFSIZE];
    int pi, len;

    strcpy(temp, "\"dir ");
    len = strlen(p_string);
    pi = e_pos;
    pi = iswhite(pi);
  /**/
    if(pi < len)
    {   ch = p_string[pi];
        if(ch == '\"')
        {   p_string[pi] = ' ';
            strcat(temp, p_string);
        }
        else
        {   strcat(temp, p_string);
        }
    }
    else
    {   strcat(temp, "\"\n");
    }
    strcpy(p_string, temp);
    e_pos = 0;
    GetNewVar();     /* get new varname */
}
/*---------- end ScanFiles ----------*/


void ScanShell()
{   char ch, temp[BUFSIZE];
    int pi, len;

    len = strlen(p_string);
    pi = e_pos;
    pi = iswhite(pi);
  /**/
    if(pi < len)
    {   strcpy(temp, p_string);
    }
    else
    {   strcpy(temp, "\"command\"");
    }
    strcpy(p_string, temp);
    e_pos = 0;
    GetNewVar();     /* get new varname */
}
/*---------- end ScanShell ----------*/


void ScanRename()
{   char temp[6];
    int pi, len, mark;

    len = strlen(p_string);
    pi = e_pos;
  /**/
    strcpy(temp, "AS ");
    s_pos = pi;
    mark = find_strng(temp);
    mark--;
    pi = mark;
    if(pi < len)
    {   p_string[pi] = ',';
        p_string[(pi+1)] = ' ';
    }
    e_pos = 0;
    ScanPrint();
}
/*---------- end ScanRename ----------*/

void load_tmpdata()
{   char tmp_string[BUFSIZE];
    int x;
    FILE *datatemp;

    f_writeln("\t_var_endzz\tdd\t?");
    f_writeln("\tStringBffr\tdb\tMBUFSIZE\tdup(?)");
    fclose(s_datatemp);
    fclose(i_datatemp);
    fclose(f_datatemp);
    fclose(x_datatemp);
  /**/
    datatemp = fopen("sdatatmp.tmp","r");  /* open temp file */
    while(!feof(datatemp))
    {   fgets(tmp_string, BUFSIZE, datatemp);
        if(!feof(datatemp))
        {   write_str(tmp_string);  /* write data to file */
        }
        tmp_string[0] = '\0';
    }
    fclose(datatemp);
  /**/
    datatemp = fopen("idatatmp.tmp","r");  /* open temp file */
    while(!feof(datatemp))
    {   fgets(tmp_string, BUFSIZE, datatemp);
        if(!feof(datatemp))
        {   write_str(tmp_string);  /* write data to file */
        }
        tmp_string[0] = '\0';
    }
    fclose(datatemp);
  /**/
    datatemp = fopen("fdatatmp.tmp","r");  /* open temp file */
    while(!feof(datatemp))
    {   fgets(tmp_string, BUFSIZE, datatemp);
        if(!feof(datatemp))
        {   write_str(tmp_string);  /* write data to file */
        }
        tmp_string[0] = '\0';
    }
    fclose(datatemp);
  /**/
    datatemp = fopen("xdatatmp.tmp","r");  /* open temp file */
    while(!feof(datatemp))
    {   fgets(tmp_string, BUFSIZE, datatemp);
        if(!feof(datatemp))
        {   write_str(tmp_string);  /* write data to file */
        }
        tmp_string[0] = '\0';
    }
    fclose(datatemp);
  /**/
    x = remove("sdatatmp.tmp");     /* if '0', successful */
    x = remove("idatatmp.tmp");     /* if '0', successful */
    x = remove("fdatatmp.tmp");     /* if '0', successful */
    x = remove("xdatatmp.tmp");     /* if '0', successful */
}
/*------- end load_tmpdata ----------*/


void ScanErase()
{   char ch, varname[VAR_NAME];
    int pi, type, len, ival, ab_code=22, x=line_ndx;

    len = strlen(p_string);
    pi = e_pos;
    pi = iswhite(pi);
    ch = p_string[pi];
    while((pi < len) && (ch != '\n'))
    {   e_pos = pi;
  /**/
        if(isalpha(ch))
        {   strcpy(varname, get_varname()); /* get varname */
            s_pos = pi;
            pi = e_pos;
            type = get_ObjectType(varname);
   /**/
            if(type == 6)   /* string array */
            {   Fix_StrArray(varname);
            }
            else if((type >= 7) && (type <= 10)) /* numeric array */
            {   Fix_VarArray(varname);
            }
            else
            {   a_bort(ab_code, x);
            }
        }
        else
        {   a_bort(ab_code, x);
        }
        pi = e_pos;
        ch = p_string[pi];
        len = strlen(p_string);
        if(strchr(",", ch))   /* jump over punctuation */
        {   pi = get_rightExp(pi);  /* get to next alpha or string */
        }
        e_pos = pi;
        ch = p_string[pi];
    }
}
/*---------- end ScanErase ----------*/

/* bxbasm : Asmutils.c : alpha version */
/* ----- function prototypes ----- */
//#include "prototyp.h"




void Do_asm()    /* write to asm file */
{
    write_str("  ");
    write_str(p_string);
}
/*---------- end Do_asm ----------*/


void write_str(char *string)   /* write to asm file */
{
    fprintf(f_out,"%s", string);
}
/*---------- end write_str ----------*/


void writeln(char *string)   /* write to asm file */
{
    write_str(string);
    fprintf(f_out, "\n");
}
/*---------- end writeln ----------*/


void s_write_str(char *string)  /* write to string temp file */
{
    fprintf(s_datatemp,"%s", string);
}
/*---------- end s_write_str ----------*/


void s_writeln(char *string)   /* write to string temp file */
{
    s_write_str(string);
    fprintf(s_datatemp, "\n");
}
/*---------- end s_writeln ----------*/


void i_write_str(char *string)  /* write to integer temp file */
{
    fprintf(i_datatemp,"%s", string);
}
/*---------- end i_write_str ----------*/


void i_writeln(char *string)   /* write to integer temp file */
{
    i_write_str(string);
    fprintf(i_datatemp, "\n");
}
/*---------- end i_writeln ----------*/


void f_write_str(char *string)  /* write to float temp file */
{
    fprintf(f_datatemp,"%s", string);
}
/*---------- end f_write_str ----------*/


void f_writeln(char *string)   /* write to float temp file */
{
    f_write_str(string);
    fprintf(f_datatemp, "\n");
}
/*---------- end f_writeln ----------*/


void x_write_str(char *string)  /* write to arrays temp file */
{
    fprintf(x_datatemp,"%s", string);
}
/*---------- end f_write_str ----------*/


void x_writeln(char *string)   /* write to arrays temp file */
{
    x_write_str(string);
    fprintf(x_datatemp, "\n");
}
/*---------- end f_writeln ----------*/


void PostLabel(char *string)   /* Post a Label To Output */
{
    fprintf(f_out, "%s:\n", string);
}
/*---------- end PostLabel ----------*/


char *get_varname()
{   char ch;
    static char varname[VAR_NAME];
    int pi, si=0;

    pi = e_pos;
    ch = p_string[pi];
    while((isalnum(ch) != 0))
    {   varname[si] = ch;
        si++;
        pi++;
        ch = p_string[pi];
    }
    varname[si] = '\0';
    e_pos = pi;
    return varname;
}
/*---------- end get_varname ----------*/


char *get_NewLabel()    /* generate a unique label */
{   char Val[6];
    static char NewLabel[LLEN];

    UnqLblNdx++;
    strcpy(NewLabel, "Unq_");
    sprintf(Val, "%d", UnqLblNdx);  /* generate an index */
    strcat(NewLabel, Val);
    strcat(NewLabel, "_Label");
    return NewLabel;
}
/*---------- end get_NewLabel ----------*/


double get_avalue()
{   char ch, varname[VAR_NAME];
    int pi, si=0;
    double value=0;

    pi = e_pos;
    ch = p_string[pi];
    if((isdigit(ch)) || (IsAddop(ch)))    /* this is a number */
    {   if(IsAddop(ch))
        {   varname[si] = ch;
            si++;
            pi++;
            ch = p_string[pi];
        }
        while(isdigit(ch) != 0)
        {   varname[si] = ch;
            pi++;
            si++;
            ch = p_string[pi];
        }
        varname[si] = '\0';
        value = atof(varname);      /* convert alpha to float */
    }
    pi = iswhite(pi);
    e_pos = pi;
    return value;
}
/*-------- end get_avalue --------*/


void InitObj()   /* initialize object name/type array */
{   int ndx;
    unsigned size;

    if(ObjNdxCnt == 0)
    {   ndx = ObjNdxCnt;
        ObjNdxCnt++;
        size = ObjNdxCnt;
        ObjIndx = (char**)malloc(size * sizeof(char *));
        ObjType = (int**)malloc(size * sizeof(int *));
        size = VAR_NAME;
        ObjIndx[ndx] = (char*)malloc(size * sizeof(char));
        size = 2;
        ObjType[ndx] = (int*)malloc(size * sizeof(int));
    }
    else
    {   ndx = ObjNdxCnt;
        ObjNdxCnt++;
        size = ObjNdxCnt;
        ObjIndx = (char**)realloc(ObjIndx, size * sizeof(char *));
        ObjType = (int**)realloc(ObjType, size * sizeof(int *));
        size = VAR_NAME;
        ObjIndx[ndx] = (char*)malloc(size * sizeof(char));
        size = 2;
        ObjType[ndx] = (int*)malloc(size * sizeof(int));
    }
}
/*---------- end InitObj ----------*/


void Sav_ObjName(char *name, int type, int parm)
{   char varname[VAR_NAME];
    int ndx=0, _bool=0;

    strcpy(varname, name);
    InitObj();

    ndx = ObjNdxCnt - 1;
    strcpy(ObjIndx[ndx], varname);
    ObjType[ndx][0] = type;
    ObjType[ndx][1] = parm;

 /* printf("Obj: name=%s type=%d\n", ObjIndx[ndx], ObjType[ndx][0]); */

}
/*---------- end Sav_ObjName ----------*/


int get_ObjectType(char *name) /* identify object type specifier */
{   char varname[VAR_NAME];
    int ndx=0, type=-1;

    strcpy(varname, name);
    while((ndx < ObjNdxCnt) && (strcmp(varname, ObjIndx[ndx]) != 0))
    {   ndx++;
    }
    if(ndx < ObjNdxCnt)
    {   type = ObjType[ndx][0];
    }
/* printf("getObj: name=%s type=%d\n", ObjIndx[ndx], ObjType[ndx][0]); */

    return type;
}
/*---------- end get_ObjectType ----------*/


int get_ObjectParm(char *name) /* array parameter count */
{   char varname[VAR_NAME];
    int ndx=0, param;

    strcpy(varname, name);
    while((ndx < ObjNdxCnt) && (strcmp(varname, ObjIndx[ndx]) != 0))
    {   ndx++;
    }
    if(ndx < ObjNdxCnt)
    {   param = ObjType[ndx][1];
    }
 /* printf("getParm: name=%s param=%d\n", ObjIndx[ndx], ObjType[ndx][1]); */

    return param;
}
/*---------- end get_ObjectParm ----------*/


void InitVars()
{   int ndx;
    unsigned size;

    if(VarNdxCnt == 0)
    {   ndx = VarNdxCnt;
        VarNdxCnt++;
        size = VarNdxCnt;
        VarIndx = (char**)malloc(size * sizeof(char *));
        size = VAR_NAME;
        VarIndx[ndx] = (char*)malloc(size * sizeof(char));
    }
    else
    {   ndx = VarNdxCnt;
        VarNdxCnt++;
        size = VarNdxCnt;
        VarIndx = (char**)realloc(VarIndx, size * sizeof(char *));
        size = VAR_NAME;
        VarIndx[ndx] = (char*)malloc(size * sizeof(char));
    }
}
/*---------- end InitVars ----------*/


int check_VarName(char *name)
{   char varname[VAR_NAME];
    int ndx=0, _bool=0;

    strcpy(varname, name);
    if(VarNdxCnt == 0)     /* no vars exist yet */
    {   InitVars();
        ndx = VarNdxCnt - 1;
        strcpy(VarIndx[ndx], varname);
    }
    else
    {   while((ndx < VarNdxCnt) && (strcmp(varname, VarIndx[ndx]) != 0))
        {   ndx++;
        }
        if(ndx >= VarNdxCnt)   /* var name does not exist */
        {   InitVars();
            ndx = VarNdxCnt - 1;
            strcpy(VarIndx[ndx], varname);
        }
        else
        {   _bool = 1;     /* var name exists */
        }
    }
    return _bool;
}
/*---------- end check_VarName ----------*/


int check_arrayName(char *name)
{   char varname[VAR_NAME];
    int ndx=0, _bool=0;
      /* ArryNdx;     name array */
      /* ArryNdxCnt;  counter */
    strcpy(varname, name);
    if(ArryNdxCnt == 0)
    {   InitArrays();
        ndx = ArryNdxCnt - 1;
        strcpy(ArryNdx[ndx], varname);
    }
    else
    {   while((ndx < ArryNdxCnt) && (strcmp(varname, ArryNdx[ndx]) != 0))
        {   ndx++;
        }
        if(ndx >= ArryNdxCnt)
        {   InitArrays();
            ndx = ArryNdxCnt - 1;
            strcpy(ArryNdx[ndx], varname);
        }
        else
        {   _bool = 1;     /* array name exists */
        }
    }
    return _bool;
}
/*---------- end check_arrayName ----------*/


int verify_arrayName(char *name)
{   char varname[VAR_NAME];
    int ndx=0, _bool=0;

    strcpy(varname, name);
    if(ArryNdxCnt != 0)     /* no arrays exist yet */
    {   while((ndx < ArryNdxCnt) && (strcmp(varname, ArryNdx[ndx]) != 0))
        {   ndx++;
        }
        if(ndx < ArryNdxCnt)
        {   _bool = 1;     /* array name exists */
        }
    }
    return _bool;
}
/*---------- end verify_arrayName ----------*/


int verify_VarName(char *name)
{   char varname[VAR_NAME];
    int ndx=0, _bool=0;

    strcpy(varname, name);
    if(VarNdxCnt != 0)     /* no vars exist yet */
    {   while((ndx < VarNdxCnt) && (strcmp(varname, VarIndx[ndx]) != 0))
        {   ndx++;
        }
        if(ndx < VarNdxCnt)
        {   _bool = 1;     /* var name exists */
        }
    }
    return _bool;
}
/*---------- end verify_VarName ----------*/


void InitArrays()
{   int ndx;
    unsigned size;
       /* ArryNdx;     name array */
       /* ArryNdxCnt;  counter */
    if(ArryNdxCnt == 0)
    {   ndx = ArryNdxCnt;
        ArryNdxCnt++;
        size = ArryNdxCnt;
        ArryNdx = (char**)malloc(size * sizeof(char *));
        ArryParams = (int*)malloc(size * sizeof(int));
        size = VAR_NAME;
        ArryNdx[ndx] = (char*)malloc(size * sizeof(char));
    }
    else
    {   ndx = ArryNdxCnt;
        ArryNdxCnt++;
        size = ArryNdxCnt;
        ArryNdx = (char**)realloc(ArryNdx, size * sizeof(char *));
        ArryParams = (int*)realloc(ArryParams, size * sizeof(int));
        size = VAR_NAME;
        ArryNdx[ndx] = (char*)malloc(size * sizeof(char));
    }
}
/*---------- end InitArrays ----------*/


int get_paramsCount(int pi, int len)
{   char ch;
    int xcnt=0;

    ch = p_string[pi];
    while((ch != ')') && (pi < len))  /* get params count */
    {   pi = get_alnum(pi, len);
        ch = p_string[pi];
        if(isalnum(ch))
        {   xcnt++;
            pi = get_NextOp(pi);
            ch = p_string[pi];
        }
    }
    return xcnt;
}
/*---------- end get_paramsCount ----------*/


void GetNewVar()
{   char ch, NewVar[12], a_string[BUFSIZE], count[4];
    int pi, x=0, len, ab_code=23;

    len = strlen(p_string);
    pi = e_pos;
    s_pos = pi;
  /**/
    strcpy(NewVar, NewVarname());  /* --- get new varname --- */
  /**/
    write_str("\t");
    write_str(NewVar);    /* NewVar  DB  # */
    write_str("\t\tDB\t");
  /**/
    pi++;
    ch = p_string[pi];
    while((ch != '\"') && (pi < len))  /* copy up to quote */
    {   a_string[x] = ch;
        x++;
        pi++;
        ch = p_string[pi];
    }
    a_string[x] = '\0';
    if(pi >= len)    /* Error: missing closing quote */
    {   x = line_ndx;
        a_bort(ab_code, x);
    }
    e_pos = pi;
    len = strlen(a_string);
    if(len == 0)
    {   writeln("NULL");
    }
    else
    {   write_str("\'");
        write_str(a_string);
        writeln("\',0");
    }
  /* --- save varname in array --- */
    StorVar(NewVar);
    pi = e_pos;
    ch = p_string[pi];
    if(strchr(":;,", ch))
    {   pi++;
        e_pos = pi;
    }
}
/*---------- end GetNewVar ----------*/


void StorVar(char *name)
{   char ch, varname[12];
    int pi, x=0, ii, len;
    unsigned size;

    strcpy(varname, name);
    len = strlen(varname);
    ii = (s_pos + len);    /* how many chars to transfer */
    if(s_pos > 0)
    {   for(;x < s_pos; x++)
        {   s_holder[x] = p_string[x];
        }
        x = 0;
    }
    for(pi=s_pos; pi < ii; pi++,x++)
    {   s_holder[pi] = varname[x];    /* copy varname */
    }
    x = pi;
    s_pos = pi;
    pi = e_pos;
    pi++;
    ch = p_string[pi];
    while(ch != '\0')
    {   s_holder[x] = p_string[pi];
        x++;
        pi++;
        ch = p_string[pi];
    }
    s_holder[x] = '\0';
    strcpy(p_string, s_holder);

/* --- save p_string to array --- */
    x = strlen(p_string);
    len = strlen(array1[line_ndx]);
    if(x > len)
    {  size = (x+1);
       ii = line_ndx;
       array1[ii] = (char*)realloc(array1[ii], size * sizeof(char));
    }
    strcpy(array1[line_ndx], p_string);     /* store to array */
    e_pos = s_pos;
}
/*---------- end StorVar ----------*/


void Sav_String(char *Name)
{   char varname[VAR_NAME];

    strcpy(varname, Name);
  /**/
    if(check_VarName(varname) == 0)
    {   s_write_str("\t");
        s_write_str(varname);
        s_writeln("\t\tDD\t?");
   /**/
        Sav_ObjName(varname, 0, 0);
    }
}
/*---------- end Sav_String ----------*/


void Fix_String(char *Name)
{   char ch, varname[VAR_NAME];
    int pi, len;

    strcpy(varname, Name);
    len = strlen(varname);
    pi = e_pos;
    s_pos = pi - len;
    ch = p_string[pi];
  /**/
    if(ch == '$')
    {   p_string[pi] = ' ';
        Sav_String(varname);
        StorVar(varname);
    }
}
/*---------- end Fix_String ----------*/


char *NewVarname()    /* generate a unique varname */
{   char Val[6];
    static char NewVar[12];
    int type=0;

    var_count++;
    strcpy(NewVar, "VARX");
    sprintf(Val, "%d", var_count);
    strcat(NewVar, Val);
    strcat(NewVar, "S");
  /**/
    Sav_ObjName(NewVar, type, 0);
  /**/
    return NewVar;
}
/*---------- end NewVarname ----------*/


void Fix_VarName(char *Name, int type)
{   char ch, varname[VAR_NAME];
    int pi, len;

    strcpy(varname, Name);
    len = strlen(varname);
    pi = e_pos;
    s_pos = pi - len;
    ch = p_string[pi];
  /**/
    if(strchr("%!#@&", ch))
    {   p_string[pi] = ' ';
    }
}
/*---------- end Fix_VarName----------*/


void Fix_StrArray(char *Name)
{   char ch, varname[VAR_NAME];
    int pi, len;

    strcpy(varname, Name);
    len = strlen(varname);
    pi = e_pos;
    s_pos = pi - len;
    ch = p_string[pi];
  /**/
    if(ch == '$')
    {   p_string[pi] = ' ';
        StorVar(varname);
    }
}
/*---------- end Fix_StrArray ----------*/


void Fix_StrArray2(char *Name)
{   char ch, varname[VAR_NAME];
    int pi, len, ab_code=26, x=line_ndx;

/* printf("%s", p_string); */
    strcpy(varname, Name);
    len = strlen(varname);
    pi = e_pos;
    s_pos = pi - len;
    StorVar(varname);
  /**/
    if(check_VarName(varname) != 0)
    {   a_bort(ab_code,x);
    }
    if(check_arrayName(varname) == 0)
    {   x_write_str("\t");
        x_write_str(varname);
        x_writeln("\t\tDD\t?");
        x_writeln("\t\t\tDW\t61\tdup(?)");
    }
    Sav_ObjName(varname, 6, 1);
/* printf("%s", p_string); */
}
/*---------- end Fix_StrArray2 ----------*/


void Fix_VarArray2(char *Name, int type)
{   char ch, varname[VAR_NAME];
    int pi, len, ab_code=26, x=line_ndx;

/* printf("fixVA2::%s", p_string); */
    strcpy(varname, Name);
    len = strlen(varname);
    pi = e_pos;
    s_pos = pi - len;
    StorVar(varname);     /* save array name */
  /**/
    if(check_VarName(varname) != 0)
    {   a_bort(ab_code,x);
    }
    if(check_arrayName(varname) == 0)
    {   x_write_str("\t");
        x_write_str(varname);
        x_writeln("\t\tDD\t?");
        x_writeln("\t\t\tDW\t61\tdup(?)");
    }
    Sav_ObjName(varname, type, 1);
/* printf("%s", p_string); */
}
/*---------- end Fix_VarArray2 ----------*/


void Fix_VarArray(char *Name)
{   char ch, varname[VAR_NAME];
    int pi, len;

    strcpy(varname, Name);
    len = strlen(varname);
    pi = e_pos;
    s_pos = pi - len;
    ch = p_string[pi];
  /**/
    if(strchr("%!#@&", ch))
    {   p_string[pi] = ' ';
        StorVar(varname);    /* save array name */
    }
}
/*---------- end Fix_VarArray ----------*/


int relocate(int pi, int px)
{   char ch;
    int mark, len;

    len = strlen(p_string);
    p_string[px] = '(';
    px++;
    pi = get_digit(pi, len);
    ch = p_string[pi];
    while(isdigit(ch))
    {   p_string[px] = ch;
        px++;
        pi++;
        ch = p_string[pi];
    }
    p_string[px] = ')';
    px++;
    mark = px;
    while(ch != '\0')
    {   p_string[px] = ch;
        px++;
        pi++;
        ch = p_string[pi];
    }
    p_string[px] = '\0';
  /**/
/* --- save p_string to array --- */
    strcpy(array1[line_ndx], p_string);     /* store to array */
    e_pos = mark;
    return mark;
}
/*---------- end relocate ----------*/


void Fix_StrArray3(char *Name, int len)
{   char ch, varname[VAR_NAME];
    int pi, xcnt, ab_code=26, x=line_ndx;

    strcpy(varname, Name);
    Fix_StrArray(varname);
  /**/
    if(check_VarName(varname) != 0)
    {   a_bort(ab_code, x);
    }
    if(check_arrayName(varname) == 0)  /* register array-name */
    {   x_write_str("\t");
        x_write_str(varname);
        x_writeln("\t\tDD\t?");
        x_writeln("\t\t\tDW\t61\tdup(?)");
   /**/
        pi = e_pos;
        pi = get_paren(pi, len);
        s_pos = pi;
        xcnt = get_paramsCount(pi, len);    /* get params count */
        Sav_ObjName(varname, 6, xcnt);  /* save object name */
        pi++;
        pi = get_paren(pi, len);
        pi++;
        e_pos = pi;
    }
}
/*---------- end Fix_StrArray3 ----------*/


void Fix_VarArray3(char *Name, int type, int len)
{   char ch, varname[VAR_NAME];
    int pi, xcnt, ab_code=26, x=line_ndx;

    strcpy(varname, Name);
    Fix_VarArray(varname);
  /**/
    if(check_VarName(varname) != 0)
    {   a_bort(ab_code, x);
    }
    if(check_arrayName(varname) == 0)  /* register array-name */
    {   x_write_str("\t");
        x_write_str(varname);
        x_writeln("\t\tDD\t?");
        x_writeln("\t\t\tDW\t61\tdup(?)");
  /**/
        pi = e_pos;
        pi = get_paren(pi, len);
        s_pos = pi;
        xcnt = get_paramsCount(pi, len);  /* get params count */
        Sav_ObjName(varname, type, xcnt);  /* save object name */
    }
}
/*---------- end Fix_VarArray3 ----------*/


/* bxbasm : Asmfunct.c : alpha version */
/* ----- function prototypes ----- */
//#include "prototyp.h"


void Do_functions()
{
    if(stringcopy == 1)
    {   copystrng_bffr();
    }
    if(asnchrstr == 1)
    {   func_chrstr();
    }
    if(asnleftstr == 1)
    {   func_leftstr();
    }
    if(asnrightstr == 1)
    {   func_rightstr();
    }
    if(asnmidstr == 1)
    {   func_midstr();
    }
    if(asnspacestr == 1)
    {   func_spacestr();
    }
    if(asnstrsIval == 1)
    {   func_strsIval();
    }
    if(asnstrsFval == 1)
    {   func_strsFval();
    }
    if(asnstringstr == 1)
    {   func_stringstr();
    }
    if(asninkeystr == 1)
    {   func_inkeystr();
    }
    if(asninputstr == 1)
    {   func_inputstr();
    }
    if(asnmkdstr == 1)
    {   func_mkdstr();
    }
    if(asnmkistr == 1)
    {   func_mkistr();
    }
    if(resetcursor == 1)
    {   func_resetcursor();
        func_wherexy();
    }
    if(getsysdate == 1)
    {   func_getsysdate();
    }
    if(getsystime == 1)
    {   func_getsystime();
    }
    if(asndatestr == 1)
    {   func_datestr();
    }
    if(asntimestr == 1)
    {   func_timestr();
    }
    if(filecloseall == 1)
    {   func_closeallfiles();
    }
    if(closeafile == 1)
    {   func_closeafile();
    }
    if(getfilehandle == 1)
    {   func_getfilehandle();
    }
    if(clearstrngbffr == 1)
    {   func_clearstrng_bffr();
    }
    if(setupiobuffer == 1)
    {   func_setupiobuffer();
    }
    if(asnlsetstr == 1)
    {   func_lsetstr();
    }
    if(asnrsetstr == 1)
    {   func_rsetstr();
    }
    if(clearallvars == 1)
    {   func_clear_allvars();
    }
    if(clearstrvar == 1)
    {   func_clearstrvar();
    }
    if(clearintvar == 1)
    {   func_clearintvar();
    }
    if(clearfltvar == 1)
    {   func_clearfltvar();
    }
    if(clearLngstrngbffr == 1)
    {   func_clearLngstrng_bffr();
    }
    if(movstrngbffr == 1)
    {   func_movstrng_bffr();
    }
    if(readintstr == 1)
    {   func_readintstr();
    }
    if(readfltstr == 1)
    {   func_readfltstr();
    }
    if(getfilelength == 1)
    {   func_getfilelength();
    }
    if(setcolortext == 1)
    {   func_setcolortext();
    }
    if(readQintstr == 1)
    {   func_readQintstr();
    }
    if(asnmkqstr == 1)
    {   func_mkqstr();
    }
    if(dimstrarray == 1)
    {   func_dimstrarray();
    }
    if(getArryOffst == 1)
    {   func_getArryOffst();
    }
    if(dblArryElement == 1)
    {   func_dblArryElement();
    }
    if(quadArryElement == 1)
    {   func_quadArryElement();
    }
    if(freeArray == 1)
    {   func_freeArray();
    }


 /**/
    Do_initialize();
}
/*---------- end Do_functions ----------*/




void func_freeArray()
{      /* enters: ESI = array base address */
    writeln("; --------------------------------------------------");
    writeln("freeArray proc");
    writeln("; --------------------------------------------------");
    writeln("  mov  eax, [esi]");
    writeln("  .if eax == 0");
    writeln("    jmp freearry_end");  /* array is free */
    writeln("  .endif");
    writeln("  push esi");   /* save the array pointer */
    writeln("  mov  edi, esi");
    writeln("  add  edi, 4");   /* this is the param count */
    writeln("  mov  cx, word ptr [edi]");
    writeln("  dec  cx");
    writeln("  mov  ch, 0");
    writeln("  add  edi, 2");
    writeln("  xor  eax, eax");
    writeln("  mov  ax, word ptr [edi]");
    writeln("@@:");
    writeln("  .if ch < cl");
    writeln("    add  edi, 2");
    writeln("    mov  bx, word ptr [edi]");
    writeln("    mul  bx");
    writeln("    inc  ch");
    writeln("    jmp  @B");
    writeln("  .endif");
    writeln("  xor  ecx, ecx");
    writeln("  mov  ebx, eax");
    writeln("  pop  esi");
    writeln("  push esi");
    writeln("  mov  edi, [esi]");
    writeln("@@:");
    writeln("  .if ecx < ebx");
    writeln("    mov  eax, [edi]");
    writeln("    .if eax != 0");
    writeln("      pushad");
    writeln("      invoke free, eax");
    writeln("      popad");
    writeln("    .endif");
    writeln("    add  edi, 4");
    writeln("    inc  ecx");
    writeln("    jmp @B");
    writeln("  .endif");
    writeln("  pop  esi");
    writeln("  push esi");
    writeln("  mov  edi, [esi]");
    writeln("  invoke free, edi");
    writeln("  pop  esi");
    writeln("  mov  [esi], dword ptr 0");
    writeln("freearry_end:");
    writeln("  ret");
    writeln("  ; --------------------------------------------------");
    writeln("freeArray endp");
    writeln("; =========================================================================");
}
/*---------- end func_freeArray ----------*/


void func_quadArryElement()
{  /* enters: EDI = this element's address */
    writeln("; --------------------------------------------------");
    writeln("quadArryElement proc");
    writeln("; --------------------------------------------------");
    writeln("  push edi");
    writeln("  mov  eax, [edi]");
    writeln("  .if eax != 0");
    writeln("    invoke free, eax");
    writeln("  .endif");
    writeln("  mov  eax, 8");
    writeln("  invoke malloc, eax");
    writeln("  pop  edi");
    writeln("  mov  [edi], eax");
    writeln("  ret");
    writeln("  ; --------------------------------------------------");
    writeln("quadArryElement endp");
    writeln("; =========================================================================");
}
/*---------- end func_quadArryElement ----------*/


void func_dblArryElement()
{  /* enters: EDI = this element's address */
    writeln("; --------------------------------------------------");
    writeln("dblArryElement proc");
    writeln("; --------------------------------------------------");
    writeln("  push edi");
    writeln("  mov  eax, [edi]");
    writeln("  .if eax != 0");
    writeln("    invoke free, eax");
    writeln("  .endif");
    writeln("  mov  eax, 4");
    writeln("  invoke malloc, eax");
    writeln("  pop  edi");
    writeln("  mov  [edi], eax");
    writeln("  ret");
    writeln("  ; --------------------------------------------------");
    writeln("dblArryElement endp");
    writeln("; =========================================================================");
}
/*---------- end func_dblArryElement ----------*/


void func_getArryOffst()
{  /* enters: ESI = array base address, ESI = params address */
    writeln("; --------------------------------------------------");
    writeln("getArryOffst proc");
    writeln("; --------------------------------------------------");
    writeln("  xor  eax, eax");
    writeln("  xor  ecx, ecx");
    writeln("@@:");
    writeln("  mov  cx, word ptr [esi]");
    writeln("  .if cx != 0");
    writeln("    add  edi, 2");
    writeln("    mov  bx, word ptr [edi]");
    writeln("    dec  cx");
    writeln("    add  eax, ecx");
    writeln("    mul  bx");
    writeln("    add  esi, 2");
    writeln("    jmp  @B");
    writeln("  .endif");
    writeln("  add  esi, 2");
    writeln("  mov  cx, word ptr [esi]");
    writeln("  dec  cx");
    writeln("  add  eax, ecx");
    writeln("  mov  ebx, 4");
    writeln("  mul  bx");  /* EAX = offset */
    writeln("  ret");
    writeln("  ; --------------------------------------------------");
    writeln("getArryOffst endp");
    writeln("; =========================================================================");
}
/*---------- end func_getArryOffst ----------*/


void func_dimstrarray()
{      /* enters: ESI = pointer address */
    writeln("; --------------------------------------------------");
    writeln("dimstrarray proc");
    writeln("; --------------------------------------------------");
    writeln("  push esi");
    writeln("  mov  edi, esi");
    writeln("  add  edi, 4");
    writeln("  mov  cx, word ptr [edi]");
    writeln("  dec  cx");
    writeln("  mov  ch, 0");
    writeln("  add  edi, 2");
    writeln("  mov  ax, word ptr [edi]");
    writeln("@@:");
    writeln("  .if ch < cl");
    writeln("    add  edi, 2");
    writeln("    mov  bx, word ptr [edi]");
    writeln("    mul  bx");
    writeln("    inc  ch");
    writeln("    jmp  @B");
    writeln("  .endif");
    writeln("  mov  ebx, 4");
    writeln("  mul  bx");
    writeln("  inc  eax");
    writeln("  push eax");
    writeln("  invoke malloc, eax");
    writeln("  pop  ebx");
    writeln("  pop  esi");
    writeln("  mov  [esi], eax"); /* ESI points to array of pointers */
    writeln("  invoke memset, eax, 0, ebx");
    writeln("  ret");
    writeln("  ; --------------------------------------------------");
    writeln("dimstrarray endp");
    writeln("; =========================================================================");
}
/*---------- end func_dimstrarray ----------*/


void func_setcolortext()
{
    writeln("; --------------------------------------------------");
    writeln("setcolortext proc");  /* enters: EAX=foregrnd, EBX=bkgrnd */
    writeln("; --------------------------------------------------");
    writeln("  mov  ecx, eax");
    writeln("  mov  eax, 16");
    writeln("  mul  bx");
    writeln("  or   eax, ecx");
    writeln("  invoke SetConsoleTextAttribute, hStdHandle, eax");
    writeln("  ret");
    writeln("  ; --------------------------------------------------");
    writeln("setcolortext endp");
    writeln("; =========================================================================");
}
/*---------- end func_setcolortext ----------*/


void func_getfilelength()
{
    writeln("; --------------------------------------------------");
    writeln("getfilelength proc "); /* enters: EAX = (fptr) */
    writeln("; --------------------------------------------------");
    writeln("  call getfilehandle");
    writeln("  push eax");   /* save File PTR */
    writeln("  invoke ftell, eax");  /* get current offset */
    writeln("  mov  ecx, eax");  /* and save it */
    writeln("  pop  eax");   /* load fptr */
    writeln("  push ecx");   /* save current offset */
    writeln("  push eax");   /* save File PTR */
    writeln("  invoke fseek, eax, 0, SEEK_END");
    writeln("  pop  eax");   /* load fptr */
    writeln("  push eax");   /* save File PTR */
    writeln("  invoke ftell, eax");
    writeln("  mov  iLVAR, eax");  /* integer value is in eax */
    writeln("  FILD iLVAR");
    writeln("  pop  eax");   /* load fptr */
    writeln("  pop  ecx");   /* reload current offset */
    writeln("  invoke fseek, eax, ecx, SEEK_SET");
    writeln("  ret");
    writeln("  ; --------------------------------------------------");
    writeln("getfilelength endp");
    writeln("; =========================================================================");
}
/*---------- end func_getfilelength ----------*/


void func_readQintstr()
{ /* extract a quad integer value from a file INPUT or READ */
    writeln("; --------------------------------------------------");
    writeln("readQintstr proc ");
    writeln("; --------------------------------------------------");
    writeln("  push edi");
    writeln("  FLDZ");
    writeln("  FISTP qword ptr [edi]");
    writeln("  mov  edi, offset FltString");
    writeln("  push edi");
    writeln("  xor  eax, eax");
    writeln("@@:");
    writeln("  mov  al, byte ptr [esi]");
    writeln("  .if al != ',' && al != 10 && al != 0");
    writeln("    mov  [edi], al");
    writeln("    mov  [esi], ah");
    writeln("    inc  esi");
    writeln("    inc  edi");
    writeln("    jmp  @B");
    writeln("  .endif");
    writeln("  mov  [edi], ah");  /* add '\0' terminator */
    writeln("  inc  esi");
    writeln("  mov  integer, esi");
    writeln("  pop  eax");
    writeln("  pop  edi");
    writeln("  push edi");
    writeln("  invoke StrToFloat, eax, edi");
    writeln("  pop  edi");
    writeln("  FLD qword ptr [edi]");
    writeln("  FISTP qword ptr [edi]");
    writeln("  mov  esi, integer");        /* ESI = iobuffer address */
    writeln("  ret");
    writeln("  ; --------------------------------------------------");
    writeln("readQintstr endp");
    writeln("; =========================================================================");
}
/*---------- end func_readQintstr ----------*/


void func_readfltstr()
{ /* extract a float value from a file INPUT or READ */
    writeln("; --------------------------------------------------");
    writeln("readfltstr proc ");
    writeln("; --------------------------------------------------");
    writeln("  push edi");
    writeln("  FLDZ");
    writeln("  FSTP qword ptr [edi]");
    writeln("  mov  edi, offset FltString");
    writeln("  push edi");
    writeln("  xor  eax, eax");
    writeln("@@:");    /* integer number */
    writeln("  mov  al, byte ptr [esi]");
    writeln("  .if al != ',' && al != 10 && al != 0 && al != '.'");
    writeln("    mov  [edi], al");
    writeln("    mov  [esi], ah");
    writeln("    inc  esi");
    writeln("    inc  edi");
    writeln("    jmp  @B");
    writeln("  .endif");
    writeln("  .if al == '.'");
    writeln("@@:");    /* fractional number */
    writeln("    mov  al, byte ptr [esi]");
    writeln("    .if al != ',' && al != 10 && al != '0'");
    writeln("      mov  [edi], al");
    writeln("      mov  [esi], ah");
    writeln("      inc  esi");
    writeln("      inc  edi");
    writeln("      jmp  @B");
    writeln("    .endif");
    writeln("  .endif");
    writeln("  .if al == '0'");
    writeln("@@:");    /* trailing zeros */
    writeln("    mov  al, byte ptr [esi]");
    writeln("    .if al != ',' && al != 10");
    writeln("      mov  [esi], ah");
    writeln("      inc  esi");
    writeln("      jmp  @B");
    writeln("    .endif");
    writeln("  .endif");
    writeln("  mov  [edi], ah");  /* add '\0' terminator */
    writeln("  inc  esi");
    writeln("  mov  integer, esi");
    writeln("  pop  eax");
    writeln("  pop  edi");
    writeln("  invoke StrToFloat, eax, edi");
    writeln("  mov  esi, integer");       /* ESI = iobuffer address */
    writeln("  ret");
    writeln("  ; --------------------------------------------------");
    writeln("readfltstr endp");
    writeln("; =========================================================================");
}
/*---------- end func_readfltstr ----------*/


void func_readintstr()
{ /* extract an integer value from a file INPUT or READ */
    writeln("; --------------------------------------------------");
    writeln("readintstr proc ");
    writeln("; --------------------------------------------------");
    writeln("  push edi");
    writeln("  FLDZ");
    writeln("  FISTP dword ptr [edi]");
    writeln("  mov  edi, offset IntString");
    writeln("  push edi");
    writeln("  xor  eax, eax");
    writeln("@@:");
    writeln("  mov  al, byte ptr [esi]");
    writeln("  .if al != ',' && al != 10 && al != 0");
    writeln("    mov  [edi], al");
    writeln("    mov  [esi], ah");
    writeln("    inc  esi");
    writeln("    inc  edi");
    writeln("    jmp  @B");
    writeln("  .endif");
    writeln("  mov  [edi], ah");  /* add '\0' terminator */
    writeln("  inc  esi");
    writeln("  mov  integer, esi");
    writeln("  pop  eax");
    writeln("  invoke atodw, eax");
    writeln("  pop  edi");
    writeln("  mov  [edi], eax");
    writeln("  mov  esi, integer");        /* ESI = iobuffer address */
    writeln("  ret");
    writeln("  ; --------------------------------------------------");
    writeln("readintstr endp");
    writeln("; =========================================================================");
}
/*---------- end func_readintstr ----------*/


void func_movstrng_bffr()
{ /* extract a character string from a file INPUT or READ */
    writeln("; --------------------------------------------------");
    writeln("movstrng_bffr proc "); /* enter: ESI=buffer, EDI=destination */
    writeln("; --------------------------------------------------");
    writeln("  call clearstrng_bffr");
    writeln("  push eax");  /* push string address */
    writeln("  mov  edi, eax");
    writeln("  xor  eax, eax");
    writeln("@@:");
    writeln("  mov  al, byte ptr [esi]");
    writeln("  .if al != ',' && al != 10 && al != 0");
    writeln("    mov  [edi], al");
    writeln("    mov  [esi], ah");
    writeln("    inc  esi");
    writeln("    inc  edi");
    writeln("    jmp  @B");
    writeln("  .endif");
    writeln("  mov  [edi], ah");  /* add '\0' terminator */
    writeln("  inc  esi");
    writeln("  mov  integer, esi");
    writeln("  pop  eax");
    writeln("  ret");
    writeln("  ; --------------------------------------------------");
    writeln("movstrng_bffr endp");
    writeln("; =========================================================================");
}
/*---------- end func_movstrng_bffr ----------*/


void func_clearfltvar()
{
    writeln("; --------------------------------------------------");
    writeln("clearfltvar proc ");
    writeln("; --------------------------------------------------");
    writeln("  mov  eax, 0");
    writeln("  mov  [esi], eax");
    writeln("  add  esi, 4");
    writeln("  mov  [esi], eax");
    writeln("  ret");
    writeln("  ; --------------------------------------------------");
    writeln("clearfltvar endp");
    writeln("; =========================================================================");
}
/*---------- end func_clearfltvar ----------*/


void func_clearintvar()
{
    writeln("; --------------------------------------------------");
    writeln("clearintvar proc ");
    writeln("; --------------------------------------------------");
    writeln("  mov  eax, 0");
    writeln("  mov  [esi], eax");
    writeln("  ret");
    writeln("  ; --------------------------------------------------");
    writeln("clearintvar endp");
    writeln("; =========================================================================");
}
/*---------- end func_clearintvar ----------*/


void func_clearstrvar()
{
    writeln("; --------------------------------------------------");
    writeln("clearstrvar proc ");
    writeln("; --------------------------------------------------");
    writeln("  mov  edi, [esi]\t\t\t; clear string variable");
    writeln("  .if edi != 0");
    writeln("    pushad");
    writeln("    invoke free, edi");
    writeln("    popad");
    writeln("    mov  eax, 0");
    writeln("    mov  [esi], eax");
    writeln("  .endif");
    writeln("  ret");
    writeln("  ; --------------------------------------------------");
    writeln("clearstrvar endp");
    writeln("; =========================================================================");
}
/*---------- end func_clearstrvar ----------*/



void func_clear_allvars()
{
    writeln("; --------------------------------------------------");
    writeln("clear_allvars proc ");
    writeln("; --------------------------------------------------");
    writeln("  mov  esi, _var_start");
    writeln("  mov  edi, _int_start\t\t; clear strings");
    writeln("  mov  ecx, 0");
    writeln("  add  esi, 4");
    writeln("@@:");
    writeln("  .if esi < edi");
    writeln("    mov  eax, [esi]");
    writeln("    .if eax != 0");
    writeln("      pushad");
    writeln("      invoke free, eax");
    writeln("      popad");
    writeln("      mov  [esi], ecx");
    writeln("    .endif");
    writeln("    add  esi, 4");
    writeln("    jmp  @B");
    writeln("  .endif");
    writeln("  mov  edi, _flt_start\t\t; clear integers");
    writeln("  add  esi, 4");
    writeln("@@:");
    writeln("  .if esi < edi");
    writeln("    mov  [esi], ecx");
    writeln("    add  esi, 4");
    writeln("    jmp  @B");
    writeln("  .endif");
    writeln("  mov  edi, _var_endzz\t\t; clear floats");
    writeln("  add  esi, 4");
    writeln("@@:");
    writeln("  .if esi < edi");
    writeln("    mov  [esi], ecx");
    writeln("    add  esi, 4");
    writeln("    mov  [esi], ecx");
    writeln("    add  esi, 4");
    writeln("    jmp  @B");
    writeln("  .endif");
    writeln("  ret");
    writeln("  ; --------------------------------------------------");
    writeln("clear_allvars endp");
    writeln("; =========================================================================");
}
/*---------- end func_clear_allvars ----------*/


void func_rsetstr()
{
    writeln("; --------------------------------------------------");
    writeln("rsetstr proc"); /* enter with: EDX = [field length] */
    writeln("; --------------------------------------------------");
    writeln("  pushad");
    writeln("  invoke strlen, esi        ; get source length");
    writeln("  mov  iLVAR, eax");
    writeln("  popad");
    writeln("  mov  eax, iLVAR");
    writeln("  dec  edx");
    writeln(";===========================");
    writeln("  .if eax >= edx            ; if source >= destination");
    writeln("    mov  ecx, 0");
    writeln("@@:");
    writeln("    .if ecx < edx");
    writeln("      mov  al, byte ptr [esi]");
    writeln("      mov  [edi], al");
    writeln("      inc  esi");
    writeln("      inc  edi");
    writeln("      inc  ecx");
    writeln("      jmp  @B");
    writeln("    .endif");
    writeln(";===========================");
    writeln("  .elseif eax < edx");
    writeln("    push edx");
    writeln("    sub  edx, eax");
    writeln("    mov  ebx, edx");
    writeln("    mov  ecx, 0");
    writeln("    mov  eax, 32");
    writeln("@@:");
    writeln("    .if ecx < ebx");
    writeln("      mov  [edi], al");
    writeln("      inc  edi");
    writeln("      inc  ecx");
    writeln("      jmp  @B");
    writeln("    .endif");
    writeln("    xor  eax, eax");
    writeln("    pop  edx");
    writeln("@@:");
    writeln("    .if ecx < edx");
    writeln("      mov  al, byte ptr [esi]");
    writeln("      mov  [edi], al");
    writeln("      inc  esi");
    writeln("      inc  edi");
    writeln("      inc  ecx");
    writeln("      jmp  @B");
    writeln("    .endif");
    writeln("  .endif");
    writeln(";===========================");
    writeln("  xor  eax, eax");
    writeln("  mov  [edi], al");
    writeln("  ret");
    writeln("; --------------------------------------------------");
    writeln("rsetstr endp");
    writeln("; =========================================================================");
}
/*---------- end func_rsetstr ----------*/


void func_lsetstr()
{
    writeln("; --------------------------------------------------");
    writeln("lsetstr proc"); /* enter with: EDX = [field length] */
    writeln("; --------------------------------------------------");
    writeln("  pushad");
    writeln("  invoke strlen, esi        ; get source length");
    writeln("  mov  iLVAR, eax");
    writeln("  popad");
    writeln("  mov  eax, iLVAR");
    writeln("  dec  edx");
    writeln(";===========================");
    writeln("  .if eax >= edx            ; if source >= destination");
    writeln("    mov  ecx, 0");
    writeln("@@:");
    writeln("    .if ecx < edx");
    writeln("      mov  al, byte ptr [esi]");
    writeln("      mov  [edi], al");
    writeln("      inc  esi");
    writeln("      inc  edi");
    writeln("      inc  ecx");
    writeln("      jmp  @B");
    writeln("    .endif");
    writeln(";===========================");
    writeln("  .elseif eax < edx");
    writeln("    push edx");
    writeln("    mov  edx, eax");
    writeln("    mov  ecx, 0");
    writeln("@@:");
    writeln("    .if ecx < edx");
    writeln("      mov  al, byte ptr [esi]");
    writeln("      mov  [edi], al");
    writeln("      inc  esi");
    writeln("      inc  edi");
    writeln("      inc  ecx");
    writeln("      jmp  @B");
    writeln("    .endif");
    writeln("    pop edx");
    writeln("    mov  al, 32");
    writeln("@@:");
    writeln("    .if ecx < edx");
    writeln("      mov  [edi], al");
    writeln("      inc  edi");
    writeln("      inc  ecx");
    writeln("      jmp  @B");
    writeln("    .endif");
    writeln("  .endif");
    writeln(";===========================");
    writeln("  xor  eax, eax");
    writeln("  mov  [edi], al");
    writeln("  ret");
    writeln("; --------------------------------------------------");
    writeln("lsetstr endp");
    writeln("; =========================================================================");
}
/*---------- end func_lsetstr ----------*/



void func_setupiobuffer()
{
    writeln("; --------------------------------------------------");
    writeln("setupiobuffer proc");
    writeln("; --------------------------------------------------");
    writeln("  push eax");
    writeln("  mov  eax, [edi]");
    writeln("  .if eax != 0");
    writeln("    invoke free, eax");
    writeln("  .endif");
    writeln("  pop  eax");
    writeln("  inc  eax");
    writeln("  invoke malloc, eax");
    writeln("  mov  [edi], eax");
    writeln("  ret");
    writeln("; --------------------------------------------------");
    writeln("setupiobuffer endp");
    writeln("; =========================================================================");
}
/*---------- end func_setupiobuffer ----------*/


void func_clearLngstrng_bffr()
{
    writeln("; --------------------------------------------------");
    writeln("clearLngstrng_bffr proc ");
    writeln("; --------------------------------------------------");
    writeln("  push  esi");  /* enter: ESI = addr varname */
    writeln("  .if edi == 0");   /* EDI = ptr *string */
    writeln("    mov  eax, BUFSIZE");
    writeln("    invoke malloc, eax");
    writeln("  .else");
    writeln("    push edi");
    writeln("    invoke _msize, edi");
    writeln("    pop  edi");
    writeln("    .if eax < BUFSIZE");
    writeln("      invoke realloc, edi, BUFSIZE");
    writeln("    .else");
    writeln("      mov  eax, edi");
    writeln("    .endif");
    writeln("  .endif");
    writeln("  pop  esi");
    writeln("  mov  [esi], eax");
    writeln("  ret");   /* exit: EAX = ptr *string */
    writeln("  ; --------------------------------------------------");
    writeln("clearLngstrng_bffr endp");
    writeln("; =========================================================================");
}
/*---------- end func_clearLngstrng_bffr ----------*/


void func_clearstrng_bffr()
{
    writeln("; --------------------------------------------------");
    writeln("clearstrng_bffr proc ");
    writeln("; --------------------------------------------------");
    writeln("  .if edi != 0");
    writeln("    invoke free, edi");
    writeln("  .endif");
    writeln("  invoke malloc, BUFFR_SIZ");
    writeln("  ret");
    writeln("  ; --------------------------------------------------");
    writeln("clearstrng_bffr endp");
    writeln("; =========================================================================");
}
/*---------- end func_clearstrng_bffr ----------*/


void func_getfilehandle()
{
    writeln("; --------------------------------------------------");
    writeln("getfilehandle proc ");
    writeln("; --------------------------------------------------");
    writeln("  mov  ebx, 4");
    writeln("  mul  bl");
    writeln("  mov  edi, offset iohandles");
    writeln("  add  edi, eax");
    writeln("  mov  eax, [edi]");
    writeln("  ret");
    writeln("  ; --------------------------------------------------");
    writeln("getfilehandle endp");
    writeln("; =========================================================================");
}
/*---------- end func_getfilehandle ----------*/


void func_closeafile()
{
    writeln("; --------------------------------------------------");
    writeln("closeafile proc ");
    writeln("; --------------------------------------------------");
    writeln("  mov  edi, offset iohandles");
    writeln("  mov  esi, offset iobuffers");
    writeln("  mov  ebx, 4");
    writeln("  mul  bl");
    writeln("  push eax");
    writeln("  add  edi, eax");
    writeln("  mov  eax, [edi]");
    writeln("  invoke fclose, eax");
    writeln("  mov  eax, 0");
    writeln("  mov  [edi], eax");
    writeln("  pop  eax");
    writeln("  add  esi, eax");
    writeln("  mov  eax, [esi]");
    writeln("  invoke free, eax");
    writeln("  mov  eax, 0");
    writeln("  mov  [esi], eax");
    writeln("  ret");
    writeln("  ; --------------------------------------------------");
    writeln("closeafile endp");
    writeln("; =========================================================================");
}
/*---------- end func_closeafile ----------*/


void func_closeallfiles()
{
    writeln("; --------------------------------------------------");
    writeln("closeallfiles proc ");
    writeln("; --------------------------------------------------");
    writeln("  call _fcloseall");
    writeln("  mov  edi, offset iohandles");
    writeln("  mov  esi, offset iobuffers");
    writeln("  mov  ecx, 98");
    writeln("  xor  ebx, ebx");
    writeln("  xor  eax, eax");
    writeln("close_all:");
    writeln("  .if ebx <= ecx");
    writeln("    mov  edx, [edi]");
    writeln("    .if edx != 0");
    writeln("      mov  [edi], eax");
    writeln("      mov  edx, [esi]");
    writeln("      pushad");
    writeln("      invoke free, edx");
    writeln("      popad");
    writeln("      mov  [esi], eax");
    writeln("    .endif");
    writeln("    add  edi, 4");
    writeln("    add  esi, 4");
    writeln("    inc  ebx");
    writeln("    jmp  close_all");
    writeln("  .endif");
    writeln("  ret");
    writeln("  ; --------------------------------------------------");
    writeln("closeallfiles endp");
    writeln("; =========================================================================");
}
/*---------- end func_closeallfiles ----------*/


void func_timestr()
{
    writeln("; --------------------------------------------------");
    writeln("timestr proc ");
    writeln("; --------------------------------------------------");
    writeln("  LOCAL  colon[2]:BYTE");
    writeln("; --------------------------------------------------");
    writeln("  mov  colon, byte ptr 58");
    writeln("  mov  colon+1, byte ptr 0");
    writeln("  call get_sys_time");
    writeln("  mov  edi, offset BffrInput");
    writeln("  FILD  iHour");
    writeln("  FISTP  integer");
    writeln("  invoke dwtoa, integer, addr IntString");
    writeln("  invoke strcpy, edi, addr IntString");
    writeln("  invoke strcat, edi, addr colon");
    writeln("  FILD  iMinute");
    writeln("  FISTP  integer");
    writeln("  invoke dwtoa, integer, addr IntString");
    writeln("  invoke strcat, edi, addr IntString");
    writeln("  invoke strcat, edi, addr colon");
    writeln("  FILD  iSecond");
    writeln("  FISTP  integer");
    writeln("  invoke dwtoa, integer, addr IntString");
    writeln("  invoke strcat, edi, addr IntString");
    writeln("  invoke strcat, edi, addr colon");
    writeln("  FILD  iMilli");
    writeln("  FISTP  integer");
    writeln("  invoke dwtoa, integer, addr IntString");
    writeln("  invoke strcat, edi, addr IntString");
    writeln("  mov  esi, offset BffrInput");
    writeln("  ret");
    writeln("  ; --------------------------------------------------");
    writeln("timestr endp");
    writeln("; =========================================================================");
}
/*---------- end func_timestr ----------*/


void func_datestr()
{
    writeln("; --------------------------------------------------");
    writeln("datestr proc ");
    writeln("; --------------------------------------------------");
    writeln("  LOCAL  slash[2]:BYTE");
    writeln("; --------------------------------------------------");
    writeln("  mov  slash, byte ptr 47");
    writeln("  mov  slash+1, byte ptr 0");
    writeln("  call get_sys_date");
    writeln("  mov  edi, offset BffrInput");
    writeln("  FILD  iMonth");
    writeln("  FISTP  integer");
    writeln("  invoke dwtoa, integer, addr IntString");
    writeln("  invoke strcpy, edi, addr IntString");
    writeln("  invoke strcat, edi, addr slash");
    writeln("  FILD  iDay");
    writeln("  FISTP  integer");
    writeln("  invoke dwtoa, integer, addr IntString");
    writeln("  invoke strcat, edi, addr IntString");
    writeln("  invoke strcat, edi, addr slash");
    writeln("  FILD  iYear");
    writeln("  FISTP  integer");
    writeln("  invoke dwtoa, integer, addr IntString");
    writeln("  invoke strcat, edi, addr IntString");
    writeln("  mov  esi, offset BffrInput");
    writeln("  ret");
    writeln("  ; --------------------------------------------------");
    writeln("datestr endp");
    writeln("; =========================================================================");
}
/*---------- end func_datestr ----------*/


void func_getsysdate()
{
    writeln("; =========================================================================");
    writeln("get_sys_date  proc");
    writeln("  ; --------------------------------------------------");
    writeln("  invoke  GetLocalTime, addr system_time               ;Get Local Time");
    writeln("  xor  eax, eax");
    writeln("  mov  ax, system_time.wYear");
    writeln("  mov  iYear, eax");
    writeln("  mov  ax, system_time.wMonth");
    writeln("  mov  iMonth, eax");
    writeln("  mov  ax, system_time.wDay");
    writeln("  mov  iDay, eax");
    writeln("  ret");
    writeln("  ; --------------------------------------------------");
    writeln("get_sys_date  endp");
    writeln("; =========================================================================");
}
/*---------- end func_getsysdate ----------*/


void func_getsystime()
{
    writeln("; =========================================================================");
    writeln("get_sys_time  proc");
    writeln("  ; --------------------------------------------------");
    writeln("  invoke  GetLocalTime, addr system_time               ;Get Local Time");
    writeln("  xor  eax, eax");
    writeln("  mov  ax, system_time.wHour");
    writeln("  mov  iHour, eax");
    writeln("  mov  ax, system_time.wMinute");
    writeln("  mov  iMinute, eax");
    writeln("  mov  ax, system_time.wSecond");
    writeln("  mov  iSecond, eax");
    writeln("  mov  ax, system_time.wMilliseconds");
    writeln("  mov  iMilli, eax");
    writeln("  ret");
    writeln("  ; --------------------------------------------------");
    writeln("get_sys_time  endp");
    writeln("; =========================================================================");
}
/*---------- end func_getsystime ----------*/


void func_resetcursor()
{
    writeln("; --------------------------------------------------");
    writeln("reset_cursor proc ");
    writeln("; --------------------------------------------------");
    writeln("  invoke strlen, addr BffrInput");
    writeln("  add  iCOL, eax");
    writeln("  invoke locate, iCOL, iROW");
    writeln("  ret");
    writeln("  ; --------------------------------------------------");
    writeln("reset_cursor endp");
    writeln("; =========================================================================");
}
/*---------- end func_resetcursor ----------*/


void func_wherexy()
{
    writeln("; --------------------------------------------------");
    writeln("wherexy proc ");
    writeln("; --------------------------------------------------");
    writeln(".data");
    writeln("\tfname   db  'CONOUT$',0");
    writeln("\tfaccess dd  GENERIC_READ or GENERIC_WRITE");
    writeln("\tfsmode  dd  FILE_SHARE_READ or FILE_SHARE_WRITE");
    writeln("\tfmode   dd  OPEN_EXISTING");
    writeln("\tfattrib dd  0");
    writeln("\tfhtemp  dd  NULL");
    writeln(".data?");
    writeln("\tfsecur  dd  ?");
    writeln("\tfHandle dd  ?");
    writeln("\tfcsbi   dd  ?");
    writeln("\tfcoord  dd  ?");
    writeln(".code");
    writeln("  mov  eax, sa.bInheritHandle");
    writeln("  mov  fsecur, eax");
    writeln("  lea  eax, csbi");
    writeln("  mov  fcsbi, eax");
    writeln("  invoke CreateFile, addr fname, faccess, fsmode, fsecur, fmode, fattrib, fhtemp");
    writeln("  mov  fHandle, eax");
    writeln("  invoke GetConsoleScreenBufferInfo, fHandle, fcsbi");
    writeln("  .if eax == -1");
    writeln("    xor  eax, eax");
    writeln("  .else");
    writeln("    mov  eax, csbi.dwCursorPosition");
    writeln("  .endif");
    writeln("  mov  fcoord, eax");
    writeln("  invoke CloseHandle, fHandle");
    writeln("  LOWORD  fcoord");
    writeln("  mov  iCOL, eax");
    writeln("  HIWORD  fcoord");
    writeln("  mov  iROW, eax");
    writeln("  ret");
    writeln("  ; --------------------------------------------------");
    writeln("wherexy endp");
    writeln("; =========================================================================");
}
/*---------- end func_wherexy ----------*/


void func_mkqstr()
{
    writeln("; --------------------------------------------------");
    writeln("mkqstr proc ");
    writeln("; --------------------------------------------------");
    writeln("  FILD qword ptr [esi]");
    writeln("  FISTP qword ptr [edi]");
    writeln("  ret");
    writeln("  ; --------------------------------------------------");
    writeln("mkqstr endp");
    writeln("; =========================================================================");
}
/*---------- end func_mkqstr ----------*/


void func_mkistr()
{
    writeln("; --------------------------------------------------");
    writeln("mkistr proc ");
    writeln("; --------------------------------------------------");
    writeln("  mov  eax, [esi]");
    writeln("  mov  [edi], eax");
    writeln("  ret");
    writeln("  ; --------------------------------------------------");
    writeln("mkistr endp");
    writeln("; =========================================================================");
}
/*---------- end func_mkistr ----------*/


void func_mkdstr()
{
    writeln("; --------------------------------------------------");
    writeln("mkdstr proc ");
    writeln("; --------------------------------------------------");
    writeln("  FLD qword ptr [esi]");
    writeln("  FSTP qword ptr [edi]");
    writeln("  ret");
    writeln("  ; --------------------------------------------------");
    writeln("mkdstr endp");
    writeln("; =========================================================================");
}
/*---------- end func_mkdstr ----------*/


void func_inputstr()
{
    writeln("; --------------------------------------------------");
    writeln("inputstr proc ");
    writeln("; --------------------------------------------------");
    writeln("  LOCAL   ndx :DWORD");
    writeln("  LOCAL count :DWORD");
    writeln("  LOCAL   chr :BYTE");
    writeln("  LOCAL  buff :DWORD");
    writeln("; --------------------------------------------------");
    writeln("  mov  count, eax");
    writeln("  mov  edi, offset BffrInput");
    writeln("  mov  buff, edi");
    writeln("  mov  ndx, 0");
    writeln("  ;");
    writeln("inputstr1:");
    writeln("  mov  eax, ndx");
    writeln("  .if (eax < count)");
    writeln("    call _getche");
    writeln("    mov  chr, al");
    writeln("    mov  edi, buff");
    writeln("    .if (chr > 31) && (chr < 127)");
    writeln("       mov  al, chr");
    writeln("       add  edi, ndx");
    writeln("       mov  [edi], al");
    writeln("       add  ndx, 1");
    writeln("    .elseif (chr==8) && (ndx>0)");
    writeln("       add  edi, ndx");
    writeln("       mov  [edi], byte ptr 0");
    writeln("       sub  ndx, 1");
    writeln("    .elseif (chr==13)");
    writeln("       add  edi, ndx");
    writeln("       mov  [edi], byte ptr 0");
    writeln("       mov  eax, count");
    writeln("       mov  ndx, eax");
    writeln("    .endif");
    writeln("    jmp inputstr1");
    writeln("  .endif");
    writeln("  mov  esi, offset BffrInput");
    writeln("  ret");
    writeln("  ; --------------------------------------------------");
    writeln("inputstr endp");
    writeln("; =========================================================================");
}
/*---------- end func_inputstr ----------*/


void func_inkeystr()
{
    writeln("; --------------------------------------------------");
    writeln("inkeystr proc ");
    writeln("; --------------------------------------------------");
    writeln("  mov  edi, offset BffrInput");
    writeln("  mov  [edi], byte ptr 0");
    writeln("  call _kbhit");    /* call _kbhit    */
    writeln("  .if eax != 0");   /* if eax != NULL */
    writeln("    call _getch");   /* call _getch    */
    writeln("    .if eax == 0");   /* if eax == NULL */
    writeln("      mov  edi, offset BffrInput");
    writeln("      mov  [edi], byte ptr 32");  /* add a space    */
    writeln("      call _getch");   /* call _getch again */
    writeln("      mov  edi, offset BffrInput");
    writeln("      mov  [edi+1], al");
    writeln("      mov  [edi+2], byte ptr 0");
    writeln("    .else");
    writeln("      mov  edi, offset BffrInput");
    writeln("      mov  [edi], al");
    writeln("      mov  [edi+1], byte ptr 0");
    writeln("    .endif");
    writeln("  .endif");
    writeln("  mov  esi, offset BffrInput");
    writeln("  ret");
    writeln("  ; --------------------------------------------------");
    writeln("inkeystr endp");
    writeln("; =========================================================================");
}
/*---------- end func_inkeystr ----------*/


void func_stringstr()
{
    writeln("; --------------------------------------------------");
    writeln("stringstr proc ");
    writeln("; --------------------------------------------------");
    writeln("  mov  edi, offset BffrInput");
    writeln("  push eax");
    writeln("  invoke memset, edi, ebx, eax");
    writeln("  pop  eax");
    writeln("  mov  esi, offset BffrInput");
    writeln("  mov  [esi+eax], byte ptr 0");
    writeln("  ret");
    writeln("  ; --------------------------------------------------");
    writeln("stringstr endp");
    writeln("; =========================================================================");
}
/*---------- end func_stringstr ----------*/


void func_strsFval()
{
    writeln("; --------------------------------------------------");
    writeln("strsFval proc ");
    writeln("; --------------------------------------------------");
    writeln("  mov  edi, offset FltString");
    writeln("  mov  esi, offset format");
    writeln("  invoke sprintf, edi, esi, x87buff");
    writeln("  mov  esi, offset FltString");
    writeln("  ret");
    writeln("  ; --------------------------------------------------");
    writeln("strsFval endp");
    writeln("; =========================================================================");
}
/*---------- end func_strsFval ----------*/


void func_strsIval()
{
    writeln("; --------------------------------------------------");
    writeln("strsIval proc ");
    writeln("; --------------------------------------------------");
    writeln("  mov  edi, offset IntString");
    writeln("  invoke _ltoa, integer, edi, 10");
    writeln("  mov  esi, offset IntString");
    writeln("  ret");
    writeln("  ; --------------------------------------------------");
    writeln("strsIval endp");
    writeln("; =========================================================================");
}
/*---------- end func_strsIval ----------*/


void func_spacestr()
{
    writeln("; --------------------------------------------------");
    writeln("spacestr proc ");
    writeln("; --------------------------------------------------");
    writeln("  mov  edi, offset BffrInput");
    writeln("  mov  ebx, 32");
    writeln("  push eax");
    writeln("  invoke memset, edi, ebx, eax");
    writeln("  pop  eax");
    writeln("  mov  esi, offset BffrInput");
    writeln("  mov  [esi+eax], byte ptr 0");
    writeln("  ret");
    writeln("  ; --------------------------------------------------");
    writeln("spacestr endp");
    writeln("; =========================================================================");
}
/*---------- end func_spacestr ----------*/


void func_midstr()
{
    writeln("; --------------------------------------------------");
    writeln("mid_str proc ");
    writeln("; --------------------------------------------------");
    writeln("  mov  edi, offset BffrInput");
    writeln("  invoke szMid, esi, edi, ebx, eax");
    writeln("  mov  [edi+eax], byte ptr 0");
    writeln("  mov  esi, offset BffrInput");
    writeln("  ret");
    writeln("  ; --------------------------------------------------");
    writeln("mid_str endp");
    writeln("; =========================================================================");
}
/*---------- end func_midstr ----------*/


void func_rightstr()
{
    writeln("; --------------------------------------------------");
    writeln("rightstr proc ");
    writeln("; --------------------------------------------------");
    writeln("  mov  edi, offset BffrInput");
    writeln("  invoke szRight, esi, edi, eax");
    writeln("  mov  [edi+eax], byte ptr 0");
    writeln("  mov  esi, offset BffrInput");
    writeln("  ret");
    writeln("  ; --------------------------------------------------");
    writeln("rightstr endp");
    writeln("; =========================================================================");
}
/*---------- end func_rightstr ----------*/


void func_leftstr()
{
    writeln("; --------------------------------------------------");
    writeln("leftstr proc ");
    writeln("; --------------------------------------------------");
    writeln("  mov  edi, offset BffrInput");
    writeln("  invoke szLeft, esi, edi, eax");
    writeln("  mov  [edi+eax], byte ptr 0");
    writeln("  mov  esi, offset BffrInput");
    writeln("  ret");
    writeln("  ; --------------------------------------------------");
    writeln("leftstr endp");
    writeln("; =========================================================================");
}
/*---------- end func_leftstr ----------*/


void func_chrstr()
{
    writeln("; --------------------------------------------------");
    writeln("chrstr proc ");
    writeln("; --------------------------------------------------");
    writeln("  mov  esi, offset BffrInput");
    writeln("  mov  [esi], byte ptr al");
    writeln("  mov  [esi+1], byte ptr 0");
    writeln("  ret");
    writeln("  ; --------------------------------------------------");
    writeln("chrstr endp");
    writeln("; =========================================================================");
}
/*---------- end func_chrstr ----------*/


void copystrng_bffr()
{     /* enter: EDI = string base address */
    writeln("; --------------------------------------------------");
    writeln("copystrng_bffr proc ");
    writeln("; --------------------------------------------------");
    writeln("  .if edi != 0");
    writeln("    invoke free, edi");
    writeln("  .endif");
    writeln("  invoke strlen, addr StringBffr");
    writeln("  inc  eax");
    writeln("  invoke malloc, eax");
    writeln("  push eax");
    writeln("  invoke strcpy, eax, addr StringBffr");
    writeln("  pop  eax");
    writeln("  ret");
    writeln("  ; --------------------------------------------------");
    writeln("copystrng_bffr endp");
    writeln("; =========================================================================");
    writeln("; --------------------------------------------------");
    writeln("copystrng proc ");
    writeln("; --------------------------------------------------");
    write_str("  invoke strcpy, addr StringBffr, esi");
    writeln("\t\t; copy into buffer");
    writeln("  ret");
    writeln("  ; --------------------------------------------------");
    writeln("copystrng endp");
    writeln("; =========================================================================");
    writeln("catstrng proc ");
    writeln("; --------------------------------------------------");
    write_str("  invoke strcat, addr StringBffr, esi");
    writeln("\t\t; stringcat into buffer");
    writeln("  ret");
    writeln("  ; --------------------------------------------------");
    writeln("catstrng endp");
    writeln("; =========================================================================");
}
/*---------- end copystrng_bffr ----------*/


void Do_print()
{   char ch, varname[VAR_NAME];
    int pi, type, mark, len;

/* printf("Doprint::%s", p_string); */
    len = strlen(p_string);
    pi = e_pos;
    pi = iswhiter(pi);
    ch = p_string[pi];
    if(ch == '#')     /* print to file output */
    {   e_pos = pi;
        print_file(len);
        return;
    }
    e_pos = pi;
    if(strchr(":\n", ch))     /* --- print newline --- */
    {   writeln("  printstr lf");
        return;
    }
    while((pi < len) && (strchr("\n\0", ch) == 0))
    {
   /* printf("ch=%c pi=%d len=%d\n", ch, pi, len); */
        if(isdigit(ch))   /* process a string function */
        {   prn_function(len);
            pi = e_pos;
            ch = p_string[pi];
            pi++;
        }
        else
        {   strcpy(varname, "VARX");
            s_pos = pi;
            mark = find_strng(varname);
            mark--;
            if((mark >= 0) && (mark == pi))
            {   mark = 1;
            }
            else
            {   mark = 0;
            }
            strcpy(varname, get_varname());
            type = get_ObjectType(varname); /* object type specifier */
            pi = e_pos;
      /* ch = p_string[pi]; */
      /* printf("name=%s type=%d ch=>%c< pi=%d\n", varname, type, ch, pi); */
   /**/
            if(type == 0)        /* write string variable */
            {   write_str(indent);
                if(mark == 0)   /* a regular string variable */
                {   write_str("  mov  eax, [");
                    write_str(varname);
                    writeln("]");
                    writeln("  .if eax != 0");
                    write_str(indent);
                    writeln("    printvar eax");
                    writeln("  .endif");
                }
                else    /* a temp string variable */
                {   write_str("  printstr ");
                    writeln(varname);
                }
            }
            else if(type == 6)       /* write string variable */
            {   prn_strarry(varname, len);
                pi = e_pos;
                pi++;
            }
            else
            {   pi = s_pos;   /* push pointer back */
                e_pos = pi;
                prn_expression(); /* variable or math expression */
                pi = e_pos;
                ch = p_string[pi];
                while(strchr("$)", ch) != 0) /* is it end of statement */
                {   pi++;
                    ch = p_string[pi];
                }
            }
        }
        pi = iswhiter(pi);
        ch = p_string[pi];
   /* printf("ch=%c pi=%d\n", ch, pi); */

        if(ch == ',')
        {   writeln("  printstr tab");
        }
        else if(strchr(":\n", ch))
        {   write_str(indent);
            writeln("  printstr lf");
        }
  /**/
        if(strchr("\n\0", ch) == 0)      /* is it end of statement */
        {   pi++;
            pi = iswhiter(pi);
            ch = p_string[pi];
            e_pos = pi;
        }
   /* printf("ch=%c pi=%d\n", ch, pi); */
    }
}
/*---------- end Do_print ----------*/


void prn_expression()
{   char ch, varname[VAR_NAME];
    int pi;

    writeln("; --------------------------------------------------");
    writeln("  FINIT \t\t\t; initialize x87");
  /**/
    a_Expression();   /* call: recursive descent parser */
  /**/
    write_str("  FSTP  x87buff");
    writeln("\t\t\t; store in print buffer");
    writeln("  invoke FloatToStr2, x87buff, addr FltString");
    writeln("  printstr FltString");
}
/*---------- end prn_expression ----------*/


void prn_strarry(char *name, int len)     /* print an array string */
{   char varname[VAR_NAME];
    int pi, xcnt;

    strcpy(varname, name);   /* enter: array$(n,...) */
  /**/
    pi = e_pos;
    pi = get_paren(pi, len);
    xcnt = get_ObjectParm(varname);
  /**/
    writeln("; --------------------------------------------------");
    get_offset(varname, len, xcnt);
  /**/
    writeln("  mov  eax, [edi]");  /* load string address to EAX */
    writeln("  .if eax != 0");
    writeln("    printvar eax");
    writeln("  .endif");

}
/*---------- end prn_strarry ----------*/



void prn_function(int len)
{   int type;

    type = (int) get_avalue();
    string_functions(len, type);
  /**/
    if(type == 6)
    {   writeln("  printstr IntString");
    }
    else
    {   writeln("  printstr BffrInput");
    }
}
/*---------- end prn_function ----------*/


void Do_beep()
{
    writeln("  invoke Beep, 800, 250");
 /* dwFreq, // sound frequency, in hertz
  dwDuration  // sound duration, in milliseconds
 */
}
/*---------- end Do_beep ----------*/


void Do_cls()   /* call clear-screen */
{
    writeln("  cls");
}
/*---------- end Do_cls ----------*/


void Do_end()   /* jump to Done */
{
    writeln("  jmp  DONE");
}
/*---------- end Do_end ----------*/


void Do_goto()
{   char temp[LLEN];

    strcpy(temp, get_varname());
 /**/
  /* --- write assembly --- */
    write_str("  jmp  ");
    writeln(temp);
}
/*---------- end Do_goto ----------*/


void Do_label()
{   char temp[LLEN];

    strcpy(temp, label_nam[line_ndx]);
    PostLabel(temp);
}
/*---------- end Do_label ----------*/


void Do_gosub()
{   char temp[LLEN];

    strcpy(temp, get_varname());
/* --- write assembly --- */
    write_str("  call ");
    writeln(temp);
}
/*---------- end Do_gosub ----------*/


void Do_return()
{   char temp[LLEN];

/* --- write assembly --- */
    writeln("  ret");
    writeln("; --------------------------------------------------");
}
/*---------- end Do_return ----------*/


void Do_locate()
{   char ch, rows[VAR_NAME], cols[VAR_NAME];
    int pi, len, ab_code=3, x=line_ndx;

    len = strlen(p_string);
    pi = e_pos;
    pi = get_alpha(pi, len);
    e_pos = pi;
/* --- get row --- */
    if(pi < len)
    {   strcpy(rows, get_varname());   /* varname */
        pi = e_pos;
    }
    else                         /* failed to find alpha/num */
    {   a_bort(ab_code, x);
    }
    pi = get_alpha(pi, len);  /* comma separates row and column */
    e_pos = pi;
/* --- get column --- */
    if(pi < len)
    {   strcpy(cols, get_varname());   /* digit-or-varname */
    }
    else
    {   a_bort(ab_code, x);
    }
/* --- now position cursor --- */
/* --- write assembly --- */
    write_str("  invoke locate, ");
    write_str(cols);
    write_str(", ");
    write_str(rows);
    writeln("\t\t; locate cursor");
}
/*---------- end Do_locate ----------*/


void Do_initialize()
{
    writeln("; --------------------------------------------------");
    writeln("Do_initialize proc");
    writeln("; --------------------------------------------------");
    writeln("  mov  eax, offset _var_start");
    writeln("  mov  _var_start, eax");
    writeln("  mov  eax, offset _int_start");
    writeln("  mov  _int_start, eax");
    writeln("  mov  eax, offset _flt_start");
    writeln("  mov  _flt_start, eax");
    writeln("  mov  eax, offset _var_endzz");
    writeln("  mov  _var_endzz, eax");
    writeln("  invoke GetStdHandle, STD_OUTPUT_HANDLE");
    writeln("  mov  hStdHandle, eax");
    writeln("  ret");
    writeln("; --------------------------------------------------");
    writeln("Do_initialize endp");
    writeln("; =========================================================================");
}
/*---------- end Do_initialize ----------*/


/* bxbasm : Asmerror.c : alpha version */
/* ----- includes ----- */
//#include "prototyp.h"


void a_bort(int code,int x)
{
    switch(code)
    {   case 1:
            printf("Unspecified Program Name.\n");
            printf("Enter:\"bxbasm source.bas\"\n");
            printf("code(%d)\n",code);
            break;
        case 2:
            printf("Program file:\"%s\" not found.\n", t_holder);
            printf("Enter: \"bxbasm source.bas\"\n");
            printf("Program Terminated.\ncode(%d)\n", code);
            break;
        case 3:
            printf("\nSyntax error: in program line: %d.\n",(x+1));
            printf("LOCATE %s", p_string);
            printf("Use: LOCATE row, column\ncode(%d)\n", code);
            break;
        case 4:
            printf("\nSyntax error: in program line:");
            printf(" %d.\n%s",(x+1),p_string);
            printf("Unknown Command.\ncode(%d)\n", code);
            break;
        case 5:
            printf("\nVariable Type error: in program line:");
            printf(" %d.\n%sType must be: ",(x+1),p_string);
            printf("String, Integer or Float:%s\n","$%@!#");
            printf("code(%d)\n",code);
            break;
        case 6:
            printf("\nSyntax error: in program line: %d.\n",(x+1));
            printf("%s", p_string);
            printf("Useage: LET (variable=assignment):\ncode(%d)\n", code);
            break;
        case 7:
            printf("\nExpected \'variable name\' error\n");
            printf(": in line: %d.\n", (x+1));
            printf("Found digit or symbol instead.\n");
            printf("%scode(%d)\n", p_string, code);
            break;
        case 8:
            printf("\nString variable error: in line: ");
            printf("%d.\n%s", (x+1), p_string);
            printf("Expected variable name or quoted string.\n");
            printf("Found digit instead.\ncode(%d)\n", code);
            break;
        case 9:
            printf("\nVariable Type error: in program line:");
            printf(" %d.\nFOR %sType must be: ",(x+1),p_string);
            printf("Integer.\ncode(%d)\n",code);
            break;
        case 10:
            printf("\nSyntax error: in program line: %d.\n",(x+1));
            printf("\tIF %s", p_string);
            printf("Useage: IF value[expression] = value[expression]");
            printf(" THEN\ncode(%d)\n", code);
            break;
        case 11:
            printf("\nLogical Operator error: in program line: ");
            printf("%d.\n\tIF %s",(x+1), p_string);
            printf("Useage: IF exp1 (operator) exp2 THEN\n");
            printf("Where: operators are: =, <, >, <>, <=, >=\n");
            printf("code(%d)\n", code);
            break;
        case 12:
            printf("\nExpected %s ",t_holder);
            printf(": in line: %d.\n", (x+1));
            printf("%scode(%d)\n", p_string, code);
            break;
        case 13:
            printf("\nExpected : String variable or Quoted string:\n");
            printf("in program line: %d.\n",(x+1));
            printf("\tIF %s", p_string);
            printf("Useage: IF \"string\" = \"string\"");
            printf(" THEN\ncode(%d)\n", code);
            break;
        case 14:
            printf("\nIF {...} THEN: error: in program line: ");
            printf("%d.\n\tIF %s",(x+1), p_string);
            printf("Useage: IF [expression] = [expression] THEN");
            printf("\ncode(%d)\n", code);
            break;
        case 15:
            printf("\nVariable Type error: in program line:");
            printf(" %d.\nLINE INPUT%s",(x+1),p_string);
            printf("Type must be: String$\ncode(%d)\n",code);
            break;
        case 16:
            printf("\nFile OPEN error: in program line:");
            printf(" %d.\nOPEN %s",(x+1),p_string);
            printf("Invalid Open MODE:\'I,O,A,R.\'\nUsage:\n");
            printf("OPEN \"I\", #1, \"filename\"\ncode(%d)\n",code);
            break;
        case 17:
            printf("\nFile OPEN error: in program line:");
            printf(" %d.\nOPEN %s",(x+1),p_string);
            printf("Invalid File Number:\'1 to 99.\'\nUsage:\n");
            printf("OPEN \"I\", #1, \"filename\"\ncode(%d)\n",code);
            break;
        case 18:
            printf("\nFile OPEN error: in program line:");
            printf(" %d.\nOPEN %s",(x+1),p_string);
            printf("Invalid FileName.\nUsage:\n");
            printf("OPEN \"I\", #1, \"filename\"\ncode(%d)\n",code);
            break;
        case 19:
            printf("\nLSET error: in program line: %d.\n",(x+1));
            printf("%sLSET must reference an open file",p_string);
            printf(" buffer.\nUsage:\nFIELD #1, 10 AS abc$\n");
            printf("LSET abc$ = data$\ncode(%d)\n",code);
            break;
        case 20:
            printf("\nDIM error: in program line: %d.\n",(x+1));
            printf("DIM %sDuplicate variable name.\nArrays ",p_string);
            printf("names must be unique from variable names.\n");
            printf("code(%d)\n",code);
            break;
        case 21:
            printf("\nArray assignment error: in program line: ");
            printf("%d.\n%sInvalid assignment ",(x+1),p_string);
            printf("to numeric array.\ncode(%d)\n",code);
            break;
        case 22:
            printf("\nERASE error: in program line: %d.\n",(x+1));
            printf("ERASE %sObject is not an ARRAY.\n",p_string);
            printf("code(%d)\n",code);
            break;
        case 23:
            printf("\nString error: in program line: %d.\n",(x+1));
            printf("%sMissing ending quote (\").\n", p_string);
            printf("Useage: \"quoted text string\".\ncode(%d)\n", code);
            break;
        case 24:
            printf("\nCLEAR error: in program line: %d.\n",(x+1));
            printf("CLEAR %sObject is an ARRAY. Cannot ",p_string);
            printf("CLEAR an ARRAY.\nUse: ERASE arrayname\n");
            printf("code(%d)\n",code);
            break;
        case 25:
            printf("\nArray assignment error: in program line: ");
            printf("%d.\nDIM %sInvalid DIMension. ",(x+1),p_string);
            printf("Object is not an array.\nUsage: DIM array");
            printf("[%s](subscript).\ncode(%d)\n","%!@#$", code);
            break;
        case 26:
            printf("\nDIM error: in program line: %d.\n",(x+1));
            printf("VAR %sDuplicate variable name.\nArrays ",p_string);
            printf("names must be unique from variable names.\n");
            printf("code(%d)\n",code);
            break;
        case 27:
            printf("\nFile Handle error: in program line: %d.\n",(x+1));
            printf("Expected file number: (1...99). Found variable");
            printf(" name instead:\n%s",p_string);
            printf("Usage: function(1)\ncode(%d)\n",code);
            break;
        case 28:
            break;

        default:
            printf("Program aborted, undefined error.");
            break;
    }
    exit(1);
}
/*---------- end a_bort ----------*/



/* bxbasm : AsmVars.c : alpha version */
/* ----- includes ----- */
//#include "prototyp.h"





void Do_erase()
{   char ch, varname[VAR_NAME];
    int pi, len, type, ab_code=22, x=line_ndx;

    len = strlen(p_string);
    pi = e_pos;
    writeln("; --------------------------------------------------");
  /**/
    while((pi < len) && (ch = '\n'))
    {   pi = get_alpha(pi, len);
        e_pos = pi;
        if(pi < len)
        {   strcpy(varname, get_varname()); /* get this array name */
            type = get_ObjectType(varname); /* object type specifier */
   /**/
            if(verify_arrayName(varname) == 0)
            {   printf("-->\t%s", varname);
                a_bort(ab_code,x);  /* varname is not an array */
            }
            else
            {   write_str("  mov  esi, offset ");/* string array pointer */
                writeln(varname);
                writeln("  call freeArray");
    /**/
                freeArray = 1;
            }
            pi = e_pos;
            ch = p_string[pi];
        }
        if(strchr("%!#@&", ch))   /* a numeric var type */
        {   pi = get_rightExp(pi);
        }
    }
}
/*---------- end Do_erase ----------*/


void Do_dim()
{   char ch, varname[VAR_NAME], temp[6];
    int pi, len, type, dim, value;

/* printf("Dodim::%s", p_string); */
    len = strlen(p_string);
    pi = e_pos;
    pi = get_alpha(pi, len);
    ch = p_string[pi];
    e_pos = pi;
    while((pi < len) && (ch != '\n'))
    {   strcpy(varname, get_varname());  /* get this array name */
   /* printf("varname=%s pi=%d len=%d\n", varname, pi, len); */
   /**/
        type = get_ObjectType(varname);  /* object type specifier */
   /* printf("varname=%s type=%d\n", varname, type); */
   /**/
        if((type >= 6) && (type <= 10))
        {   dim = get_ObjectParm(varname);
   /**/
            writeln("; --------------------------------------------------");
            write_str("  mov  esi, offset "); /* string array pointer */
            write_str(varname);
            writeln("\t\t\t; dimension an array");
            writeln("  mov  edi, esi");
            writeln("  add  edi, 4");
   /**/
            sprintf(temp, "%d", dim);
            write_str("  mov word ptr [edi], ");
            writeln(temp);
   /**/
            pi = e_pos;
            pi = get_paren(pi, len);  /* DIM array$(3,10) */
            s_pos = pi;     /* ----------^      */
            ch = p_string[pi];
            while((ch != ')') && (ch != '\n'))
            {   pi = get_alnum(pi, len);
                e_pos = pi;
                ch = p_string[pi];
                if(isdigit(ch))
                {   value = (int) get_avalue();
                    sprintf(temp, "%d", value);
                    writeln("  add  edi, 2");
                    write_str("  mov word ptr [edi], ");
                    writeln(temp);
                }
                else if(isalpha(ch))
                {   strcpy(varname, get_varname());
                    write_str("  mov  eax, ");
                    writeln(varname);
                    writeln("  add  edi, 2");
                    writeln("  mov word ptr [edi], ax");
                }
                pi = e_pos;
                ch = p_string[pi];
            }
            writeln("  call dimstrarray");
            dimstrarray = 1;
        }
        pi = e_pos;
        pi = get_rightExp(pi);
        ch = p_string[pi];
        e_pos = pi;
 /* printf("ch=%c pi=%d len=%d\n", ch, pi, len); */
    }
}
/*---------- end Do_dim ----------*/


void Do_color()
{   char ch, varname[VAR_NAME];
    int pi, len;

    len = strlen(p_string);
    pi = e_pos;
    pi = iswhiter(pi);
    e_pos = pi;
    strcpy(varname, get_varname());
    write_str("  mov  eax, ");
    writeln(varname);
  /**/
    pi = e_pos;
    pi = get_rightExp(pi);
    e_pos = pi;
    strcpy(varname, get_varname());
    write_str("  mov  ebx, ");
    writeln(varname);
    writeln("  call setcolortext");
    setcolortext = 1;
}
/*---------- end Do_color ----------*/


void clr_vars()
{   char ch, varname[VAR_NAME];
    int pi, len, type, ab_code=24, x=line_ndx;

    len = strlen(p_string);
    pi = e_pos;
    pi = iswhite(pi);
    writeln("; --------------------------------------------------");
  /**/
    if(pi == len)
    {   writeln("  call clear_allvars");
        clearallvars = 1;
    }
    else
    {   while(pi < len)
        {   e_pos = pi;
            strcpy(varname, get_varname());
            pi = e_pos;
            type = get_ObjectType(varname); /* object type specifier */
   /**/
            if(type == 0)    /* string variable */
            {   write_str("  mov  esi, offset ");
                writeln(varname);
                writeln("  call clearstrvar");
    /**/
                clearstrvar = 1;
            }
            else
            {   if(type < 3)     /* clear integers */
                {   write_str("  mov  esi, offset ");
                    writeln(varname);
                    writeln("  call clearintvar");
    /**/
                    clearintvar = 1;
                }
                else      /* clear floats */
                {   write_str("  mov  esi, offset ");
                    writeln(varname);
                    writeln("  call clearfltvar");
    /**/
                    clearfltvar = 1;
                }
            }
            if(verify_arrayName(varname) != 0)
            {   printf("-->\t%s", varname);
                a_bort(ab_code,x);  /* varname is not an array */
            }

            pi = e_pos;
            pi = get_alpha(pi, len);
        }
    }
}
/*---------- end clr_vars ----------*/


void Do_let()
{   char ch, varname[VAR_NAME];
    int pi, len, ndx=0, type, ab_code=6, x=line_ndx;

/* printf("dolet::%s", p_string); */
    len = strlen(p_string);
    pi = e_pos;
  /**/
    pi = get_alpha(pi, len);    /* retrieve variable name */
    if(pi == len)     /* error: didn't find it */
    {   a_bort(ab_code, x);
    }
    e_pos = pi;
    strcpy(varname, get_varname());
    type = get_ObjectType(varname);  /* object type specifier */
/* printf("varname=%s type=%d\n", varname, type); */
  /**/
    switch(type)
    {   case 0:
            parse_str(varname);      /* string variable assignment */
            break;
        case 1:     /* --- integers --- */
        case 2:
        case 5:
            asn_integer(type,varname);
            break;
        case 3:
        case 4:     /* --- floating point --- */
            asn_float(type,varname);
            break;
        case 6:
            parse_strArry(varname);      /* string array assignment */
            break;
        case 8:
        case 9:
            parse_fltArry(varname, type); /* float array assignment */
            break;
        case 7:
        case 10:
            parse_intArry(varname, type); /* integer array assignment */
            break;
        default:
            a_bort(ab_code, x);
            break;
    }
}
/*---------- end Do_let ----------*/


void asn_integer(int type, char *name)
{   char ch, varname[VAR_NAME];
    int pi;

    pi = e_pos;
    ch = p_string[pi];
    strcpy(varname, name);
    if(strchr("%@&", ch))   /* 32/64-Bit Integer */
    {   pi++;     /* skip over 'type' symbol */
    }
    pi = iswhite(pi);
    e_pos = pi;
    writeln("; --------------------------------------------------");
 /**/
    Assignment();    /* call: recursive descent parser */
  /* --- store data --- */
    write_str("  FISTP ");
    write_str(varname);
    writeln("\t\t; store integer, pop stack");
}
/*---------- end asn_integer ----------*/


void asn_float(int type, char *name)
{   char ch, varname[VAR_NAME];
    int pi;

    strcpy(varname, name);
    pi = e_pos;
    ch = p_string[pi];
    if(strchr("!#", ch))
    {   pi++;     /* skip over 'type' symbol */
    }
    pi = iswhite(pi);
    e_pos = pi;
    writeln("; --------------------------------------------------");
  /**/
    Assignment();    /* call: recursive descent parser */
  /* --- store data --- */
    write_str("  FSTP  ");
    write_str(varname);
    writeln("\t\t; store float, pop stack");
}
/*---------- end asn_float ----------*/


void get_input()
{   char ch, varname[VAR_NAME], temp[6];
    int pi, len, type, mark, loc=0, ab_code=5, x=line_ndx;

/* printf("input: %s", p_string); */
    pi = e_pos;     /* INPUT;"text", var,[var,] */
    ch = p_string[pi];
    if(ch == '#')     /* this is a file: [INPUT#1, var:] */
    {   input_io();
        return;
    }
    else if(ch == ';')    /* do not echo newline */
    {   loc = 1;     /* Location Of Cursor */
        resetcursor = 1;
        pi = get_rightExp(pi); /* get to next alpha or string */
        ch = p_string[pi];
        e_pos = pi;
    }
    len = strlen(p_string);
    while((pi < len) && (ch != '\n'))        /* process to end of line */
    {   strcpy(temp, "VARX");
        s_pos = pi;
        mark = find_strng(temp);
        mark--;
        if((mark >= 0) && (mark == pi))
        {   mark = 1;
        }
        else
        {   mark = 0;
        }
  /**/
        if(mark == 1)    /* OUPUT a quoted string */
        {   strcpy(varname, get_varname());
            write_str("  printstr ");
            writeln(varname);
        }
        else if(isalpha(ch))     /* INPUT a string$ or numeric variable */
        {   strcpy(varname, get_varname());
            type = get_ObjectType(varname); /* object type specifier */
            pi = e_pos;
            if(loc == 1)
            {   writeln("  call wherexy");
            }
            if(type == 0)    /* a string$ assignment */
            {   e_pos = pi;
                writeln("  lea  eax, StringBffr");
                writeln("  mov  [eax], byte ptr 0");
                writeln("  mov  eax, BUFSIZE");
                writeln("  call inputstr\t\t; console input");
                writeln("  call copystrng");
                write_str("  mov  edi, [");   /* make string assignment */
                write_str(varname);
                write_str("]");
                writeln("\t\t\t; load address-pointer");
                writeln("  call copystrng_bffr\t\t; alloc memory and copy");
                write_str("  mov  ");
                write_str(varname);
                writeln(", eax\t\t\t; store address-pointer");
   /**/
                if(loc == 1)
                {   writeln("  call reset_cursor");
                }
                stringcopy = 1;   /* global flag */
                asninputstr = 1;
            }
            else      /* numeric assignment */
            {   writeln("  mov  eax, BUFFR_SIZ");
                writeln("  call inputstr\t\t; console input");
                writeln("  invoke StrToFloat, esi, addr qLVAR");
                writeln("  FLD   qLVAR");
                if((type < 3) || (type == 5))  /* integer types */
                {   write_str("  FISTP ");
                }
                else
                {   write_str("  FSTP ");
                }
                writeln(varname);
   /**/
                if(loc == 1)
                {   writeln("  call reset_cursor");
                }
                asninputstr = 1;
            }
        }
        else
        {   a_bort(ab_code, x);
        }
        pi = e_pos;
        ch = p_string[pi];
        if(strchr("; ,)$%!#@&", ch))  /* jump over punctuation */
        {   pi = get_alpha(pi, len);    /* get to next alpha or string */
            ch = p_string[pi];
            e_pos = pi;
        }
    }
}
/*---------- end get_input ----------*/


void get_lninput()
{   char ch, varname[VAR_NAME], temp[6];
    int pi, len, mark, loc=0, flag=0, ab_code=15, x=line_ndx;

    len = strlen(p_string);
    pi = e_pos;
    pi = iswhite(pi);
    ch = p_string[pi];
    if(ch == '#')               /* this is a file: [LINE INPUT#1, var:] */
    {   lineinput_io();
        return;
    }
    else if(ch == ';')    /* do not echo newline */
    {   loc = 1;     /* Location Of Cursor */
        resetcursor = 1;
        pi = get_rightExp(pi);  /* get to next alpha or string */
        ch = p_string[pi];
        e_pos = pi;
    }
    while(flag == 0)
    {   strcpy(temp, "VARX");
        s_pos = pi;
        mark = find_strng(temp);
        mark--;
        if((mark >= 0) && (mark == pi))
        {   mark = 1;
        }
        else
        {   mark = 0;
        }
  /**/
        if(mark == 1)    /* OUPUT a quoted string */
        {   strcpy(varname, get_varname());
            write_str("  printstr ");
            writeln(varname);
        }
        else if(isalpha(ch))       /* INPUT a string$ variable */
        {   strcpy(varname, get_varname());
            if(loc == 1)
            {   writeln("  call wherexy");
            }
            writeln("  lea  eax, StringBffr");
            writeln("  mov  [eax], byte ptr 0");
            writeln("  mov  eax, BUFSIZE");
            writeln("  call inputstr\t\t; console input");
            writeln("  call copystrng");
            write_str("  mov  edi, [");   /* make string assignment */
            write_str(varname);
            write_str("]");
            writeln("\t\t\t; load address-pointer");
            writeln("  call copystrng_bffr\t\t; alloc memory and copy");
            write_str("  mov  ");
            write_str(varname);
            writeln(", eax\t\t\t; store address-pointer");
   /**/
            if(loc == 1)
            {   writeln("  call reset_cursor");
            }
            stringcopy = 1;   /* global flag */
            asninputstr = 1;
            flag = 1;
        }
        else
        {   a_bort(ab_code, x);
        }
        pi = e_pos;
        ch = p_string[pi];
        if(strchr("; ,)$", ch))  /* jump over punctuation */
        {   pi = get_alpha(pi, len);    /* get to next alpha or string */
            ch = p_string[pi];
            e_pos = pi;
        }
    }
}
/*---------- end get_lninput ----------*/


void parse_strArry(char *name)      /* string array assignment */
{   char ch, varname[VAR_NAME], temp[6];
    int pi, len, ndx, value, xcnt=0;

    strcpy(varname, name);   /* get destination */
  /**/
    len = strlen(p_string);
    pi = e_pos;
    pi = get_paren(pi, len);
    xcnt = get_paramsCount(pi, len); /* get params count */
  /**/
    writeln("; --------------------------------------------------");
    get_offset(varname, len, xcnt);  /* get destination offset */
    writeln("  push edi");
  /**/
    pi = e_pos;
    pi++;
    pi = iswhiter(pi);
    e_pos = pi;
  /**/
    Match('=');
    writeln("  lea  eax, StringBffr");
    writeln("  mov  [eax], byte ptr 0\t\t; clear string-copy buffer");
  /**/
    str_express(varname);   /* now get assignment string */
  /**/
    writeln("  pop  edi");
    writeln("  push edi");
    writeln("  mov  eax, edi");
    writeln("  mov  edi, [eax]");  /* make string assignment */
    writeln("  call copystrng_bffr\t\t; alloc memory and copy");
    writeln("  pop  edi");   /* get destination address */
    writeln("  mov  [edi], eax\t\t\t; store address-pointer");
}
/*---------- end parse_strArry ----------*/


void get_offset(char *name, int len, int xcnt)
{   char ch, varname[VAR_NAME], temp[6];
    int pi, ndx, value;

    strcpy(varname, name);   /* get destination */
  /**/
    write_str("  mov  edi, offset ");
    writeln(varname);
    writeln("  push edi");   /* save address to array */
    writeln("  add  edi, 6");
    writeln("  mov  esi, offset array_mtrx");
    writeln("  push esi");
  /**/
    pi = e_pos;
    pi = get_paren(pi, len);   /* array$(3,1,0) = str$ */
    ch = p_string[pi];    /* ------^   */
    while((xcnt > 1) && (ch != ')'))
    {   pi = get_alnum(pi, len);
        e_pos = pi;
        ch = p_string[pi];
        if(isdigit(ch))
        {   value = (int) get_avalue();
            sprintf(temp, "%d", value);
            write_str("  mov  [esi], word ptr ");
            writeln(temp);
            writeln("  add  esi, 2");
        }
        else if(isalpha(ch))
        {   strcpy(varname, get_varname());
            write_str("  mov  eax, ");
            writeln(varname);
            writeln("  mov  [esi], ax");
            writeln("  add  esi, 2");
        }
        pi = e_pos;
        ch = p_string[pi];
        xcnt--;
    }
    writeln("  mov  [esi], word ptr 0");
    writeln("  add  esi, 2");
  /**/
    pi = get_alnum(pi, len);
    e_pos = pi;
    ch = p_string[pi];
    if(isdigit(ch))
    {   value = (int) get_avalue();
        sprintf(temp, "%d", value);
        write_str("  mov  [esi], word ptr ");
        writeln(temp);
    }
    else if(isalpha(ch))
    {   strcpy(varname, get_varname());
        write_str("  mov  eax, ");
        writeln(varname);
        writeln("  mov  [esi], ax");
    }
    writeln("  pop  esi");
    writeln("  call getArryOffst");  /* get array(index) offset */
    writeln("  pop  esi");   /* array base address */
    writeln("  mov  edi, [esi]");
    writeln("  add  edi, eax");
  /**/
    getArryOffst = 1;
}
/*---------- end get_offset ----------*/


void parse_intArry(char *name, int type) /* integer array assignment */
{   char ch, varname[VAR_NAME], temp[6];
    int pi, len, xcnt;

    strcpy(varname, name);   /* get destination */
  /**/
    len = strlen(p_string);
    pi = e_pos;
    pi = get_paren(pi, len);
    xcnt = get_paramsCount(pi, len); /* get params count */
  /**/
    writeln("; --------------------------------------------------");
    get_offset(varname, len, xcnt);  /* get destination offset */
    writeln("  push edi");
  /**/
    pi = e_pos;
    pi++;
    pi = iswhiter(pi);
    e_pos = pi;
  /**/
    Assignment();    /* call: recursive descent parser */
  /**/
  /* --- store data --- */
    writeln("  pop  edi");
    if(type == 7)
    {   writeln("  call dblArryElement");
        writeln("  FISTP dword ptr [eax]\t\t; store integer, pop stack");
  /**/
        dblArryElement = 1;
    }
    else if(type == 10)
    {   writeln("  call quadArryElement");
        writeln("  FISTP qword ptr [eax]\t\t; store integer, pop stack");
  /**/
        quadArryElement = 1;
    }
}
/*---------- end parse_intArry ----------*/


void parse_fltArry(char *name, int type) /* float array assignment */
{   char ch, varname[VAR_NAME], temp[6];
    int pi, len, xcnt;

    strcpy(varname, name);   /* get destination */
  /**/
    len = strlen(p_string);
    pi = e_pos;
    pi = get_paren(pi, len);
    xcnt = get_paramsCount(pi, len); /* get params count */
  /**/
    writeln("; --------------------------------------------------");
    get_offset(varname, len, xcnt);  /* get destination offset */
    writeln("  push edi");
  /**/
    pi = e_pos;
    pi++;
    pi = iswhiter(pi);
    e_pos = pi;
  /**/
    Assignment();    /* call: recursive descent parser */
  /**/
  /* --- store data --- */
    writeln("  pop  edi");
    writeln("  call quadArryElement");
    writeln("  FSTP qword ptr [eax]\t\t; store integer, pop stack");
  /**/
    quadArryElement = 1;
}
/*---------- end parse_fltArry ----------*/

/* bxbasm : Asmrdp.c : alpha version */
/* special credits to: Jack Crenshaw's: "How to Build a Compiler" */
/* this is a very close implementation of his tutorial.           */

/* ----- function prototypes ----- */
//#include "prototyp.h"



void Assignment()  /* Recursive Descent Parser Main */
{
    writeln("  FINIT \t\t\t; initialize x87");
    Match('=');
    a_Expression();
}
/*---------- end Assignment ----------*/

void a_Expression() /* Parse and Translate an Expression */
{   char ch;
    int pi;

    pi = e_pos;
    ch = p_string[pi];
    if(IsAddop(ch))
    {   writeln("  FLDZ\t\t\t\t; push 0 onto stack");
    }
    else
    {   a_Term();
        pi = e_pos;
        ch = p_string[pi];
    }
    while(IsAddop(ch))
    {   switch(ch)
        {   case '+':
                Add();  /* Recognize and Translate an Add */
                break;
            case '-':
                Subtract(); /* Recognize and Translate a Subtract */
                break;
            default:
                break;
        }
        pi = e_pos;
        ch = p_string[pi];
    }
}
/*---------- end a_Expression ----------*/

void a_Term()  /* Parse and Translate a Math Term */
{   char ch;
    int pi;

    a_Factor();
    pi = e_pos;
    ch = p_string[pi];
    while(IsMultop(ch))
    {   switch(ch)
        {   case '*':
                Multiply(); /* Recognize and Translate a Multiply */
                break;
            case '/':
                Divide(); /* Recognize and Translate a Divide */
                break;
            case '^':
                Power(); /* Recognize and Translate a Power Of */
                break;
            case '%':
                Modulo(); /* Recognize and Translate a Modulo */
                break;
            default:
                break;
        }
        pi = e_pos;
        ch = p_string[pi];
    }
}
/*---------- end a_Term ----------*/

void a_Factor()  /* Parse and Translate a Math Factor */
{   char ch, Value[10];
    int pi, ab_code=7, x=line_ndx;

    pi = e_pos;
    ch = p_string[pi];
    if(ch == '(')
    {   Match('(');
        a_Expression();
        Match(')');
    }
    else
    {   if(isalpha(ch))    /* variable name */
        {   Ident();
        }
        else if(ch == '?')   /* math function */
        {   math_functn();
        }
        else     /* error */
        {   a_bort(ab_code, x);
        }
    }
}
/*---------- end a_Factor ----------*/


void math_functn()
{   int pi, type;

    pi = e_pos;    /* enter: ?1(x) */
    pi++;     /*    ----^     */
    e_pos = pi;
    type = (int) get_avalue();
    switch(type)
    {   case 1:
            get_ABS();   /* a = ABS(exp) */
            break;
        case 2:
            get_ASC();   /* a = ASC(str$) */
            break;
        case 3:
            get_ATN();   /* a! = ATN(exp) */
            break;
        case 4:
            get_COS();   /* a! = COS(exp) */
            break;
        case 5:
            get_SIN();   /* a! = SIN(exp) */
            break;
        case 6:
            get_TAN();   /* a! = TAN(exp) */
            break;
        case 7:
            get_SQRT();   /* a! = SQRT(exp) */
            break;
        case 8:
            get_INT();   /* a = INT(exp) */
            break;
        case 9:
            get_LEN();   /* a = LEN(str$) */
            break;
        case 10:
            get_LOF();   /* a% = LOF(fp) */
            break;
        case 11:
            get_LOC();   /* a% = LOC(fp) */
            break;
        case 12:    /* a# = CVD(str$) */
        case 14:    /* a! = CVS(str$) */
            get_CVD();
            break;
        case 13:    /* a% = CVI(str$) */
            get_CVI();
            break;
        case 15:
            get_ATN2();   /* a! = ATN2(exp, exp) */
            break;
        case 16:
            get_COSH();   /* a! = COSH(exp) */
            break;
        case 17:
            get_SINH();   /* a! = SINH(exp) */
            break;
        case 18:
            get_TANH();   /* a! = TANH(exp) */
            break;
        case 19:
            get_ACOS();   /* a! = ACOS(exp) */
            break;
        case 20:
            get_ASIN();   /* a! = ASIN(exp) */
            break;
        case 21:
            get_CEIL();   /* a! = CEIL(exp) */
            break;
        case 22:
            get_FLOOR();  /* a! = FLOOR(exp) */
            break;
        case 23:
            get_HYPOT();  /* a! = HYPOT(exp,exp) */
            break;
        case 24:
            get_LOG();   /* a! = LOG(exp) */
            break;
        case 25:
            get_LOG10();  /* a! = LOG10(exp) */
            break;
        case 26:
            get_RAND();   /* a = RAND(void) */
            break;
        case 27:
            get_CLOCK();  /* a = CLOCK(void) */
            break;
        case 28:
            get_VAL();   /* a = VAL(string$) */
            break;
        case 29:
            get_EOF();   /* a = EOF(fp) */
            break;
        default:
            /* error */
            break;
    }
}
/*---------- end math_functn ----------*/


void asn_numarry(char *name, int type) /* assign a numeric array */
{   char ch, varname[VAR_NAME];
    int pi, len, xcnt;

    strcpy(varname, name);   /* enter: abc% = array%(n,) */
  /**/
    len = strlen(p_string);
    pi = e_pos;
    pi = get_paren(pi, len);
 /*   xcnt = get_paramsCount(pi, len);  get params count */
    xcnt = get_ObjectParm(varname);
  /**/
    get_offset(varname, len, xcnt);
    writeln("  mov  eax, [edi]");
  /**/
/* --- load integers --- */
    if(type == 7)
    {   writeln("  FILD dword ptr [eax]\t\t\t; load integer");
    }
    else if(type == 10)
    {   writeln("  FILD qword ptr [eax]\t\t\t; load integer");
    }
    else if((type == 8) || (type == 9))
    {   writeln("  FLD qword ptr [eax]\t\t\t; load float");
    }
}
/*---------- end asn_numarry ----------*/


void Ident()   /* Parse and Translate an Identifier */
{   char ch, varname[VAR_NAME];
    int pi, type, ab_code=5, x=line_ndx;

    strcpy(varname, get_varname());
    type = get_ObjectType(varname);  /* object type specifier */
 /* printf("varname=%s type=%d\n", varname, type); */

    pi = e_pos;
  /**/
    if((type >= 7) && (type <= 10))
    {   asn_numarry(varname, type);  /* source is a numeric array */
        pi = e_pos;
        pi++;
        pi = iswhiter(pi);
        e_pos = pi;
        return;
    }
/* --- get variable type --- */
    SkipWhite();
    pi = e_pos;
    ch = p_string[pi];
    if(ch == '(')  /* function call */
    {   Match('(');
        Match(')');
        write_str("  call  ");
        writeln(varname);
    }
/* --- load integers --- */
    else if((type == 1) || (type == 2) || (type == 5))
    {   write_str("  FILD  ");
        write_str(varname);
        writeln("\t\t\t; load integer");
    }
/* --- load floating pt. --- */
    else if((type == 3) || (type == 4))
    {   write_str("  FLD   ");
        write_str(varname);
        writeln("\t\t\t; load float");
    }
    else
    {   a_bort(ab_code, x);
    }
}
/*---------- end Ident ----------*/


void Add()   /* Recognize and Translate an Add */
{
    Match('+');
    a_Term();
    writeln("  FADDP ST(1), ST\t\t\t; add to ST(0) and pop");
}
/*---------- end Add ----------*/

void Subtract()  /* Recognize and Translate a Subtract */
{
    Match('-');
    a_Term();
    writeln("  FSUBP ST(1), ST\t\t; subtract and pop");
}
/*---------- end Subtract ----------*/

void Multiply()  /* Recognize and Translate a Multiply */
{
    Match('*');
    a_Factor();
    writeln("  FMULP ST(1), ST\t\t\t; multiply and pop");
}
/*---------- end Multiply ----------*/

void Divide()  /* Recognize and Translate a Divide */
{
    Match('/');
    a_Factor();
    writeln("  FDIVP ST(1), ST\t\t\t; divide and pop");
}
/*---------- end Divide ----------*/


void Power()  /* Recognize and Translate a Power Of */
{
    Match('^');
    writeln("  FSTP  qLVAR");
    a_Factor();
    writeln("  FSTP  qRVAR");
    writeln("  invoke pow, qLVAR, qRVAR"); /* double value is in ST(0) */
}
/*---------- end Power ----------*/


void Modulo()  /* Recognize and Translate a Modulo */
{
    Match('%');
    writeln("  FSTP  qLVAR");
    a_Factor();
    writeln("  FSTP  qRVAR");
    writeln("  invoke fmod, qLVAR, qRVAR"); /* double value is in ST(0) */
}
/*---------- end Modulo ----------*/


void Match(char x) /* Match a Specific Input Character */
{   char ch, string[6];
    int pi, ab_code=12, ln=line_ndx;

    pi = e_pos;
    ch = p_string[pi];
    if(ch != x)
    {   strcpy(string, "\" \"");
        string[1] = x;
        strcpy(t_holder, string);
        a_bort(ab_code,ln);
    }
    else
    {   _GetChar();
        SkipWhite();
    }
}
/*---------- end Match ----------*/

int IsAddop(char ch)   /* Recognize an Addop */
{   int _bool=0;

    if((ch == '+') || (ch == '-'))
    {   _bool = 1;
    }
    return _bool;
}
/*---------- end IsAddop ----------*/

int IsMultop(char ch)   /* Recognize an Addop */
{   int _bool=0;

    if(strchr("*^/%", ch))
    {   _bool = 1;
    }
    return _bool;
}
/*---------- end IsMultop ----------*/

int Is_White(char ch)
{   int _bool=0;

    if((ch == ' ') || (ch == '\t'))
    {   _bool = -1;
    }
    return _bool;
}
/*---------- end Is_White ----------*/

void _GetChar()
{
    e_pos++;  /* advance pointer */
}
/*---------- end _GetChar ----------*/

void SkipWhite()  /* Skip Over Leading White Space */
{   char ch;
    int pi;

    pi = e_pos;
    ch = p_string[pi];
    while(Is_White(ch))
    {   _GetChar();  /* advance & save pointer */
        pi = e_pos;
        ch = p_string[pi];
    }
}
/*---------- end SkipWhite ----------*/


void get_CVI()      /* convert an I/O buffer string to a number */
{   char varname[VAR_NAME];    /* a% = CVI(string$) */
    int pi, len;


    len = strlen(p_string);
    pi = e_pos;
    pi = get_alpha(pi, len);
    e_pos = pi;
    strcpy(varname, get_varname());
  /**/
    write_str("  mov  esi, [");
    write_str(varname);
    writeln("]");
  /**/
    if(var_type == 5)   /* check global type variable */
    {   writeln("  mov  edi, offset qLVAR");
        writeln("  call mkqstr");
        writeln("  FILD   qLVAR");
  /**/
        asnmkqstr = 1;
    }
    else
    {   writeln("  mov  edi, offset iLVAR");
        writeln("  call mkistr");
        writeln("  FILD   iLVAR");
  /**/
        asnmkistr = 1;
    }
}
/*---------- end get_CVI ----------*/


void get_CVD()      /* convert an I/O buffer string to a number */
{   char varname[VAR_NAME];    /* a# = CVD(string$) */
    int pi, len;      /* a! = CVS(string$) */

    len = strlen(p_string);
    pi = e_pos;
    pi = get_alpha(pi, len);
    e_pos = pi;
    strcpy(varname, get_varname());
  /**/
    write_str("  mov  esi, [");
    write_str(varname);
    writeln("]");
    writeln("  mov  edi, offset qLVAR");
    writeln("  call mkdstr");
    writeln("  FLD   qLVAR");
  /**/
    asnmkdstr = 1;
}
/*---------- end get_CVD ----------*/


void get_LEN()     /* get string length */
{   char varname[VAR_NAME];   /* num = LEN(string$) */
    int pi, len, type, xcnt;

    len = strlen(p_string);
    pi = e_pos;
    pi = get_alpha(pi, len);
    e_pos = pi;
    strcpy(varname, get_varname());
    type = get_ObjectType(varname);  /* object type specifier */
  /**/
    if(type == 6)     /* source is an array-string */
    {   pi = e_pos;
        pi = get_paren(pi, len);
        xcnt = get_ObjectParm(varname);
        get_offset(varname, len, xcnt);
        writeln("  mov  eax, [edi]"); /* load string address to EAX */
    }
    else
    {   write_str("  mov  eax, [");
        write_str(varname);
        writeln("]");
    }
    writeln("  invoke strlen, eax");
    writeln("  mov  iLVAR, eax");
    writeln("  FILD  iLVAR");
}
/*---------- end get_LEN ----------*/


void get_INT()   /* make a float number an integer */
{       /* a% = INT(float#) */
    a_Factor();
  /**/
    writeln("  invoke FpuTrunc, 0, 0, SRC1_FPU or DEST_FPU");
}
/*---------- end get_INT ----------*/


void get_SQRT()    /* get the square root of a number */
{      /* a! = SQRT(num) */
    a_Factor();
  /**/
    writeln("  FSTP  qLVAR");
    writeln("  invoke sqrt, qLVAR");  /* double value is in ST(0) */
}
/*---------- end get_SQRT ----------*/


void get_TANH()   /* get the hyperbolic tangent of a number */
{       /* a# = TANH(num) */
    a_Factor();
  /**/
    writeln("  FSTP  qLVAR");
    writeln("  invoke tanh, qLVAR");  /* double value is in ST(0) */
}
/*---------- end get_TANH ----------*/


void get_TAN()    /* get the tangent of a number */
{       /* a# = TAN(num) */
    a_Factor();
  /**/
    writeln("  FSTP  qLVAR");
    writeln("  invoke tan, qLVAR");  /* double value is in ST(0) */
}
/*---------- end get_TAN ----------*/


void get_SINH()   /* get the hyerbolic sine of a number */
{       /* a# = SINH(num) */
    a_Factor();
  /**/
    writeln("  FSTP  qLVAR");
    writeln("  invoke sinh, qLVAR");  /* double value is in ST(0) */
}
/*---------- end get_SINH ----------*/


void get_SIN()    /* get the sine of a number */
{       /* a# = SIN(num) */
    a_Factor();
  /**/
    writeln("  FSTP  qLVAR");
    writeln("  invoke sin, qLVAR");  /* double value is in ST(0) */
}
/*---------- end get_SIN ----------*/


void get_COSH()   /* get the hyperbolic cosine of a number */
{       /* a# = COSH(num) */
    a_Factor();
  /**/
    writeln("  FSTP  qLVAR");
    writeln("  invoke cosh, qLVAR");  /* double value is in ST(0) */
}
/*---------- end get_COSH ----------*/


void get_COS()    /* get the cosine of a number */
{       /* a# = COS(num) */
    a_Factor();
  /**/
    writeln("  FSTP  qLVAR");
    writeln("  invoke cos, qLVAR");  /* double value is in ST(0) */
}
/*---------- end get_COS ----------*/


void get_ATN2()   /* get the arctangent of 2 numbers */
{   char ch;      /* a# = ATN2(num,num) */
    int pi, len;

    pi = e_pos;
    ch = p_string[pi];
    len = strlen(p_string);
    pi = get_alpha(pi, len);
    e_pos = pi;
  /**/
    a_Factor();
    writeln("  FSTP  qLVAR");
  /**/
    pi = e_pos;
    ch = p_string[pi];
    len = strlen(p_string);
    pi = get_alpha(pi, len);
    e_pos = pi;
  /**/
    a_Factor();
    writeln("  FSTP  qRVAR");   /* double value is in ST(0) */
    writeln("  invoke atan2, qLVAR, qRVAR");
}
/*---------- end get_ATN2 ----------*/


void get_ATN()    /* get the arctangent of a number */
{       /* a# = ATN(num) */
    a_Factor();
  /**/
    writeln("  FSTP  qLVAR");
    writeln("  invoke atan, qLVAR");  /* double value is in ST(0) */
}
/*---------- end get_ATN ----------*/


void get_ASC()   /* get the ascii value of a character */
{   char ch, varname[VAR_NAME], temp[6];   /* a = ASC(chr$) */
    int pi, len, type, xcnt, mark;

    len = strlen(p_string);
    pi = e_pos;
    pi = get_alpha(pi, len);
    e_pos = pi;
    strcpy(varname, get_varname());
  /**/
    strcpy(temp, "VARX");
    s_pos = pi;
    mark = find_strng(temp);
    mark--;
  /**/
    type = get_ObjectType(varname);  /* object type specifier */
    if(type == 6)     /* source is an array-string */
    {   pi = e_pos;
        pi = get_paren(pi, len);
        xcnt = get_ObjectParm(varname);
        get_offset(varname, len, xcnt);
        writeln("  mov  esi, [edi]"); /* load string address to ESI */
    }
    else if(mark == pi)    /* this is a temp var-name */
    {   write_str("  mov  esi, offset ");
        write_str(varname);
        writeln("\t\t\t; load temp variable address");
    }
    else
    {   write_str("  mov  esi, [");
        write_str(varname);
        writeln("]");
    }
    writeln("  xor  eax, eax");
    writeln("  mov  al,  [esi]");
    writeln("  mov  iLVAR, eax");
    writeln("  FILD  iLVAR");
}
/*---------- end get_ASC ----------*/


void get_ABS()   /* get the absolute value of a number */
{       /* a% = ABS(num) */
    a_Factor();
  /**/
    writeln("  FISTP  iLVAR");
    writeln("  invoke abs, iLVAR");
    writeln("  mov   iLVAR, eax");  /* integer value is in eax */
    writeln("  FILD  iLVAR");
}
/*---------- end get_ABS ----------*/


void get_ASIN()    /* get the arc sine of a number */
{       /* a# = ASIN(num) */
    a_Factor();
  /**/
    writeln("  FSTP  qLVAR");
    writeln("  invoke asin, qLVAR");  /* double value is in ST(0) */
}
/*---------- end get_ASIN ----------*/


void get_ACOS()    /* get the arc cosine of a number */
{       /* a# = ACOS(num) */
    a_Factor();
  /**/
    writeln("  FSTP  qLVAR");
    writeln("  invoke acos, qLVAR");  /* double value is in ST(0) */
}
/*---------- end get_ACOS ----------*/


void get_CEIL()    /* get the ceiling of a number */
{       /* a# = CEIL(num) */
    a_Factor();
  /**/
    writeln("  FSTP  qLVAR");
    writeln("  invoke ceil, qLVAR");  /* double value is in ST(0) */
}
/*---------- end get_CEIL ----------*/


void get_FLOOR()    /* get the floor of a number */
{       /* a# = FLOOR(num) */
    a_Factor();
  /**/
    writeln("  FSTP  qLVAR");
    writeln("  invoke floor, qLVAR");  /* double value is in ST(0) */
}
/*---------- end get_FLOOR ----------*/


void get_HYPOT()    /* get the hypotenuse of 2 numbers */
{   char ch;      /* a# = HYPOT(num,num) */
    int pi, len;

    pi = e_pos;
    ch = p_string[pi];
    len = strlen(p_string);
    pi = get_alpha(pi, len);
    e_pos = pi;
  /**/
    a_Factor();
    writeln("  FSTP  qLVAR");
  /**/
    pi = e_pos;
    ch = p_string[pi];
    len = strlen(p_string);
    pi = get_alpha(pi, len);
    e_pos = pi;
  /**/
    a_Factor();
    writeln("  FSTP  qRVAR");   /* double value is in ST(0) */
    writeln("  invoke _hypot, qLVAR, qRVAR");
}
/*---------- end get_HYPOT ----------*/


void get_LOG()    /* get the log of a number */
{       /* a# = LOG(num) */
    a_Factor();
  /**/
    writeln("  FSTP  qLVAR");
    writeln("  invoke log, qLVAR");  /* double value is in ST(0) */
}
/*---------- end get_LOG ----------*/


void get_LOG10()    /* get the log10 of a number */
{       /* a# = LOG10(num) */
    a_Factor();
  /**/
    writeln("  FSTP  qLVAR");
    writeln("  invoke log10, qLVAR");  /* double value is in ST(0) */
}
/*---------- end get_LOG10 ----------*/


void get_RAND()      /* get a random number */
{   int pi;       /* a = RAND() */

    writeln("  call  rand");
    writeln("  mov   iLVAR, eax");  /* integer value is in eax */
    writeln("  FILD  iLVAR");
  /**/
    pi = e_pos;     /* xyz = RAND()... */
    pi += 2;     /* ----------^     */
    pi = iswhiter(pi);
    e_pos = pi;
}
/*---------- end get_RAND ----------*/


void seed_rand()    /* seed random number generator */
{        /* RANDOM(n) */
    a_Factor();
  /**/
    writeln("  FISTP  iLVAR");
    writeln("  invoke srand, iLVAR");
}
/*---------- end seed_rand ----------*/


void get_CLOCK()      /* get clock ticks */
{        /* a = CLOCK() */
    writeln("  call  clock");
    writeln("  mov   iLVAR, eax");  /* integer value is in eax */
    writeln("  FILD  iLVAR");
}
/*---------- end get_CLOCK ----------*/


void get_VAL()     /* get value of ascii string */
{   char varname[VAR_NAME];   /* num = VAL(string$) */
    int pi, len, type, xcnt;

    len = strlen(p_string);
    pi = e_pos;
    pi = get_alpha(pi, len);
    e_pos = pi;
  /**/
    strcpy(varname, get_varname());
    type = get_ObjectType(varname);  /* object type specifier */
  /**/
    if(type == 6)     /* source is an array-string */
    {   pi = e_pos;
        pi = get_paren(pi, len);
        xcnt = get_ObjectParm(varname);
        get_offset(varname, len, xcnt);
        writeln("  mov  eax, [edi]"); /* load string address to EAX */
    }
    else
    {   write_str("  mov  eax, [");
        write_str(varname);
        writeln("]");
    }
    writeln("  invoke StrToFloat, eax, addr qLVAR");
    writeln("  FLD  qLVAR");
}
/*---------- end get_VAL ----------*/


void get_LOC()
{   char fptr[4], varname[VAR_NAME];   /* num = LOC(1) */
    int pi, len, ival, ab_code=27, x=line_ndx;
    double value;

    len = strlen(p_string);
    pi = e_pos;
    pi = get_digit(pi, len);
    if(pi >= len)
    {   a_bort(ab_code, x);
    }
    e_pos = pi;
    value = get_avalue();
    ival = (int) value;
    ival--;
    sprintf(fptr, "%d", ival);
  /**/
    write_str("  mov  eax, ");
    writeln(fptr);
    writeln("  call getfilehandle");
    writeln("  invoke ftell, eax");
    writeln("  mov   iLVAR, eax");  /* integer value is in eax */
    writeln("  FILD  iLVAR");
  /**/
    getfilehandle = 1;
}
/*---------- end get_LOC ----------*/


void get_LOF()
{   char fptr[4], varname[VAR_NAME];   /* num = LOF(1) */
    int pi, len, ival, ab_code=27, x=line_ndx;
    double value;

    len = strlen(p_string);
    pi = e_pos;
    pi = get_digit(pi, len);
    if(pi >= len)
    {   a_bort(ab_code, x);
    }
    e_pos = pi;
    value = get_avalue();
    ival = (int) value;
    ival--;
    sprintf(fptr, "%d", ival);
  /**/
    write_str("  mov  eax, ");
    writeln(fptr);
    writeln("  call getfilelength");
  /**/
    getfilelength = 1;
    getfilehandle = 1;
}
/*---------- end get_LOF ----------*/


void get_EOF()
{   char fptr[4], varname[VAR_NAME];   /* num = EOF(1) */
    int pi, len, ival, ab_code=27, x=line_ndx;
    double value;

    len = strlen(p_string);
    pi = e_pos;
    pi = get_digit(pi, len);
    if(pi >= len)
    {   a_bort(ab_code, x);
    }
    e_pos = pi;
    value = get_avalue();
    ival = (int) value;
    ival--;
    sprintf(fptr, "%d", ival);
  /**/
    write_str("  mov  eax, ");
    writeln(fptr);
    writeln("  call getfilehandle");
    writeln("  invoke feof, eax");
    writeln("  mov   iLVAR, eax");  /* integer value is in eax */
    writeln("  FILD  iLVAR");
  /**/
    getfilehandle = 1;
}
/*---------- end get_EOF ----------*/


/* bxbasm : AsmNInpt.c : alpha version */
/* ----- function prototypes ----- */
//#include "prototyp.h"




void ScanLPrint()     /* parse LPRINT statement */
{   char ch, NVar[12], varname[VAR_NAME], format[BUFSIZE];
    int pi, len, type, wflag=0, ii;
    unsigned size;

    len = strlen(p_string);
    pi = e_pos;
    ch = p_string[pi];
    format[0] = '\0';
  /**/
    while((pi < len) && (ch != '\n'))   /* process up to line terminator */
    {   pi = get_rightExp(pi);
        ch = p_string[pi];
        e_pos = pi;
        if(ch == '\"')    /* found a quoted string */
        {   GetNewVar();   /* get new varname */
            strcat(format, "%s");
        }
        else
        {   type = get_vtype(pi);
            if(type == 0)
            {   e_pos = pi;
                strcpy(varname, get_varname());  /* get varname */
                Fix_String(varname);
                strcat(format, "%s");
            }
            else         /* output a value */
            {   e_pos = pi;
                type = get_Nvtype(pi);
                AddNewVar();
    /**/
                if(type < 3)
                {   strcat(format, " %d");
                }
                else if(type < 5)
                {   strcat(format, " %f");
                }
                else
                {   strcat(format, " %lu");
                }
            }
        }
        pi = e_pos;
        ch = p_string[pi];
        len = strlen(p_string);
        if(strchr("$#!%@&", ch))
        {   pi++;
            pi = iswhiter(pi);
            ch = p_string[pi];
        }
    }
/* printf("format=%s\n", format); */

  /* --- get new varname --- */
    strcpy(NVar, NewFVarname());
    strcat(NVar, "S");
    write_str("\t");
    write_str(NVar);
    write_str("\t\tDB\t\'");
    write_str(format);
    writeln("\',10,0");
  /**/
    strcpy(format, "#");
    strcat(format, NVar);
    strcat(format, ", ");
    strcat(format, p_string);
  /**/
/* --- save p_string to array --- */
    len = strlen(format);
    size = len + 1;
    ii = line_ndx;
    array1[ii] = (char*)realloc(array1[ii], size * sizeof(char));
    strcpy(array1[line_ndx], format);      /* store to array */

  /* printf("p_string:%s", format); */
}
/*------- end ScanLPrint ----------*/


void ScanFPrint()     /* parse PRINT# statement */
{   char ch, NVar[12], varname[VAR_NAME], format[BUFSIZE];
    int pi, len, type, wflag=0, ii;
    unsigned size;

    len = strlen(p_string);
    pi = e_pos;
    pi = get_digit(pi, len);
    pi = get_NextOp(pi);
    ch = p_string[pi];
    format[0] = '\0';
  /**/
    while((pi < len) && (ch != '\n'))   /* process up to line terminator */
    {   pi = get_rightExp(pi);
        ch = p_string[pi];
        e_pos = pi;
        if(ch == '\"')    /* found a quoted string */
        {   GetNewVar();   /* get new varname */
            strcat(format, "%s");
        }
        else
        {   type = get_vtype(pi);
            if(type == 0)
            {   e_pos = pi;
                strcpy(varname, get_varname());  /* get varname */
                Fix_String(varname);
                strcat(format, "%s");
            }
            else         /* output a value */
            {   e_pos = pi;
                AddNewVar();
                type = get_Nvtype(pi);
                if(type < 3)
                {   strcat(format, " %d");
                }
                else if(type < 5)
                {   strcat(format, " %f");
                }
                else
                {   strcat(format, " %lu");
                }
            }
        }
        pi = e_pos;
        ch = p_string[pi];
        len = strlen(p_string);
        if(strchr("$#!%@&", ch))
        {   pi++;
            pi = iswhiter(pi);
            ch = p_string[pi];
        }
    }
  /* printf("format=%s\n", format); */

  /* --- get new varname --- */
    strcpy(NVar, NewFVarname());
    strcat(NVar, "S");
    write_str("\t");
    write_str(NVar);
    write_str("\t\tDB\t\'");
    write_str(format);
    writeln("\',10,0");
  /**/
    strcpy(format, "#");
    strcat(format, NVar);
    strcat(format, ", ");
    strcat(format, p_string);
  /**/
/* --- save p_string to array --- */
    len = strlen(format);
    size = len + 1;
    ii = line_ndx;
    array1[ii] = (char*)realloc(array1[ii], size * sizeof(char));
    strcpy(array1[line_ndx], format);      /* store to array */

  /* printf("p_string:%s", format); */
}
/*------- end ScanFPrint ----------*/


void ScanPut()
{   char ch;
    int pi, len;

    pi = e_pos;
    len = strlen(p_string);
    pi = get_alnum(pi, len);
    pi = get_NextOp(pi);
    e_pos = pi;
  /**/
    ScanParam();      /* parse paramaters */
}
/*------- end ScanPut ----------*/



void ScanField()
{   char ch, temp[6], varname[VAR_NAME], string[BUFSIZE];
    int pi, len, mark, var_cnt=0, ii;
    unsigned size;

    len = strlen(p_string);
    pi = e_pos;
    strcpy(temp, " AS ");
  /**/
    while(pi < len)
    {   s_pos = pi;
        mark = find_strng(temp);
        mark--;
        if(mark > 0)
        {   pi = mark + 3;
            pi = iswhiter(pi);
            ch = p_string[pi];
            if(isalpha(ch))
            {   e_pos = pi;
                strcpy(varname, get_varname());  /* get varname */
                Fix_String(varname);
                var_cnt++;
            }
        }
        else
        {   pi = len;
        }
    }
    sprintf(temp, "%d", var_cnt);
    strcpy(string, temp);
    strcat(string, ",");
    strcat(string, p_string);
  /**/
/* --- save p_string to array --- */
    len = strlen(string);
    size = len + 1;
    ii = line_ndx;
    array1[ii] = (char*)realloc(array1[ii], size * sizeof(char));
    strcpy(array1[line_ndx], string);     /* store to array */
}
/*------- end ScanField ----------*/


void ScanFInput()     /* parse INPUT# statement */
{   char ch, NVar[12], varname[VAR_NAME];
    int pi, len, type, ii;
    unsigned size;

    len = strlen(p_string);
    pi = e_pos;
    ch = p_string[pi];
  /**/
    while((pi < len) && (ch != '\n'))   /* process up to line terminator */
    {   pi = get_alpha(pi, len);
        if(pi < len)
        {   type = get_vtype(pi);
            if(type == 0)
            {   e_pos = pi;
                strcpy(varname, get_varname());  /* get varname */
                Fix_String(varname);
            }
            else        /* output a value */
            {   e_pos = pi;
                AddNewVar();
            }
            pi = get_NextOp(pi);
        }
        ch = p_string[pi];
    }
 /* printf("p_string:%s", format); */

}
/*------- end ScanFInput ----------*/



void ScanWrite()     /* parse WRITE statement */
{   char ch, NVar[12], varname[VAR_NAME], format[BUFSIZE];
    int pi, len, type, wflag=0, ii;
    unsigned size;

/* printf("scanwrite: %s", p_string); */
    len = strlen(p_string);
    pi = e_pos;
    ch = p_string[pi];
    format[0] = '\0';
  /**/
    while((pi < len) && (ch != '\n'))   /* process up to line terminator */
    {   pi = get_alpha(pi, len);
        if(pi < len)
        {   type = get_vtype(pi);
            if(type == 0)
            {   e_pos = pi;
                strcpy(varname, get_varname());  /* get varname */
                Fix_String(varname);
                if(wflag == 1)
                {   strcat(format, ",");
                }
                strcat(format, "%s");
                wflag = 1;
            }
            else        /* output a value */
            {   e_pos = pi;
                type = get_Nvtype(pi);
                AddNewVar();
    /**/
                if(wflag == 1)
                {   strcat(format, ",");
                }
                if(type < 3)
                {   strcat(format, "%d");
                }
                else if(type == 4)
                {   strcat(format, "%.20f");
                }
                else if(type == 3)
                {   strcat(format, "%f");
                }
                else /* if(type == 5) */
                {   strcat(format, "%lu");
                }
                wflag = 1;
            }
            pi = get_NextOp(pi);
        }
        ch = p_string[pi];
    }
 /* printf("format=%s\n", format); */
  /**/
    strcpy(NVar, NewFVarname());  /* --- get new varname --- */
    strcat(NVar, "S");
    write_str("\t");
    write_str(NVar);
    write_str("\t\tDB\t\'");
    write_str(format);
    writeln("\',10,0");
  /**/
    strcpy(format, NVar);
    strcat(format, ", ");
    strcat(format, p_string);
/* --- save p_string to array --- */
  /**/
    len = strlen(format);
    size = len + 1;
    ii = line_ndx;
    array1[ii] = (char*)realloc(array1[ii], size * sizeof(char));
    strcpy(array1[line_ndx], format);   /* store to array */

/* printf("scanwrite:%s", format); */
}
/*------- end ScanWrite ----------*/


void ScanOpen()     /* parse OPEN statement */
{   char ch, temp[BUFSIZE];
    int pi, len, file, ii, ab_code=16, x=line_ndx;
    double value;
    unsigned size;

    len = strlen(p_string);
    pi = e_pos;
    ch = p_string[pi];
    if(ch != '\"')
    {   pi = get_quote(pi, len);
        pi--;
    }
    s_pos = pi;
    pi = get_upper(pi, len);
    ch = p_string[pi];
 /**/
    if(isalpha(ch))   /* isolate access mode: I,O,A,R (B) */
    {   switch(ch)
        {   case 'I':
                p_string[pi] = 'r';
                strcpy(temp, "0,");
                break;
            case 'O':
                p_string[pi] = 'w';
                strcpy(temp, "0,");
                break;
            case 'A':
                p_string[pi] = 'a';
                strcpy(temp, "0,");
                break;
            case 'R':
                p_string[pi] = 'r';
                p_string[(pi+1)] = 'b';
                p_string[(pi+2)] = '+';
                p_string[(pi+3)] = '\"';
                strcpy(temp, "1,");
                break;
            default:
                a_bort(ab_code,x);
                break;
        }
        e_pos = s_pos;
        GetNewVar();     /* get new varname */
        pi = e_pos;
    }
 /**/
    pi = get_digit(pi, len);   /* file number: #1,2,3... */
    ch = p_string[pi];
    if(isdigit(ch))
    {   pi = get_NextOp(pi);   /* skip over file number */
        pi = get_rightExp(pi);
    }
    else
    {   ab_code = 17;
        a_bort(ab_code,x);
    }
 /**/
    ch = p_string[pi];
    if(ch == '\"')
    {   e_pos = pi;
        GetNewVar();     /* get new varname */
    }
    else if(isalpha(ch))    /* a varname */
    {   /* do nothing, pass on varname */
    }
    else
    {   ab_code = 18;
        a_bort(ab_code,x);
    }
    strcat(temp, p_string);
  /**/
/* --- save p_string to array --- */
    len = strlen(temp);
    size = len + 1;
    ii = line_ndx;
    array1[ii] = (char*)realloc(array1[ii], size * sizeof(char));
    strcpy(array1[line_ndx], temp);   /* store to array */
}
/*---------- end ScanOpen ----------*/


void ScanJump()   /* parse numeric jump label */
{   char ch, newlabel[LLEN], label[LLEN];
    int pi, len;

    pi = e_pos;
    len = strlen(p_string);
    pi = get_alnum(pi, len);
    if(pi < len)
    {   ch = p_string[pi];
        e_pos = pi;
        if(isdigit(ch))
        {   strcpy(newlabel, "L");  /* correct numeric label */
            strcpy(label, get_varname());
            strcat(newlabel, label);
            StorNVar(newlabel);  /* save new label name */
        }
    }
}
/*---------- end ScanJump ----------*/


void ScanParam()   /* parse function paramaters */
{   char ch;
    int pi, len;

    pi = e_pos;
    len = strlen(p_string);
    while(pi < len)
    {   pi = get_alnum(pi, len);
        ch = p_string[pi];
        if(pi < len)
        {   e_pos = pi;
            if((isdigit(ch)) || (ch == '.'))
            {   GetNewTmp();   /* get new temp varname */
            }
            else if(isalpha(ch))  /* a variable name */
            {   AddNewVar();
            }
            pi = e_pos;
            len = strlen(p_string);
        }
    }
}
/*---------- end ScanParam ----------*/


void defaultStep(int len)
{   char ch;
    int pi;

    pi = e_pos;
    len--;
    p_string[len] = '\0';
    strcat(p_string, " STEP 1\n");

  /* --- skip over STEP --- */
    len = strlen(p_string);
    pi = while_isalnum(pi);
    pi = get_digit(pi, len);

  /* --- convert digit to var-name --- */
    e_pos = pi;
    GetNewTmp();     /* get new temp varname */
}
/*---------- end defaultStep ----------*/


void LexStep(int len)
{   char ch;
    int pi;

    pi = e_pos;
    while(pi < len)
    {   ch = p_string[pi];
        while((isalnum(ch) == 0) && (pi < len))
        {   pi++;
            ch = p_string[pi];
        }
        if(pi < len)
        {   e_pos = pi;
            if(isdigit(ch))
            {   GetNewTmp();   /* get new temp varname */
            }
            else if(isalpha(ch))  /* a variable name */
            {   AddNewVar();
            }
            pi = e_pos;
        }
    }
}
/*---------- end LexStep ----------*/


void LexTo()
{   char ch;
    int pi, STEP;

    pi = e_pos;
    s_pos = pi;
    STEP = find_strng("STEP");   /* work up to: STEP */
    STEP--;
    if(STEP < 0)     /* if STEP does not exist */
    {   STEP = strlen(p_string);  /* use p_string length */
    }
    while(pi < STEP)
    {   ch = p_string[pi];
        while((isalnum(ch) == 0) && (pi < STEP))
        {   pi++;
            ch = p_string[pi];
        }
        if(pi < STEP)
        {   e_pos = pi;
            if(isdigit(ch))
            {   GetNewTmp();   /* get new temp varname */
            }
            else if(isalpha(ch))  /* a variable name */
            {   AddNewVar();
            }
            pi = e_pos;
            s_pos = pi;
            STEP = find_strng("STEP"); /* work up to: STEP */
            STEP--;
            if(STEP < 0)
            {   STEP = strlen(p_string);
            }
        }
    }
    e_pos = pi;
}
/*---------- end LexTo ----------*/


void LexFor(char *name)
{   char ch, varname[VAR_NAME];
    int pi, type, len, TO, ab_code=9, x=line_ndx;

    strcpy(varname, name);
    pi = e_pos;
    len = strlen(varname);
    s_pos = pi - len;
    type = get_Nvtype(pi);   /* get var-type length */
 /**/
    if((type == 1) || (type == 2))  /* must be type: integer */
    {   Sav_Destin(type, varname);  /* save destination name */
    }
    else
    {   a_bort(ab_code, x);
    }
    pi = e_pos;       /* handle expresions */
    s_pos = pi;
    TO = find_strng("TO");   /* work up to: TO */
    TO--;
    while(pi < TO)
    {   ch = p_string[pi];
        while((isalnum(ch) == 0) && (pi < TO))
        {   pi++;
            ch = p_string[pi];
        }
        if(pi < TO)
        {   e_pos = pi;
            if(isdigit(ch))
            {   GetNewTmp();   /* get new temp varname */
            }
            else if(isalpha(ch))
            {   AddNewVar();   /* a variable name */
            }
            pi = e_pos;
            s_pos = pi;
            TO = find_strng("TO");  /* work up to: TO */
            TO--;
        }
    }
    e_pos = pi;
}
/*---------- end LexFor ----------*/


void ScanNumeric(char *name)
{   char ch, varname[VAR_NAME];
    int pi, type, len, ival, funcflag=0, ab_code=5, x=line_ndx;

/* printf("->Numer::%s", p_string); */
    strcpy(varname, name);
    pi = e_pos;
    len = strlen(varname);
    s_pos = pi - len;
    type = get_Nvtype(pi);   /* get var-type length */
 /**/
    Sav_Destin(type, varname);  /* save destination name */
 /**/
    pi = e_pos;       /* handle expresions */
    len = strlen(p_string);
    while(pi < len)
    {   ch = p_string[pi];
        while((isalnum(ch) == 0) && (pi < len) && (strchr(".\"",ch) == 0))
        {   pi++;
            ch = p_string[pi];
            if(ch == '?')   /* math function: ?1(num) */
            {   e_pos = pi + 1;
                ival = (int) get_avalue();
                if((ival == 10) || (ival == 11) || (ival == 29))
                {   pi = len;    /* LOC, LOF, EOF */
                }
                else     /* any other function */
                {   pi = get_paren(pi, len); /* ?num(string$) */
                    ch = p_string[pi];  /* ----^      */
                    funcflag = 1;
                }
            }
        }
        if(pi < len)
        {   e_pos = pi;
            if(funcflag == 1)   /* this is a math function */
            {   ScanMathFunc(len);
                funcflag = 0;
            }
            else if((isdigit(ch)) || (ch == '.'))
            {   GetNewTmp();    /* get new temp varname */
            }
            else if(isalpha(ch))  /* an array or variable name */
            {   pi = e_pos;
                strcpy(varname, get_varname());  /* get varname */
                type = get_ObjectType(varname);
    /**/
                if((type >= 7) && (type <= 10))  /* an array name */
                {   Fix_VarArray(varname);
                    pi = e_pos;
                    pi = get_paren(pi, len);
                    ScanArrayParam();
                }
                else
                {   e_pos = pi;
                    AddNewVar();   /* a variable name */
                }
            }
            pi = e_pos;
            len = strlen(p_string);
        }
    }
/*  printf("ScanNumeric: %s", p_string); */
}
/*---------- end ScanNumeric ----------*/


void ScanMathFunc(int len)
{   char ch, varname[VAR_NAME];
    int pi, type;

/* printf("ScanMath::%s", p_string); */
    pi = e_pos;
    ch = p_string[pi];
    while((ch != ')') && (pi < len))
    {   if(ch == '\"')    /* found a quoted string */
        {   GetNewVar();    /* get new varname */
        }
        else if((isdigit(ch)) || (ch == '.'))
        {   GetNewTmp();   /* get new temp varname */
        }
        else if(isalpha(ch))   /* a variable name */
        {   type = get_vtype(pi);  /* get variable type */
            if(type == 0)   /* string variables */
            {   strcpy(varname, get_varname());
                Fix_String(varname);
            }
            else if(type == 6)
            {   strcpy(varname, get_varname());
                Fix_StrArray(varname);
                pi = e_pos;
                pi = get_paren(pi, len);
                e_pos = pi;
                ScanArrayParam();
                pi = e_pos;
                pi++;
                e_pos = pi;
            }
            else
            {   AddNewVar();
            }
        }
        pi = e_pos;
        len = strlen(p_string);
        ch = p_string[pi];
        if(ch != ')')
        {   pi++;
            ch = p_string[pi];
            e_pos = pi;
        }
    }
/* printf("ScanMath::%s", p_string); */
}
/*---------- end ScanMathFunc ----------*/


void Sav_Destin(int type, char *Name)
{   char ch, varname[VAR_NAME];
    int pi, ab_code=5, x=line_ndx;

    strcpy(varname, Name);
    pi = e_pos;
    ch = p_string[pi];
  /**/
    if(strchr("%!#@&", ch))
    {   p_string[pi] = ' ';
    }
 /**/
    if((type == 1) || (type == 2))   /* 32-Bit Long Integer */
    {   if(check_VarName(varname) == 0)
        {   i_write_str("\t");
            i_write_str(varname);
            i_writeln("\t\tDD  ?");
   /**/
            Sav_ObjName(varname, type, 0);
        }
    }
    else if((type >= 3) && (type <= 5))
    {   if(check_VarName(varname) == 0)
        {   f_write_str("\t");
            f_write_str(varname);
            f_writeln("\t\tDQ  ?");
   /**/
            Sav_ObjName(varname, type, 0);
        }
    }
    else
    {   a_bort(ab_code, x);
    }
    StorNVar(varname);    /* save destination name */
}
/*---------- end Sav_Destin ----------*/


void AddNewVar()
{   char ch, varname[VAR_NAME];
    int pi, type;

    pi = e_pos;
    s_pos = pi;
  /* --- get varname --- */
    strcpy(varname, get_varname());
    pi = e_pos;

  /* --- get variable type --- */
    type = get_Nvtype(pi);
    Sav_Destin(type, varname);  /* save destination name */
}
/*---------- end AddNewVar ----------*/


void GetNewTmp()
{   char ch, NewVar[12], a_string[BUFSIZE];
    int pi, x=0, dotflag=0;
    double ftest=0;

    pi = e_pos;
    s_pos = pi;
    strcpy(NewVar, NewFVarname());
  /**/
    ch = p_string[pi];
    if(ch == '-')
    {   a_string[x] = ch;
        x++;
        pi++;
        ch = p_string[pi];
    }
    else if(ch == '.')
    {   a_string[x] = '0';
        x++;
    }
    while(isdigit(ch) || (ch == '.')) /* copy digits */
    {   if(ch == '.')
        {   dotflag = 1; /* flag: floating point number */
        }
        a_string[x] = ch;
        x++;
        pi++;
        ch = p_string[pi];
    }
    a_string[x] = '\0';
    e_pos = pi;
  /**/
  /* --- integers --- */
    if(dotflag == 0)
    {   ftest = atof(a_string);
        if(ftest <= 32767)
        {   strcat(NewVar, "I");
            write_str("\t");
            write_str(NewVar);  /* NewVar  DW  integer */
            write_str("\t\tDD  ");
   /**/
            Sav_ObjName(NewVar, 1, 0);
        }
        else if(ftest <= 2147483647)
        {   strcat(NewVar, "L");
            write_str("\t");
            write_str(NewVar);  /* NewVar  DD  long */
            write_str("\t\tDD  ");
   /**/
            Sav_ObjName(NewVar, 2, 0);
        }
        else
        {   strcat(NewVar, "Q");
            write_str("\t");
            write_str(NewVar);  /* NewVar  DD  long */
            write_str("\t\tDQ  ");
   /**/
            Sav_ObjName(NewVar, 5, 0);
        }
    }
  /**/
  /* --- floats --- */
    else
    {   ftest = atof(a_string);
        if(ftest <= 2147483647)
        {   strcat(NewVar, "F");
            write_str("\t");
            write_str(NewVar);  /* NewVar  DD  float */
            write_str("\t\tDQ  ");
   /**/
            Sav_ObjName(NewVar, 3, 0);
        }
        else
        {   strcat(NewVar, "D");
            write_str("\t");
            write_str(NewVar);  /* NewVar  DQ  double */
            write_str("\t\tDQ  ");
   /**/
            Sav_ObjName(NewVar, 4, 0);
        }
    }
    writeln(a_string);  /* write temp declaration */
  /**/
  /* --- save varname in array --- */
    StorNVar(NewVar);
}
/*---------- end GetNewTmp ----------*/


void StorNVar(char *name)
{   char ch, varname[VAR_NAME];
    int pi, x=0, ii, len;
    unsigned size;

    strcpy(varname, name);
    len = strlen(varname);
    ii = (s_pos + len);    /* how many chars to xfer */
    if(s_pos > 0)
    {   for(x=0;x < s_pos; x++)
        {   s_holder[x] = p_string[x];
        }
        x = 0;
    }
    for(pi=s_pos; pi < ii; pi++,x++)
    {   s_holder[pi] = varname[x];   /* copy varname */
    }
    x = pi;
    s_pos = pi;
    pi = e_pos;
    ch = p_string[pi];
    while(ch != '\0')
    {   s_holder[x] = p_string[pi];
        x++;
        pi++;
        ch = p_string[pi];
    }
    s_holder[x] = '\0';
    strcpy(p_string, s_holder);
  /**/
  /* --- save p_string to array --- */
    x = strlen(p_string);
    len = strlen(array1[line_ndx]);
    if(x > len)
    {  size = (x+1);
       ii = line_ndx;
       array1[ii] = (char*)realloc(array1[ii], size * sizeof(char));
    }
    strcpy(array1[line_ndx], p_string);    /* store to array */
  /**/
    ch = p_string[s_pos];
    if(isalpha(ch))
    {   s_pos = get_NextOp(s_pos);
    }
    e_pos = s_pos;
}
/*---------- end StorNVar ----------*/


char *NewFVarname()  /* generate a unique varname */
{   char Val[6];
    static char NVar[12];

    var_count++;
    strcpy(NVar, "VARX");
    sprintf(Val, "%d", var_count);
    strcat(NVar, Val);
    return NVar;
}
/*---------- end NewFVarname ----------*/





/* bxbasm : Asmloops.c : alpha version */
/* ----- function prototypes ----- */
//#include "prototyp.h"



void Do_do()     /* parse a DO-WHILE statement */
{   char Label[LLEN];
    int pi, mark_or;

    strcat(indent, "  ");
  /**/
    strcpy(WhileArray[whileLblCtr], get_NewLabel()); /* END-WHILE label */
    strcpy(BreakArray[breakCtr], WhileArray[whileLblCtr]);  /* BREAK */
    breakCtr++;
    whileLblCtr++;
    strcpy(WhileArray[whileLblCtr], get_NewLabel());   /* DO label */
  /**/
    strcpy(Label, WhileArray[whileLblCtr]);
    whileLblCtr++;
    PostLabel(Label);
  /**/
    write_str(indent);
    writeln(";--------------------<do>");
 /**/
    dowhileflag = 1;
}
/*------- end Do_do -------*/


void Do_dowhile()     /* parse a DO-WHILE statement */
{   char Label[LLEN];
    int pi, _len, mark_or;

    write_str(indent);
    writeln(";--------------------<end-do>");
  /**/
    Or_pi = 0;
    mark_or = wcheck_or();    /* is there an: or */
    wboolexpress();     /* evaluate condition */
    wor_true(mark_or);
  /**/
    whileLblCtr--;
    strcpy(Label, WhileArray[whileLblCtr]);
    WhileArray[whileLblCtr][0] = '\0';
  /**/
    write_str(indent);
    write_str("jmp  ");
    writeln(Label);
  /**/
    whileLblCtr--;
    strcpy(Label, WhileArray[whileLblCtr]);
    WhileArray[whileLblCtr][0] = '\0';
    PostLabel(Label);
  /**/
    breakCtr--;
    BreakArray[breakCtr][0] = '\0';
  /**/
    _len = strlen(indent);
    _len = _len - 2;
    indent[_len] = '\0';
    indcnt--;
  /**/
    opcntr = 0;
    dowhileflag = 0;

}
/*------- end Do_while -------*/



void Do_break()     /* parse an BREAK statement */
{   char label[LLEN];
    int count;

    count = breakCtr - 1;
    strcpy(label, BreakArray[count]);
  /**/
    write_str(indent);
    write_str("jmp  ");
    write_str(label);
    writeln("\t\t;--------------------<break>");
}
/*------- end Do_break -------*/


void Do_loop()     /* parse a LOOP statement */
{   char Label[LLEN];

    strcat(indent, "  ");
  /**/
    strcpy(LoopArray[loopLblCtr], get_NewLabel()); /* ENDLOOP label */
    strcpy(BreakArray[breakCtr], LoopArray[loopLblCtr]);
    breakCtr++;
    loopLblCtr++;
  /**/
    strcpy(LoopArray[loopLblCtr], get_NewLabel());   /* LOOP label */
    strcpy(Label, LoopArray[loopLblCtr]);
    PostLabel(Label);
    loopLblCtr++;
  /**/
    write_str(indent);
    writeln(";--------------------<loop>");
}
/*------- end Do_loop -------*/


void Do_endloop()     /* parse an LEND statement */
{   char label[LLEN];
    int _len;

    loopLblCtr--;
    strcpy(label, LoopArray[loopLblCtr]);
    LoopArray[loopLblCtr][0] = '\0';
    write_str(indent);
    write_str("jmp  ");
    writeln(label);
    write_str(indent);
    writeln(";--------------------<end-loop>");
  /**/
    _len = strlen(indent);
    _len = _len - 2;
    indent[_len] = '\0';
    indcnt--;
  /**/
    loopLblCtr--;
    strcpy(label, LoopArray[loopLblCtr]);
    LoopArray[loopLblCtr][0] = '\0';
    PostLabel(label);
  /**/
    breakCtr--;
    BreakArray[breakCtr][0] = '\0';
}
/*------- end Do_endloop -------*/


void Do_while()     /* parse a WHILE statement */
{   char Label[LLEN];
    int pi, mark_or;

    if(dowhileflag == 1)   /* a DO-WHILE statement */
    {   Do_dowhile();
        return;
    }
    pi = e_pos;
    strcat(indent, "  ");
    write_str(indent);
    writeln(";--------------------<while>");
  /**/
    strcpy(WhileArray[whileLblCtr], get_NewLabel());   /* WEND label */
    strcpy(BreakArray[breakCtr], WhileArray[whileLblCtr]);  /* BREAK */
    breakCtr++;
    whileLblCtr++;
    strcpy(WhileArray[whileLblCtr], get_NewLabel());   /* WHILE label */
  /**/
    strcpy(Label, WhileArray[whileLblCtr]);
    whileLblCtr++;
    PostLabel(Label);
  /**/
    Or_pi = 0;
    mark_or = wcheck_or();    /* is there an: or */
    wboolexpress();   /* evaluate condition */
  /**/
    write_str(indent);
    writeln(";--------------------<block>");
    wor_true(mark_or);
    opcntr = 0;
}
/*------- end Do_while -------*/


void Do_wend()     /* parse an WEND statement */
{   char label[LLEN];
    int _len;

    write_str(indent);
    writeln(";--------------------<end-block>");
  /**/
    whileLblCtr--;
    strcpy(label, WhileArray[whileLblCtr]);
    WhileArray[whileLblCtr][0] = '\0';
    write_str(indent);
    write_str("jmp  ");
    writeln(label);
    write_str(indent);
    writeln(";--------------------<wend>");
  /**/
    _len = strlen(indent);
    _len = _len - 2;
    indent[_len] = '\0';
    indcnt--;
  /**/
    whileLblCtr--;
    strcpy(label, WhileArray[whileLblCtr]);
    WhileArray[whileLblCtr][0] = '\0';
    PostLabel(label);
  /**/
    breakCtr--;
    BreakArray[breakCtr][0] = '\0';
}
/*------- end Do_wend -------*/


void wboolexpress()
{   int pi, unary, type, op, ab_code=14, x=line_ndx;

    pi = e_pos;
    unary = isUnary_Exp();   /* is it a unary expression */
    if(unary != 0)
    {   op = do_UnaryExp(unary);
    }
    else
    {   type = get_Exptype();   /* string, numeric, or eof */
        switch(type)
        {   case 1:
            case 2:
                op = Nboolterm(type);         /* numeric evaluation */
                break;
            case 3:
            case 4:
                op = Sboolterm(type);        /* a string evaluation */
                break;
            case 5:
                op = is_eof();   /* an EOF evaluation */
                break;
            default:
                /* a_bort(ab_code,x); */
                break;
        }
    }
    op = WIsAndOrOp(op);     /* --- process AND / OR --- */
    if(op != 0)
    {   opcntr++;
        wboolexpress();    /* do: AND/OR */
    }
}
/*------- end wboolexpress --------*/


int WIsAndOrOp(int op)
{   char ch, jump[10], this_label[LLEN];
    int pi, _bool, _len, wlabel;

    pi = e_pos;
    pi = iswhiter(pi);
    ch = p_string[pi];
    e_pos = pi;
    wlabel = whileLblCtr - 2;
    strcpy(this_label, WhileArray[wlabel]);
    if(op > 6)      /* a UNARY condition */
    {   if(op == 7)     /* a NOT condition */
        {   op = 6;
            ch = '|';      /* force 'jump' */
            strcpy(jump, jump_if(op, ch));
        }
        else
        {   op = 6;
            ch = ' ';      /* force 'jump' */
            strcpy(jump, jump_if(op, ch));
        }
        ch = p_string[pi];
        switch(ch)
        {   case '&':      /* AND */
                _bool = look_Or();  /* is there an OR to jump to */
                if(_bool == 1)
                {   strcpy(this_label, label_Or);
                }
                write_str(indent);
                write_str(jump);
                writeln(this_label);
                op = 1;
                break;
            case '|':      /* OR */
                strcpy(this_label, wlabel_block);
                write_str(indent);
                write_str(jump);
                writeln(this_label);
   /**/
                if(label_Or[0] != '\0')
                {   PostLabel(label_Or);
                    label_Or[0] = '\0';
                }
                op = 2;
                break;
            case '^':      /* NOT */
                write_str(indent);
                write_str(jump);
                writeln(this_label);
                op = 3;
                break;
            default:
                write_str(indent);
                write_str(jump);
                writeln(this_label);
                op = 0;
                pi--;
                break;
        }
        pi++;
        pi = iswhiter(pi);
    }
    else      /* a normal BINARY condition */
    {   switch(ch)
        {   case '&':      /* AND */
                _bool = look_Or();  /* is there an OR to jump to */
                if(_bool == 1)
                {   strcpy(this_label, label_Or);
                }
                strcpy(jump, jump_if(op, ch));
                write_str(indent);
                write_str(jump);
                writeln(this_label);
                op = 1;
                break;
            case '|':      /* OR */
                strcpy(this_label, wlabel_block);
                strcpy(jump, jump_if(op, ch));
                write_str(indent);
                write_str(jump);
                writeln(this_label);
   /**/
                if(label_Or[0] != '\0')
                {   PostLabel(label_Or);
                    label_Or[0] = '\0';
                }
                op = 2;
                break;
            case '^':      /* NOT */
                strcpy(jump, jump_if(op, ch));
                write_str(indent);
                write_str(jump);
                writeln(this_label);
                op = 3;
                break;
            default:
                strcpy(jump, jump_if(op, ch));
                write_str(indent);
                write_str(jump);
                writeln(this_label);
                op = 0;
                pi--;
                break;
        }
        pi++;
        pi = iswhiter(pi);
    }
    e_pos = pi;
    return op;
}
/*------- end WIsAndOrOp --------*/


int do_UnaryExp(int _bool)    /* a unary expression */
{   int op, type;

    switch(_bool)
    {   case 1:     /* boolean NOT expression */
            op = Unary_NOT();
            break;
        case 2:     /* boolean TRUE expression */
            op = Unary_TRUE();
            break;
    }
    return op;
}
/*------- end do_Unary_Exp --------*/


int Unary_NOT()    /* a unary NOT condition */
{   char temp[6];
    int pi, type, op, mark;

    pi = e_pos;
    pi = get_rightExp(pi);
    e_pos = pi;
    type = get_vtype(pi);   /* numeric evaluation */
    if(type == 1)
    {   op = WNrelation();
    }
    else if(type == 5)
    {   strcpy(temp, "EOF");
        s_pos = pi;
        mark = find_strng(temp);
        mark--;
        if(mark == pi)
        {   op = is_eof();   /* an EOF evaluation */
            op++;
        }
    }
    return op;
}
/*------- end Unary_NOT --------*/


int Unary_TRUE()    /* a unary TRUE condition */
{   char temp[6];
    int pi, type, op, mark;

    pi = e_pos;
    pi = get_rightExp(pi);
    e_pos = pi;
    type = get_vtype(pi);   /* numeric evaluation */
    if(type == 1)
    {   op = x_WNrelation();
    }
    else if(type == 5)
    {   strcpy(temp, "EOF");
        s_pos = pi;
        mark = find_strng(temp);
        mark--;
        if(mark == pi)
        {   op = is_eof();   /* an EOF evaluation */
        }
    }
    return op;
}
/*------- end Unary_TRUE --------*/


int x_WNrelation()     /* a unary TRUE condition */
{   char varname[VAR_NAME];
    int pi, op;

    pi = e_pos;
    pi = get_rightExp(pi);
    e_pos = pi;
  /**/
    write_str(indent);
    writeln("mov  eax, 0");
  /**/
    strcpy(varname, get_varname());
    write_str(indent);
    write_str("cmp  eax, ");
    writeln(varname);
  /**/
    op = 6;
    return op;
}
/*------- end x_WNrelation --------*/


int WNrelation()
{   char varname[VAR_NAME];
    int op;

    write_str(indent);
    writeln("mov  eax, 0");
  /**/
    strcpy(varname, get_varname());
    write_str(indent);
    write_str("cmp  eax, ");
    writeln(varname);
  /**/
    op = 8;
    return op;
}
/*------- end WNrelation --------*/


int isUnary_Exp()   /* return: is it a unary expression */
{   char ch;
    int pi, _bool=0;

    pi = e_pos;
    pi = iswhiter(pi);
    ch = p_string[pi];
    if(ch == '<')
    {   _bool = 1;                      /* 'NOT' boolean expression */
    }
    else if(isalpha(ch))
    {   pi = get_NextOp(pi);   /* get past this varname */
        ch = p_string[pi];   /* what is the next char ? */
        if(strchr(" $#!%@&", ch))  /* variable type, skip it */
        {   pi++;
            pi = iswhiter(pi);
            ch = p_string[pi];
        }
        if(strchr("&|^\n\0", ch))  /* AND, OR, NOT or terminated */
        {   _bool = 2;
        }
    }
    return _bool;
}
/*------- end isUnary_Exp ---------*/


void wor_true(int mark_or) /* does this statement contain an OR */
{   char block[LLEN];

    if(mark_or > 0)
    {   strcpy(block, wlabel_block);
        PostLabel(block);
    }
}
/*------- end wor_true -------*/


int wcheck_or()     /* look ahead for an: OR */
{   char temp[3];
    int mark_or;

    s_pos = 0;
    strcpy(temp, "| ");
    mark_or = find_strng(temp);
    mark_or--;
    if(mark_or > 0)
    {   strcpy(wlabel_block, get_NewLabel());
        Or_pi = 0;  /* keep track of recurring OR position */
    }
    else
    {   wlabel_block[0] = '\0';
    }
    return mark_or;
}
/*------- end wcheck_or -------*/


void Do_for()
{   char ch, varFrom[VAR_NAME], varTo[VAR_NAME], varStep[VAR_NAME];
    char Label1[LLEN], Label2[LLEN];
    int pi, sav_pi, _len, ab_code, x=line_ndx;

    _len = strlen(p_string);
  /**/
  /* --- assign FROM --- */
    pi = e_pos;
    sav_pi = pi;
    pi = get_alpha(pi, _len);
    strcpy(varFrom, get_varname());  /* get name for: x */
    e_pos = sav_pi;
  /**/
  /* --- make assignment -- */
    Do_let();                   /* FOR x%=a TO b STEP c: */
  /**/
  /* --- get TO --- */
    pi = e_pos;
    s_pos = pi;
    pi = find_strng("TO");   /* work up to: TO */
    pi = while_isalnum(pi);
    pi = get_alpha(pi, _len);
    e_pos = pi;
    strcpy(varTo, get_varname());  /* get name for: TO */
    pi = e_pos;
  /**/
  /* --- get STEP --- */
    s_pos = pi;
    pi = find_strng("STEP");   /* work up to: STEP */
    pi = while_isalnum(pi);
    pi = get_alpha(pi, _len);
    e_pos = pi;
    strcpy(varStep, get_varname());  /* get name for: STEP */
    pi = e_pos;
  /**/
  /* --- get unique labels --- */
    strcpy(Label1, get_NewLabel());
    strcpy(Label2, get_NewLabel());
  /**/
  /* --- begin writing assembly code --- */
    PostLabel(Label1);
  /**/
    write_str("  mov  eax, ");
    write_str(varFrom);
    writeln("\t\t;For/Next loop");
  /**/
    write_str("  cmp  eax, ");
    writeln(varTo);
  /**/
    write_str("  jg  ");
    write_str(Label2);
    writeln("\t\t;exit loop");
  /**/
  /* --- save labels --- */
    strcpy(ForArray[forLabelCtr], Label1);
    forLabelCtr++;
  /**/
    strcpy(ForArray[forLabelCtr], Label2);
    forLabelCtr++;
  /**/
    strcpy(ForArray[forLabelCtr], varFrom);
    forLabelCtr++;
  /**/
    strcpy(ForArray[forLabelCtr], varStep);
    forLabelCtr++;
}
/*-------- end Do_for ----------*/


void Do_next()
{   char ch, varFrom[VAR_NAME], varStep[VAR_NAME];
    char Label1[LLEN], Label2[LLEN];

    forLabelCtr--;
    strcpy(varStep, ForArray[forLabelCtr]);
    ForArray[forLabelCtr][0] = '\0';
  /**/
    forLabelCtr--;
    strcpy(varFrom, ForArray[forLabelCtr]);
    ForArray[forLabelCtr][0] = '\0';
  /**/
    forLabelCtr--;
    strcpy(Label2, ForArray[forLabelCtr]);
    ForArray[forLabelCtr][0] = '\0';
  /**/
    forLabelCtr--;
    strcpy(Label1, ForArray[forLabelCtr]);
    ForArray[forLabelCtr][0] = '\0';
  /**/
    write_str("  FILD  ");
    writeln(varFrom);
    write_str("  FILD  ");
    writeln(varStep);
    writeln("  FADDP  ST(1), ST\t\t;increment counter");
    write_str("  FISTP  ");
    writeln(varFrom);
  /**/
    write_str("  jmp  ");
    write_str(Label1);
    writeln("\t\t;Next n");
  /**/
    PostLabel(Label2);
}
/*-------- end Do_next ---------*/

/* bxbasm : Asmif.c : alpha version */
/* ----- function prototypes ----- */
//#include "prototyp.h"



void Do_if()     /* parse an IF statement */
{   int pi, mark_or;

    pi = e_pos;
    strcat(indent, "  ");
    write_str(indent);
    writeln(";--------------------<if>");
  /**/
    endifCtr++;
    strcpy(label_endif[endifCtr], get_NewLabel());
    check_lsif();     /* is there an: elseif */
    check_else();     /* is there an: else */
    mark_or = check_or();   /* is there an: or */
  /**/
    boolexpress();
  /**/
    write_str(indent);
    writeln(";--------------------<block>");
    or_true(mark_or);    /* post block label */
    opcntr = 0;
}
/*------- end Do_if -------*/


void Do_elseif()     /* parse an ELSEIF statement */
{   char label[LLEN];
    int mark_or;

    strcpy(label, label_endif[endifCtr]);
    write_str(indent);
    writeln(";--------------------<end-block>");
    write_str(indent);
    write_str("jmp  ");
    writeln(label);
    write_str(indent);
    writeln(";--------------------<elseif>");
  /**/
    strcpy(label, label_elseif[endifCtr]);
    PostLabel(label);
    check_lsif();     /* is there an: elseif */
    check_else();     /* is there an: else */
    mark_or = check_or();   /* is there an: or */
  /**/
    boolexpress();
  /**/
    write_str(indent);
    writeln(";--------------------<block>");
    or_true(mark_or);    /* post block label */
    opcntr = 0;
}
/*------- end Do_elseif -------*/


void Do_else()     /* parse an ELSE statement */
{   char label[LLEN];
    int len;

    write_str(indent);
    writeln(";--------------------<end-block>");
  /**/
    strcpy(label, label_endif[endifCtr]);
    write_str(indent);
    write_str("jmp  ");
    writeln(label);    /* jump to end */
  /**/
    strcpy(label, label_else[endifCtr]);
    write_str(indent);
    writeln(";--------------------<else>");
    PostLabel(label);
  /**/
    write_str(indent);
    writeln(";--------------------<block>");
  /**/
    label_else[endifCtr][0] = '\0';
}
/*------- end Do_else -------*/


void Do_endif()     /* parse an ENDIF statement */
{   char label[LLEN];
    int len;

    write_str(indent);
    writeln(";--------------------<end-block>");
  /**/
    if(label_elseif[endifCtr][0] != 0)
    {   strcpy(label, label_elseif[endifCtr]);
        PostLabel(label);
    }
  /**/
    strcpy(label, label_endif[endifCtr]);
    write_str(indent);
    writeln(";--------------------<endif>");
    PostLabel(label);
  /**/
    len = strlen(indent);
    len = len - 2;
    indent[len] = '\0';
    indcnt--;
    label_endif[endifCtr][0] = '\0';
    endifCtr--;
}
/*------- end Do_endif -------*/


void boolexpress()
{   int type, op, ab_code=14, x=line_ndx;

    type = get_Exptype();   /* string, numeric, or eof */
    if((type >= 1) && (type <= 5))
    {   type = 1;
    }
 /**/
    switch(type)
    {   case 0:
            op = Sboolterm(type);        /* a string evaluation */
            break;
        case 1:
        case 11:
            op = Nboolterm(type);         /* numeric evaluation */
            break;
        case 12:
            op = is_eof();   /* an EOF evaluation */
            break;
        default:
            a_bort(ab_code,x);
            break;
    }
    op = IsAndOrOp(op);     /* --- process AND / OR --- */
  /**/
    if(op != 0)
    {   opcntr++;
        boolexpress();    /* do: AND/OR */
    }
}
/*------- end boolexpress --------*/


int Nboolterm(int type)
{   char varname[VAR_NAME];
    int op;

    switch(type)
    {   case 1:     /* variable value */
            strcpy(varname, get_varname());
            write_str(indent);
            write_str("mov  eax, ");
            writeln(varname);
            break;
        case 11:     /* expression within parens */
            write_str(indent);
            writeln("FINIT \t\t\t; initialize x87");
            a_Expression();
   /**/
            write_str(indent);
            write_str("FISTP iLVAR");
            writeln("\t\t; store in system left variable");
            write_str(indent);
            writeln("mov  eax, iLVAR");
            break;
    }
    op = Nrelation();
    return op;
}
/*------- end Nboolterm --------*/


int Nrelation()
{   char varname[VAR_NAME];
    int op, type, ab_code=10, x=line_ndx;

    op = get_op();    /* get eval op type */
    type = get_Exptype();   /* get right side type */
    if((type >= 1) && (type <= 5))
    {   type = 1;
    }
 /**/
    switch(type)
    {   case 1:     /* variable value */
            strcpy(varname, get_varname());
            write_str(indent);
            write_str("cmp  eax, ");
            writeln(varname);
            break;
        case 11:     /* expression within parens */
            write_str(indent);
            writeln("FINIT \t\t\t; initialize x87");
            a_Expression();
   /**/
            write_str(indent);
            write_str("FISTP ");
            write_str("iRVAR");
            writeln("\t\t; store in system right variable");
            write_str(indent);
            writeln("cmp  eax, iRVAR");
            break;
        default:
            a_bort(ab_code,x);
            break;
    }
    return op;
}
/*------- end Nrelation --------*/


int Sboolterm(int type)
{   char varname[VAR_NAME], temp[6];
    int pi, op, mark;

    pi = e_pos;
    strcpy(varname, get_varname());  /* string variable */
  /**/
    strcpy(temp, "VARX");
    s_pos = pi;
    mark = find_strng(temp);
    mark--;
  /**/
    if(mark == pi)    /* this is a temp var-name */
    {   write_str(indent);
        write_str("mov  esi, offset ");
        write_str(varname);
        writeln("\t\t; load temp variable address");
    }
    else
    {   write_str(indent);
        write_str("mov  esi, [");
        write_str(varname);
        write_str("]");
        writeln("\t\t\t; address of source string");
    }
  /**/
    op = Srelation();
    return op;
}
/*------- end Sboolterm --------*/


int Srelation()
{   char varname[VAR_NAME], temp[6];
    int pi, op, type, mark, ab_code=13, x=line_ndx;

    op = get_op();    /* get eval op type */
    type = get_Exptype();   /* get right side type */
  /**/
    switch(type)
    {   case 0:     /* string variable */
            pi = e_pos;
            strcpy(varname, get_varname());
   /**/
            strcpy(temp, "VARX");
            s_pos = pi;
            mark = find_strng(temp);
            mark--;
   /**/
            if(mark == pi)   /* this is a temp var-name */
            {   write_str(indent);
                write_str("mov  edi, offset ");
                write_str(varname);
                writeln("\t\t; load temp variable address");
            }
            else
            {   write_str(indent);
                write_str("mov  edi, [");
                write_str(varname);
                write_str("]");
                writeln("\t\t\t; address of source string");
            }
   /**/
            write_str(indent);
            write_str("invoke StrLen, addr ");
            write_str(varname);
            writeln("\t\t; get string length");
            write_str(indent);
            writeln(".if eax == 0");
            write_str(indent);
            writeln("  inc  eax");
            write_str(indent);
            writeln(".endif");
            write_str(indent);
            writeln("mov  ecx, eax\t\t\t\t; Load length of string");
   /**/
            write_str(indent);
            writeln("cld\t\t\t; clear direction flag: work upward");
            write_str(indent);
            writeln("repe cmpsb\t\t; Compare and repeat");
            break;
        default:
            a_bort(ab_code,x);
            break;
    }
    return op;
}
/*------- end Srelation --------*/


int get_op()
{   char ch;
    int pi, op, ab_code=11, x=line_ndx;

    pi = e_pos;
    ch = p_string[pi];
    if(strchr("\"$%!#@&", ch))
    {   pi++;    /* increment past current symbol */
    }
    pi = iswhite(pi);
    ch = p_string[pi];
    switch(ch)
    {   case '=':
            op = 1;    /* is_equal */
            break;
        case '<':
            pi++;
            ch = p_string[pi];
            if(ch == '>')
            {   op = 6;    /* not_equal */
            }
            else if(ch == '=')
            {   op = 4;    /* less-than or equal to */
            }
            else
            {   op = 2;    /* less-than */
            }
            break;
        case '>':
            pi++;
            ch = p_string[pi];
            if(ch == '=')
            {   op = 5;           /* greater-than or equal to */
            }
            else
            {   op = 3;           /* greater-than */
            }
            break;
        default:
            a_bort(ab_code,x);
            break;
    }
    if(strchr("=>", ch))
    {   pi++;
    }
    e_pos = pi;
    return op;
}
/*------- end get_op -------*/


int get_Exptype()  /* return: variable, string, or expression */
{   char ch, varname[VAR_NAME];
    int pi, type=0;

    pi = e_pos;
    pi = iswhiter(pi);
    ch = p_string[pi];
    if(isalpha(ch))              /* variable name */
    {   e_pos = pi;
        strcpy(varname, get_varname());
        if(strcmp("EOF", varname) == 0)
        {   type = 12;
        }
        else
        {   type = get_ObjectType(varname);  /* object type specifier */
        }
  /* printf("getxptyp::varname=%s type=%d\n", varname, type); */

    }
    else if(ch == '(')
    {   type = 11;                      /* expression in parens */
    }
    else if(ch == '<')
    {   type = 12;                      /* 'NOT' boolean expression */
    }
    e_pos = pi;
    return type;
}
/*------- end get_Exptype ---------*/


char *jump_if(int op, char ch)
{   static char jump[10];

    if(ch == '|')     /* ch == | */
    {   switch(op)
        {   case 1:    /* equal to */
                strcpy(jump, "je   ");
                break;
            case 2:    /* less than */
                strcpy(jump, "jl   ");
                break;
            case 3:    /* greater than */
                strcpy(jump, "jg   ");
                break;
            case 4:    /* less than or equal */
                strcpy(jump, "jle  ");
                break;
            case 5:    /* greater than or equal */
                strcpy(jump, "jge  ");
                break;
            case 6:    /* not */
                strcpy(jump, "jnz  ");
                break;
        }
    }
    else      /* ch == & (or no op) */
    {   switch(op)
        {   case 1:    /* equal to */
                strcpy(jump, "jne  ");
                break;
            case 2:    /* less than */
                strcpy(jump, "jnl  ");
                break;
            case 3:    /* greater than */
                strcpy(jump, "jng  ");
                break;
            case 4:    /* less than or equal */
                strcpy(jump, "jnle ");
                break;
            case 5:    /* greater than or equal */
                strcpy(jump, "jnge ");
                break;
            case 6:    /* not */
                strcpy(jump, "jz   ");
                break;
        }
    }
    return jump;
}
/*------- end jump_if -------*/


int look_Or()     /* look for the next OR op */
{   char ch;
    int pi, len, _bool=0;

    pi = e_pos;
    ch = p_string[pi];
    len = strlen(p_string);
    while((ch != '|') && (pi < len)) /* find next OR */
    {   pi++;
        ch = p_string[pi];
    }
    if(pi < len)
    {   if((ch == '|') && (pi > Or_pi)) /* found a new OR */
        {   strcpy(label_Or, get_NewLabel());
            Or_pi = pi;
            _bool = 1;
        }
        else if(ch == '|')   /* use old OR */
        {   _bool = 1;
        }
    }
    return _bool;
}
/*------- end look_Or -------*/


int IsAndOrOp(int op)
{   char ch, jump[10], this_label[LLEN];
    int pi, _bool, len;

    pi = e_pos;
    pi = iswhiter(pi);
    ch = p_string[pi];
    e_pos = pi;
    if(label_elseif[endifCtr][0] != '\0')
    {   strcpy(this_label, label_elseif[endifCtr]);
    }
    else if(label_else[endifCtr][0] != '\0')
    {   strcpy(this_label, label_else[endifCtr]);
    }
    else
    {   strcpy(this_label, label_endif[endifCtr]);
    }
 /**/
    switch(ch)
    {   case '&':      /* AND */
            _bool = look_Or();   /* is there an OR to jump to */
            if(_bool == 1)
            {   strcpy(this_label, label_Or);
            }
            strcpy(jump, jump_if(op, ch));
            op = 1;
            pi++;
            pi = iswhiter(pi);
            write_str(indent);
            write_str(jump);
            writeln(this_label);
            break;
        case '|':      /* OR */
            strcpy(this_label, label_block[endifCtr]);
            strcpy(jump, jump_if(op, ch));
            op = 2;
            pi++;
            pi = iswhiter(pi);
            write_str(indent);
            write_str(jump);
            writeln(this_label);
   /**/
            if(label_Or[0] != '\0')
            {   PostLabel(label_Or);
                label_Or[0] = '\0';
            }
            break;
        case '^':      /* NOT */
            strcpy(jump, jump_if(op, ch));
            op = 3;
            pi++;
            pi = iswhiter(pi);
            write_str(indent);
            write_str(jump);
            writeln(this_label);
            break;
        default:
            strcpy(jump, jump_if(op, ch));
            op = 0;
            write_str(indent);
            write_str(jump);
            writeln(this_label);
            break;
    }
    e_pos = pi;
    return op;
}
/*------- end IsAndOrOp --------*/


void check_lsif()    /* look ahead for an: elseif */
{   int line, tok=0, lsif=0, newif=0;

    line = line_ndx;
    while((tok != 16) && (tok != 14) && (line < nrows))
    {   line++;
        tok = byte_array[line];
        if(tok == 13)     /* found an: if */
        {   newif++;
        }
        else if(tok == 14)    /* found an: elseif */
        {   if(newif == 0)
            {   lsif++;
            }
            else
            {   tok = 0;    /* it's an embedded if */
            }
        }
        else if(tok == 16)    /* found an: endif */
        {   if(newif > 0)    /* is it an embedded if */
            {   newif--;
                tok = 0;
            }
        }
    }
    if(lsif > 0)
    {   strcpy(label_elseif[endifCtr], get_NewLabel());
    }
    else
    {   label_elseif[endifCtr][0] = '\0';
    }
}
/*------- end check_lsif -------*/


void check_else()    /* look ahead for an: elseif */
{   int line, tok=0, lse=0, newif=0;

    line = line_ndx;
    while((tok != 16) && (tok != 15) && (line < nrows))
    {   line++;
        tok = byte_array[line];
        if(tok == 13)     /* found an: if */
        {   newif++;
        }
        else if(tok == 15)    /* found an: else */
        {   if(newif == 0)
            {   lse++;
            }
            else
            {   tok = 0;    /* it's an embedded if */
            }
        }
        else if(tok == 16)    /* found an: endif */
        {   if(newif > 0)    /* is it an embedded if */
            {   newif--;
                tok = 0;
            }
        }
    }
    if(lse > 0)
    {   strcpy(label_else[endifCtr], get_NewLabel());
    }
    else
    {   label_else[endifCtr][0] = '\0';
    }
}
/*------- end check_else -------*/


void or_true(int mark_or)  /* does this statement contain an OR */
{   char block[LLEN];

    if(mark_or > 0)
    {   strcpy(block, label_block[endifCtr]);
        PostLabel(block);
    }
}
/*------- end or_true -------*/


int check_or()     /* look ahead for an: OR */
{   char temp[3];
    int mark_or;

    strcpy(temp, "| ");
    mark_or = find_strng(temp);
    mark_or--;
    if(mark_or > 0)
    {   strcpy(label_block[endifCtr], get_NewLabel());
        Or_pi = 0;   /* keep track of recurring OR position */
    }
    else
    {   label_block[endifCtr][0] = '\0';
    }
    return mark_or;
}
/*------- end check_or -------*/


int is_eof()
{   char fptr[4], varname[VAR_NAME];   /* num = EOF(f) */
    int pi, len, ival, op;
    double value;

    len = strlen(p_string);
    pi = e_pos;
    pi = get_digit(pi, len);
    e_pos = pi;
    value = get_avalue();
    ival = (int) value;
    ival--;
    sprintf(fptr, "%d", ival);
  /**/
    write_str(indent);
    write_str("mov  eax, ");
    writeln(fptr);
    write_str(indent);
    writeln("call getfilehandle");
    write_str(indent);
    writeln("invoke feof, eax");  /* integer value is in eax */
    write_str(indent);
    writeln("cmp  eax, 0");
  /**/
    getfilehandle = 1;
    pi = e_pos;
    pi++;
    e_pos = pi;
    op = 6;    /* IF EOF == true == [<> 0] */
    return op;
}
/*------- end is_eof ----------*/


/* bxbasm : Asmstrng.c : alpha version */
/* ----- includes ----- */
//#include "prototyp.h"



void parse_str(char *name)
{   char ch, varname[VAR_NAME];
    int pi, ndx;
    unsigned size;

    strcpy(varname, name);   /* get destination */
    pi = e_pos;
    pi = iswhite(pi);
    e_pos = pi;
  /**/
    Match('=');
    writeln("; --------------------------------------------------");
    writeln("  lea  eax, StringBffr");
    writeln("  mov  [eax], byte ptr 0\t\t; clear string-copy buffer");
  /**/
    str_express(varname);   /* now get assignment string */
  /**/
    write_str("  mov  edi, [");  /* make string assignment */
    write_str(varname);
    write_str("]");
    writeln("\t\t\t; load address-pointer");
    writeln("  call copystrng_bffr\t\t; alloc memory and copy");
    write_str("  mov  ");
    write_str(varname);
    writeln(", eax\t\t\t; store address-pointer");
}
/*---------- end parse_str ----------*/


void str_express(char *name)
{   char ch, varname[VAR_NAME], temp[3];
    int pi, len, mark, catflag=0, copyflag=0;

    strcpy(varname, name);
    len = strlen(p_string);
    pi = e_pos;
  /**/
    strcpy(temp, "+");
    s_pos = pi;
    mark = find_strng(temp);
    mark--;
    if(mark > 0)   /* does this concatenate a string ? */
    {   catflag = 1;
    }
    while(pi < len)
    {   ch = p_string[pi];
        if(isdigit(ch))
        {   if((catflag == 1) && (copyflag == 1))
            {   cat_function(len);  /* cat a string function */
            }
            else
            {   asn_function(len);  /* copy a string function */
                stringcopy = 1;  /* global flag */
                copyflag = 1;   /* local flag */
            }
        }
        else
        {   if((catflag == 1) && (copyflag == 1))
            {   cat_string(len);  /* concatenate a variable */
            }
            else
            {   copy_string(len);  /* copy a variable */
                stringcopy = 1;  /* global flag */
                copyflag = 1;   /* local flag */
            }
        }
        pi = e_pos;
        pi++;
        pi = iswhite(pi);
        e_pos = pi;
        if(pi < len)
        {   Match('+');   /* concatenate symbol */
            pi = e_pos;
        }
    }
}
/*---------- end str_express ----------*/


void cat_function(int len)
{   int type;

    type = (int) get_avalue();
    string_functions(len,type);
  /**/
    writeln("  call catstrng");
}
/*---------- end cat_function ----------*/


void asn_function(int len)
{   int type;

    type = (int) get_avalue();
    string_functions(len,type);
  /**/
    writeln("  call copystrng");
}
/*---------- end asn_function ----------*/


void string_functions(int len, int type)
{
    switch(type)
    {   case 1:
            chrstr(len);  /* a$ = CHR$(n) */
            break;
        case 2:
            leftstr(len);  /* a$ = LEFT$(x$,n) */
            break;
        case 3:
            rightstr(len);  /* a$ = RIGHT$(x$,n) */
            break;
        case 4:
            midstr(len);  /* a$ = MID$(x$,n,n) */
            break;
        case 5:
            spacestr(len);  /* a$ = SPACE$(n) */
            break;
        case 6:
            strsval(len);  /* a$ = STR$(n) */
            break;
        case 7:
            stringstr(len);  /* a$ = STRING$(n,c) */
            break;
        case 8:
            inkeystr();   /* a$ = INKEY$ */
            break;
        case 9:
            inputstr(len);  /* a$ = INPUT$(n) */
            break;
        case 10:    /* LSET a$ = MKD$(n) */
        case 11:    /* LSET a$ = MKI$(n) */
        case 12:    /* LSET a$ = MKS$(n) */
            break;
        case 13:
            datestr();   /* a$ = DATE$ */
            break;
        case 14:
            timestr();   /* a$ = TIME$ */
            break;
        default:
            /* error */
            break;
    }
}
/*---------- end string_functions ----------*/


void mkistr(int len)     /* LSET a$ = MKI$(n%) */
{   char ch, srcname[VAR_NAME];
    int pi, type;

/* this function is called by LSET !!! */

    pi = e_pos;                    /* pi enters pointing to: "(" */
    pi = get_alpha(pi, len);   /* advance to varname */
    e_pos = pi;
    strcpy(srcname, get_varname());  /* get value variable name */
    type = get_ObjectType(srcname);  /* object type specifier */
  /**/
    if(type == 5)
    {   write_str("  mov  esi, offset ");
        writeln(srcname);
        writeln("  call mkqstr");
  /**/
        asnmkqstr = 1;
    }
    else
    {   write_str("  mov  esi, offset ");
        writeln(srcname);
        writeln("  call mkistr");
  /**/
        asnmkistr = 1;
    }
}
/*------ end mkistr ------*/


void mkdstr(int len)     /* LSET a$ = MKD$(n) */
{   char ch, srcname[VAR_NAME];  /* LSET a$ = MKS$(n) */
    int pi;

/* this function is called by LSET !!! */

    pi = e_pos;                    /* pi enters pointing to: "(" */
    pi = get_alpha(pi, len);   /* advance to varname */
    e_pos = pi;
    strcpy(srcname, get_varname());  /* get value variable name */
  /**/
    write_str("  mov  esi, offset ");
    writeln(srcname);
    writeln("  call mkdstr");
  /**/
    asnmkdstr = 1;
}
/*------ end mkdstr ------*/


void timestr()      /* a$ = TIME$ */
{
    writeln("  call timestr");
  /**/
    asntimestr = 1;
    getsystime = 1;
}
/*---------- end timestr ----------*/


void datestr()      /* a$ = DATE$ */
{
    writeln("  call datestr");
  /**/
    asndatestr = 1;
    getsysdate = 1;
}
/*---------- end datestr ----------*/


void inputstr(int len)    /* a$ = INPUT$(num) */
{   char srcname[VAR_NAME];
    int pi;

    pi = e_pos;                      /* pi enters pointing to: "(" */
    pi = get_alpha(pi, len);   /* advance to varname */
    e_pos = pi;
    strcpy(srcname, get_varname());  /* get count variable name */
  /**/
    write_str("  mov  eax, ");
    write_str(srcname);
    writeln("\t\t\t; load the count");
  /**/
    writeln("  call inputstr");
  /**/
    asninputstr = 1;
}
/*---------- end inputstr ----------*/


void inkeystr()      /* a$ = INKEY$ */
{
    writeln("  call inkeystr");
  /**/
    asninkeystr = 1;
}
/*---------- end inkeystr ----------*/


void stringstr(int len)    /* STRING$(number, character) */
{   char srcname[VAR_NAME];
    int pi, type;

    pi = e_pos;                    /* pi enters pointing to: "(" */
    pi = get_alpha(pi, len);   /* advance to varname */
    e_pos = pi;
    strcpy(srcname, get_varname());  /* get count variable name */
  /**/
    write_str("  mov  eax, ");
    write_str(srcname);
    writeln("\t\t\t; load the count");
  /**/
    pi = e_pos;
    pi = get_alpha(pi, len);   /* advance to varname */
    e_pos = pi;
    strcpy(srcname, get_varname());  /* get character variable name */
    type = get_ObjectType(srcname);  /* object type specifier */
    pi = e_pos;
    if(type == 0)
    {   write_str("  mov  esi, offset ");
        write_str(srcname);
        writeln("\t\t\t; load temp variable address");
        writeln("  mov  ebx, [esi]");
  /**/
        pi = get_paren(pi, len);
        e_pos = pi;
    }
    else
    {   write_str("  mov  ebx, ");
        write_str(srcname);
        writeln("\t\t\t; load value");
    }
    writeln("  call stringstr");
  /**/
    asnstringstr = 1;
}
/*---------- end stringstr ----------*/


void strsval(int len)     /* STR$(value) */
{   char ch, srcname[VAR_NAME], tmp[2]={0,0};
    int pi, type;

    pi = e_pos;                    /* pi enters pointing to: "(" */
    pi = get_alpha(pi, len);   /* advance to varname */
    e_pos = pi;
    strcpy(srcname, get_varname());  /* get value variable name */
    type = get_ObjectType(srcname);  /* object type specifier */
    pi = e_pos;
    if(type != 1)
    {   pi = get_paren(pi, len);
        e_pos = pi;
    }
    if(type < 3)     /* integer values */
    {   write_str("  mov  eax, ");
        write_str(srcname);
        writeln("\t\t\t; load the value");
        writeln("  mov  integer, eax");
        writeln("  call strsIval");
        asnstrsIval = 1;
    }
    else      /* float values */
    {   write_str("  FLD  ");
        writeln(srcname);
        writeln("  FSTP x87buff");
        writeln("  call strsFval");
        asnstrsFval = 1;
    }
}
/*---------- end strsval ----------*/


void spacestr(int len)    /* SPACE$(number) */
{   char srcname[VAR_NAME];
    int pi;

    pi = e_pos;                    /* pi enters pointing to: "(" */
    pi = get_alpha(pi, len);   /* advance to varname */
    e_pos = pi;
    strcpy(srcname, get_varname());  /* get count variable name */
  /**/
    write_str("  mov  eax, ");
    write_str(srcname);
    writeln("\t\t\t; load the count");
    writeln("  call spacestr");
  /**/
    asnspacestr = 1;
}
/*---------- end spacestr ----------*/


void midstr(int len)    /* MID$(a$, start, number) */
{   char srcname[VAR_NAME], temp[6];
    int pi, mark;

    pi = e_pos;                    /* pi enters pointing to: "(" */
    pi = get_alpha(pi, len);   /* advance to varname */
    e_pos = pi;
    strcpy(srcname, get_varname());  /* get source string name */
  /**/
    strcpy(temp, "VARX");
    s_pos = pi;
    mark = find_strng(temp);
    mark--;
  /**/
    if(mark == pi)    /* this is a temp var-name */
    {   write_str("  mov  esi, offset ");
        write_str(srcname);
        writeln("\t\t\t; load temp variable address");
    }
    else
    {   write_str("  mov  esi, ");
        write_str("[");
        write_str(srcname);
        write_str("]");
        writeln("\t\t\t; address of source string");
    }
  /**/
    pi = e_pos;
    pi = get_alpha(pi, len);   /* advance to varname */
    e_pos = pi;
    strcpy(srcname, get_varname());  /* get the start position */
  /**/
    write_str("  mov  ebx, ");
    write_str(srcname);
    writeln("\t\t\t; load the start");
    writeln("  dec  ebx");
  /**/
    pi = e_pos;
    pi = get_alpha(pi, len);   /* advance to varname */
    e_pos = pi;
    strcpy(srcname, get_varname());  /* get the count */
  /**/
    write_str("  mov  eax, ");
    write_str(srcname);
    writeln("\t\t\t; load the count");
    writeln("  call mid_str");
  /**/
    asnmidstr = 1;
}
/*---------- end midstr ----------*/


void rightstr(int len)    /* RIGHT$(a$, number) */
{   char srcname[VAR_NAME], temp[6];
    int pi, mark;

    pi = e_pos;                    /* pi enters pointing to: "(" */
    pi = get_alpha(pi, len);   /* advance to varname */
    e_pos = pi;
    strcpy(srcname, get_varname());  /* get source string name */
  /**/
    strcpy(temp, "VARX");
    s_pos = pi;
    mark = find_strng(temp);
    mark--;
  /**/
    if(mark == pi)    /* this is a temp var-name */
    {   write_str("  mov  esi, offset ");
        write_str(srcname);
        writeln("\t\t\t; load temp variable address");
    }
    else
    {   write_str("  mov  esi, ");
        write_str("[");
        write_str(srcname);
        write_str("]");
        writeln("\t\t\t; address of source string");
    }
  /**/
    pi = e_pos;
    pi = get_alpha(pi, len);   /* advance to varname */
    e_pos = pi;
    strcpy(srcname, get_varname());  /* get the count */
  /**/
    write_str("  mov  eax, ");
    write_str(srcname);
    writeln("\t\t\t; load the count");
    writeln("  call rightstr");
  /**/
    asnrightstr = 1;
}
/*---------- end rightstr ----------*/


void leftstr(int len)    /* LEFT$(a$, number) */
{   char srcname[VAR_NAME], temp[6];
    int pi, mark;

    pi = e_pos;                    /* pi enters pointing to: "(" */
    pi = get_alpha(pi, len);   /* advance to varname */
    e_pos = pi;
    strcpy(srcname, get_varname());  /* get source string name */
  /**/
    strcpy(temp, "VARX");
    s_pos = pi;
    mark = find_strng(temp);
    mark--;
  /**/
    if(mark == pi)    /* this is a temp var-name */
    {   write_str("  mov  esi, offset ");
        write_str(srcname);
        writeln("\t\t\t; load temp variable address");
    }
    else
    {   write_str("  mov  esi, ");
        write_str("[");
        write_str(srcname);
        write_str("]");
        writeln("\t\t\t; address of source string");
    }
  /**/
    pi = e_pos;
    pi = get_alpha(pi, len);   /* advance to varname */
    e_pos = pi;
    strcpy(srcname, get_varname());  /* get the count */
  /**/
    write_str("  mov  eax, ");
    write_str(srcname);
    writeln("\t\t\t; load the count");
    writeln("  call leftstr");
  /**/
    asnleftstr = 1;
}
/*---------- end leftstr ----------*/


void chrstr(int len)    /* CHR$(ascii character) */
{   char srcname[VAR_NAME];
    int pi;

    pi = e_pos;                 /* pi enters pointing to: "(" */
    pi = get_alpha(pi, len);   /* advance to varname */
    e_pos = pi;
  /**/
    strcpy(srcname, get_varname());
  /**/
    write_str("  mov  eax, ");
    write_str(srcname);
    writeln("\t\t\t; load the ascii value");
    writeln("  call chrstr");
  /**/
    asnchrstr = 1;
}
/*---------- end chrstr ----------*/


void cat_string(int len)
{   char ch, srcname[VAR_NAME], temp[6];
    int pi, mark, type;

    pi = e_pos;
    pi = get_alpha(pi, len);
    e_pos = pi;
    strcpy(srcname, get_varname());
    type = get_ObjectType(srcname);  /* object type specifier */
  /**/
    if(type == 6)
    {   e_pos = pi;
        cat_strarry();   /* source is an array-string */
    }
    else
    {   strcpy(temp, "VARX");
        s_pos = pi;
        mark = find_strng(temp);
        mark--;
  /**/
        if(mark == pi)    /* this is a temp var-name */
        {   write_str("  mov  esi, offset ");
            write_str(srcname);
            writeln("\t\t\t; load temp variable address");
        }
        else     /* this is a real var-name */
        {   write_str("  mov  esi, [");
            write_str(srcname);
            write_str("]");
            writeln("\t\t\t; load real variable address");
        }
        writeln("  call catstrng");
    }
}
/*---------- end cat_string ----------*/


void copy_string(int len)
{   char ch, srcname[VAR_NAME], temp[6];
    int pi, mark, type;

    pi = e_pos;       /* get source varname */
    pi = get_alpha(pi, len);
    e_pos = pi;
    strcpy(srcname, get_varname());
    type = get_ObjectType(srcname);  /* object type specifier */
  /**/
    if(type == 6)
    {   e_pos = pi;
        asn_strarry();    /* source is an array-string */
    }
    else
    {   strcpy(temp, "VARX");
        s_pos = pi;
        mark = find_strng(temp);
        mark--;
  /**/
        if(mark == pi)    /* this is a temp var-name */
        {   write_str("  mov  esi, offset ");
            write_str(srcname);
            writeln("\t\t\t; load temp variable address");
        }
        else     /* this is a real var-name */
        {   write_str("  mov  esi, [");
            write_str(srcname);
            write_str("]");
            writeln("\t\t\t; load a real variable address");
        }
        writeln("  call copystrng");
    }
}
/*---------- end copy_string ----------*/


void asn_strarry()       /* assign an array string */
{   char ch, varname[VAR_NAME];
    int pi, len, xcnt;

    strcpy(varname, get_varname());  /* enter: a$ = array$(n,...) */
  /**/
    len = strlen(p_string);
    pi = e_pos;
    pi = get_paren(pi, len);
    xcnt = get_ObjectParm(varname);
    get_offset(varname, len, xcnt);
  /**/
    writeln("  mov  esi, [edi]");  /* load string address to ESI */
    writeln("  call copystrng");
}
/*---------- end asn_strarry ----------*/


void cat_strarry()        /* cat an array string */
{   char ch, varname[VAR_NAME];
    int pi, len, xcnt;

    strcpy(varname, get_varname());  /* enter: a$ = array$(n,...) */
  /**/
    len = strlen(p_string);
    pi = e_pos;
    pi = get_paren(pi, len);
    xcnt = get_ObjectParm(varname);
    get_offset(varname, len, xcnt);
  /**/
    writeln("  mov  esi, [edi]");  /* load string address to ESI */
    writeln("  call catstrng");
}
/*---------- end cat_strarry ----------*/





/* bxbasm : Fileio.c : alpha version */
/* ----- includes ----- */
//#include "prototyp.h"



void Do_lprint()
{   char ch, varname[VAR_NAME], format[VAR_NAME], temp[6];
    int pi, len, type, wflag=0, mark;

    len = strlen(p_string);
    pi = e_pos;
    pi = get_alpha(pi, len);    /* #VARX1, output$ */
    e_pos = pi;
    ch = p_string[pi];
    strcpy(format, get_varname());
    pi = e_pos;
    ch = p_string[pi];
  /**/
    writeln("  invoke fopen, addr Lprint$, addr Lprnmode$");
    writeln("  push eax");
  /**/
    pi = e_pos;
    ch = p_string[pi];
    s_holder[0] = '\0';
  /**/
    while((pi < len) && (ch != '\n'))   /* process up to line terminator */
    {   pi = get_alpha(pi, len);
   ch = p_string[pi];
        if(pi < len)
        {   e_pos = pi;
            strcpy(varname, get_varname());
            type = get_ObjectType(varname);
   /**/
            if(type == 0)       /* output a string$ */
            {   if(wflag == 1)
                {   strcat(s_holder, ",");
                }
                strcpy(temp, "VARX");
                s_pos = pi;
                mark = find_strng(temp);
                mark--;
                if(mark == pi)
                {   strcat(s_holder, "addr ");
                }
                strcat(s_holder, varname);
                wflag = 1;
            }
            else        /* output a value */
            {   if(wflag == 1)
                {   strcat(s_holder, ",");
                }
                strcat(s_holder, varname);
                wflag = 1;
            }
            pi = e_pos;
            ch = p_string[pi];
        }
    }
    write_str("  invoke fprintf, eax, addr ");
    write_str(format);
    write_str(", ");
    writeln(s_holder);
    writeln("  pop  eax");
    writeln("  invoke fclose, eax");
}
/*------- end Do_lprint ----------*/


void parse_chdrive()
{   char ch, varname[VAR_NAME], temp[6];
    int pi, drive, len, ndx;

    len = strlen(p_string);
    pi = e_pos;
    ch = p_string[pi];
  /**/
    if(ch == '\"')     /* CHDRIVE "A" */
    {   pi = get_alpha(pi, len);
        ch = p_string[pi];
        drive = ch;
        if(isupper(ch))
        {   drive -= 64;    /* is an uppercase */
        }
        else
        {   drive -= 96;    /* is a lowercase */
        }
        sprintf(temp, "%d", drive);
        write_str("  invoke _chdrive, ");
        writeln(temp);
    }
    else if(isdigit(ch))    /* CHDRIVE 1 */
    {   ndx = 0;
        while(isdigit(ch))
        {   temp[ndx] = ch;
            pi++;
            ch = p_string[pi];
            ndx++;
        }
        temp[ndx] = '\0';
        write_str("  invoke _chdrive, ");
        writeln(temp);
    }
    else       /* CHDRIVE drive */
    {   strcpy(varname, get_varname());
        write_str("  invoke _chdrive, ");
        writeln(varname);
    }
}
/*------- end parse_chdrive ----------*/


void parse_name()
{   char varname[VAR_NAME], temp[6];
    int pi, mark, len;

    len = strlen(p_string);
    pi = e_pos;
    pi = get_alpha(pi, len);
  /**/
    strcpy(temp, "VARX");
    s_pos = pi;
    mark = find_strng(temp);
    mark--;
  /**/
    strcpy(varname, get_varname());
    write_str("  invoke rename, ");
    if(mark == pi)
    {   write_str("addr ");
    }
    write_str(varname);
  /**/
    pi = e_pos;
    pi = get_alpha(pi, len);
  /**/
    s_pos = pi;
    mark = find_strng(temp);
    mark--;
  /**/
    e_pos = pi;
    strcpy(varname, get_varname());
    write_str(", ");
    if(mark == pi)
    {   write_str("addr ");
    }
    writeln(varname);
}
/*------- end parse_name ----------*/


void parse_kill()
{   char varname[VAR_NAME], temp[6];
    int pi, mark, len;

    len = strlen(p_string);
    pi = e_pos;
    pi = get_alpha(pi, len);
  /**/
    strcpy(temp, "VARX");
    s_pos = pi;
    mark = find_strng(temp);
    mark--;
  /**/
    strcpy(varname, get_varname());
    write_str("  invoke remove, ");
    if(mark == pi)
    {   write_str("addr ");
    }
    writeln(varname);
}
/*------- end parse_kill ----------*/


void parse_rmd()
{   char varname[VAR_NAME], temp[6];
    int pi, mark, len;

    len = strlen(p_string);
    pi = e_pos;
    pi = get_alpha(pi, len);
  /**/
    strcpy(temp, "VARX");
    s_pos = pi;
    mark = find_strng(temp);
    mark--;
  /**/
    strcpy(varname, get_varname());
    write_str("  invoke _rmdir, ");
    if(mark == pi)
    {   write_str("addr ");
    }
    writeln(varname);
}
/*------- end parse_rmd ----------*/



void parse_mkd()
{   char varname[VAR_NAME], temp[6];
    int pi, mark, len;

    len = strlen(p_string);
    pi = e_pos;
    pi = get_alpha(pi, len);
  /**/
    strcpy(temp, "VARX");
    s_pos = pi;
    mark = find_strng(temp);
    mark--;
  /**/
    strcpy(varname, get_varname());
    write_str("  invoke _mkdir, ");
    if(mark == pi)
    {   write_str("addr ");
    }
    writeln(varname);
}
/*------- end parse_mkd ----------*/


void parse_chd()
{   char varname[VAR_NAME], temp[6];
    int pi, mark, len;

    len = strlen(p_string);
    pi = e_pos;
    pi = get_alpha(pi, len);
  /**/
    strcpy(temp, "VARX");
    s_pos = pi;
    mark = find_strng(temp);
    mark--;
  /**/
    strcpy(varname, get_varname());
    write_str("  invoke _chdir, ");
    if(mark == pi)
    {   write_str("addr ");
    }
    writeln(varname);
}
/*------- end parse_chd ----------*/


void parse_shell()     /* SHELL "command" */
{   char ch, varname[VAR_NAME];    /* "FILES *.*" */
    int pi, len;

    len = strlen(p_string);
    pi = e_pos;
    pi = get_alpha(pi, len);
    e_pos = pi;
    strcpy(varname, get_varname());
  /**/
    write_str("  invoke system, addr ");
    writeln(varname);
}
/*------- end parse_shell ----------*/


void print_file(int len)
{   char ch, fhandle[4], varname[VAR_NAME], format[VAR_NAME], temp[6];
    int pi, port, type, wflag=0, mark;
    double file_no;

    pi = e_pos;
    pi = get_alpha(pi, len);    /* #VARX1$, #1, output$ */
    e_pos = pi;
    ch = p_string[pi];
    strcpy(format, get_varname());
  /**/
    pi = e_pos;
    ch = p_string[pi];
    pi = get_digit(pi, len);    /* WRITE#1, output$ */
    e_pos = pi;
    file_no = get_avalue();
    port = (int) file_no;
    port--;
    sprintf(fhandle, "%d", port);
  /**/
    write_str("  mov  eax, ");
    writeln(fhandle);
    writeln("  call getfilehandle");  /* EAX now has the FP */
    getfilehandle = 1;
  /**/
    pi = e_pos;
    ch = p_string[pi];
    s_holder[0] = '\0';
  /**/
    while((pi < len) && (ch != '\n'))   /* process up to line terminator */
    {   pi = get_alpha(pi, len);
   ch = p_string[pi];
        if(pi < len)
        {   e_pos = pi;
            strcpy(varname, get_varname());
            type = get_ObjectType(varname);
   /**/
            if(type == 0)       /* output a string$ */
            {   if(wflag == 1)
                {   strcat(s_holder, ",");
                }
                strcpy(temp, "VARX");
                s_pos = pi;
                mark = find_strng(temp);
                mark--;
                if(mark == pi)
                {   strcat(s_holder, "addr ");
                }
                strcat(s_holder, varname);
                wflag = 1;
            }
            else        /* output a value */
            {   if(wflag == 1)
                {   strcat(s_holder, ",");
                }
                strcat(s_holder, varname);
                wflag = 1;
            }
            pi = e_pos;
            ch = p_string[pi];
        }
    }
    write_str("  invoke fprintf, eax, addr ");
    write_str(format);
    write_str(", ");
    writeln(s_holder);

 /* printf("s_holder=%s\n", s_holder); */
}
/*------- end print_file ----------*/


void lineinput_io()
{   char ch, fhandle[4], varname[VAR_NAME];
    int pi, len, port;
    double file_no;

    len = strlen(p_string);
    pi = e_pos;
    ch = p_string[pi];
    pi = get_digit(pi, len);   /* LINE INPUT #1, input$ */
    e_pos = pi;
    file_no = get_avalue();
    port = (int) file_no;
    port--;
    sprintf(fhandle, "%d", port);
  /**/
    pi = e_pos;
    ch = p_string[pi];
  /**/
    pi = get_alpha(pi, len);
    e_pos = pi;
    strcpy(varname, get_varname());
  /**/
    writeln("; --------------------------------------------------");
    write_str("  mov  esi, offset ");
    writeln(varname);
    write_str("  mov  edi, [");
    write_str(varname);
    writeln("]");
    writeln("  call clearLngstrng_bffr");
    clearLngstrngbffr = 1;
  /**/
    write_str("  mov  eax, ");
    writeln(fhandle);
    writeln("  call getfilehandle");  /* EAX now has the FP */
    getfilehandle = 1;
  /**/
    write_str("  invoke fgets, ");
    write_str(varname);
    writeln(", BUFSIZE, eax");
}
/*------- end lineinput_io ----------*/


void Do_rset()
{   char ch, varname[VAR_NAME], length[4];
    int pi, ii, len, fld_len, ndx, cnt, _bool;
    int func, ab_code=19, x=line_ndx;
    double value;
    unsigned size;

    len = strlen(p_string);
    pi = e_pos;
    strcpy(varname, get_varname());  /* get destination name */
    pi = e_pos;
  /**/
    write_str("  mov  edi, [");
    write_str(varname);
    writeln("]");
  /**/
    ndx = -1;
    _bool = 1;
    while((ndx < (IOARRAY - 1)) && (_bool != 0))
    {   ndx++;
        cnt = fld_bffr[ndx].fld_count;
        if(cnt > 0)
        {   ii = -1;
            while((_bool != 0) && (ii < cnt))
            {   ii++;
                _bool = strcmp(fld_bffr[ndx].str_name[ii], varname);
            }
        }
    }
    if(_bool == 0)
    {   fld_len = fld_bffr[ndx].str_len[ii];
        sprintf(length, "%d", fld_len);
    }
    else
    {   a_bort(ab_code, x);
    }
    pi = get_alnum(pi, len);
    ch = p_string[pi];
    if((pi < len) && (isdigit(ch)))
    {   e_pos = pi;
        value = get_avalue();    /* get function number */
        func = (int) value;
        if(func == 11)
        {   mkistr(len);
        }
        else
        {   mkdstr(len);
        }
    }
    else if((pi < len) && (isalpha(ch)))
    {   pi = get_alpha(pi, len);   /* advance to varname */
        e_pos = pi;
        strcpy(varname, get_varname());  /* get source name */
        pi = e_pos;
  /**/
        write_str("  mov  esi, [");
        write_str(varname);
        writeln("]\t\t; source string");
        write_str("  mov  edx, ");
        writeln(length);
        writeln("  call  rsetstr");
  /**/
        asnrsetstr = 1;
    }
    else
    {   a_bort(ab_code, x);
    }
}
/*------- end Do_rset ----------*/


void Do_get()
{   char ch, fhandle[6], bffsiz[6], varname[VAR_NAME];
    int len, pi, ndx, buffsize;
    double file_no;

    len = strlen(p_string);         /* GET 1, record% */
    pi = e_pos;
    pi = get_digit(pi,len);
    e_pos = pi;
    file_no = get_avalue();
    ndx = (int) file_no;
    ndx--;
    sprintf(fhandle, "%d", ndx);
    pi = e_pos;
  /**/
    buffsize = fld_bffr[ndx].bfr_size;
    sprintf(bffsiz, "%d", buffsize);
  /**/
    writeln("; --------------------------------------------------");
  /**/
    pi = get_alpha(pi, len);
    ch = p_string[pi];
    if((pi < len) && (isalpha(ch)))
    {   e_pos = pi;
        strcpy(varname, get_varname());  /* get destination name */
  /**/
        write_str("  mov  eax, ");
        writeln(varname);
        writeln("  dec  eax");
        writeln("  mov  ebx, eax");
        write_str("  mov  eax, ");
        writeln(bffsiz);
        writeln("  mul  bx");
        writeln("  push eax\t\t\t; save this record number");
        write_str("  mov  eax, ");
        writeln(fhandle);
        writeln("  call getfilehandle");
        writeln("  pop  ebx");
        writeln("  invoke fseek, eax, ebx, SEEK_SET");
    }
 /**/
    writeln("; --------------------------------------------------");
    writeln("  mov  edi, offset iobuffers");
    if(ndx > 0)
    {   write_str("  add  edi, (");
        write_str(fhandle);
        writeln(" * 4)");
    }
    writeln("  mov  esi, [edi]");
    writeln("  push esi");
    write_str("  add  esi, ");
    writeln(bffsiz);
    writeln("  mov  eax, 0");
    writeln("  mov  [esi], al");
    write_str("  mov  eax, ");
    writeln(fhandle);
    writeln("  call getfilehandle");
    writeln("  pop esi");
    write_str("  invoke fread, esi, ");
    write_str(bffsiz);
    writeln(", 1, eax");
  /**/
    getfilehandle = 1;
}
/*------- end Do_get ----------*/


void Do_put()
{   char ch, fhandle[6], bffsiz[6], varname[VAR_NAME];
    int len, pi, ndx, buffsize;
    double file_no;

    len = strlen(p_string);         /* PUT 1, record% */
    pi = e_pos;
    pi = get_digit(pi,len);
    e_pos = pi;
    file_no = get_avalue();
    ndx = (int) file_no;
    ndx--;
    sprintf(fhandle, "%d", ndx);
    pi = e_pos;
  /**/
    buffsize = fld_bffr[ndx].bfr_size;
    sprintf(bffsiz, "%d", buffsize);
  /**/
    writeln("; --------------------------------------------------");
  /**/
    pi = get_alpha(pi, len);
    ch = p_string[pi];
    if((pi < len) && (isalpha(ch)))
    {   e_pos = pi;
        strcpy(varname, get_varname());  /* get destination name */
  /**/
        write_str("  mov  eax, ");
        writeln(varname);
        writeln("  dec  eax");
        writeln("  mov  ebx, eax");
        write_str("  mov  eax, ");
        writeln(bffsiz);
        writeln("  mul  bx");
        writeln("  push eax\t\t\t; save this record number");
        write_str("  mov  eax, ");
        writeln(fhandle);
        writeln("  call getfilehandle");
        writeln("  pop  ebx");
        writeln("  invoke fseek, eax, ebx, SEEK_SET");
    }
 /**/
    writeln("; --------------------------------------------------");
    writeln("  mov  edi, offset iobuffers");
    if(ndx > 0)
    {   write_str("  add  edi, (");
        write_str(fhandle);
        writeln(" * 4)");
    }
    writeln("  mov  esi, [edi]");
    writeln("  push esi");
    write_str("  add  esi, ");
    writeln(bffsiz);
    writeln("  mov  eax, 0");
    writeln("  mov  [esi], al");
    write_str("  mov  eax, ");
    writeln(fhandle);
    writeln("  call getfilehandle");
    writeln("  pop esi");
    write_str("  invoke fwrite, esi, ");
    write_str(bffsiz);
    writeln(", 1, eax");
  /**/
    getfilehandle = 1;
}
/*------- end Do_put ----------*/


void Do_lset()
{   char ch, varname[VAR_NAME], length[4];
    int pi, ii, len, fld_len, ndx, cnt, _bool;
    int func, ab_code=19, x=line_ndx;
    double value;
    unsigned size;

    len = strlen(p_string);
    pi = e_pos;
    strcpy(varname, get_varname());  /* get destination name */
    pi = e_pos;
  /**/
    write_str("  mov  edi, [");
    write_str(varname);
    writeln("]");
  /**/
    ndx = -1;
    _bool = 1;
    while((ndx < (IOARRAY - 1)) && (_bool != 0))
    {   ndx++;
        cnt = fld_bffr[ndx].fld_count;
        if(cnt > 0)
        {   ii = -1;
            while((_bool != 0) && (ii < cnt))
            {   ii++;
                _bool = strcmp(fld_bffr[ndx].str_name[ii], varname);
            }
        }
    }
    if(_bool == 0)
    {   fld_len = fld_bffr[ndx].str_len[ii];
        sprintf(length, "%d", fld_len);
    }
    else
    {   a_bort(ab_code, x);
    }
    pi = get_alnum(pi, len);
    ch = p_string[pi];
    if((pi < len) && (isdigit(ch)))
    {   e_pos = pi;
        value = get_avalue();    /* get function number */
        func = (int) value;
        if(func == 11)
        {   mkistr(len);
        }
        else
        {   mkdstr(len);
        }
    }
    else if((pi < len) && (isalpha(ch)))
    {   pi = get_alpha(pi, len);   /* advance to varname */
        e_pos = pi;
        strcpy(varname, get_varname());  /* get source name */
        pi = e_pos;
  /**/
        write_str("  mov  esi, [");
        write_str(varname);
        writeln("]\t\t; source string");
        write_str("  mov  edx, ");
        writeln(length);
        writeln("  call  lsetstr");
  /**/
        asnlsetstr = 1;
    }
    else
    {   a_bort(ab_code, x);
    }
}
/*------- end Do_lset ----------*/


void Do_field()
{   char ch, varname[VAR_NAME], fhandle[4], temp[6], str[3];
    int pi, handle, len, mark, slen;
    int ii, ndx, varcnt, cnt, fld_len;
    double value;
    unsigned size;

    len = strlen(p_string);      /* FIELD #1, 1 AS a$, 2 AS b$, 3 AS c$  */
    pi = e_pos;
    value = get_avalue();    /* get var count */
    pi = e_pos;
    varcnt = (int) value;
  /**/
    pi = get_digit(pi, len);
    e_pos = pi;
  /**/
    value = get_avalue();    /* get file number */
    pi = e_pos;
    handle = (int) value;
    handle--;
    ndx = handle;
    sprintf(fhandle, "%d", handle);
  /**/
    writeln("; --------------------------------------------------");
    writeln("  mov  edi, offset iobuffers\t\t; FIELD #, data...");
  /**/
    if(handle > 0)    /* adjust pointer to this file */
    {   write_str("  add  edi, (");
        write_str(fhandle);
        writeln(" * 4)");
    }
    writeln("  mov  eax, [edi]");
  /**/    /* EDI now points to the buffer */
    cnt = fld_bffr[ndx].fld_count;
    if(cnt > 0)
    { free(fld_bffr[ndx].str_len);
 for(ii = 0; ii < cnt; ii++)
 {   free(fld_bffr[ndx].str_name[ii]);
 }
 free(fld_bffr[ndx].str_name);
 fld_bffr[ndx].fld_count = 0;
    }
    cnt = 0;
    size = varcnt;             /* store the "AS" count in the structure */
    fld_bffr[ndx].fld_count = varcnt;
    fld_bffr[ndx].str_len = (int*)malloc(size * sizeof(int));
    fld_bffr[ndx].str_name = (char**)malloc(size * sizeof(char *));
    for(ii = 0; ii < size; ii++)
    {   fld_bffr[ndx].str_name[ii] = (char*)malloc(VAR_NAME * sizeof(char));
   fld_bffr[ndx].str_name[ii][0] = '\0';
    }
  /**/
     while(pi < len)  /* move to the string length position */
     {  pi = get_digit(pi, len);
        e_pos = pi;
        value = get_avalue();    /* get string length */
        pi = e_pos;
        slen = (int) value;
   fld_bffr[ndx].str_len[cnt] = slen;
        sprintf(str, "%d", slen);
  /**/
        strcpy(temp, "AS ");
        s_pos = pi;
        mark = find_strng(temp);
        mark--;
        if((mark > 0) && (mark < len))
        {   pi = mark;
            pi += 2;
            pi = get_alpha(pi, len);
            e_pos = pi;
            strcpy(varname, get_varname());  /* get varname */
            pi = e_pos;
            strcpy(fld_bffr[ndx].str_name[cnt], varname); /* save it */
   /**/
            write_str("  mov  ");
            write_str(varname);
            writeln(", eax\t\t\t; create string pointer");
            write_str("  add  eax, ");
            writeln(str);
   /**/
            cnt++;
        }
        else
        {   pi = len;
        }
    }
    writeln("; --------------------------------------------------");
}
/*------- end Do_field ----------*/


void input_io()
{   char ch, fhandle[4], varname[VAR_NAME], format[VAR_NAME];
    int pi, len, port, type, wflag=0;
    double file_no;

    len = strlen(p_string);
    pi = e_pos;
    pi = get_digit(pi, len);    /* INPUT #1, input$ */
    e_pos = pi;      /* READ #1, input$ */
    file_no = get_avalue();
    port = (int) file_no;
    port--;
    sprintf(fhandle, "%d", port);
  /**/
    writeln("; --------------------------------------------------");
    writeln("  mov  edi, offset iobuffers");
    if(port > 0)
    {   write_str("  add  edi, (");
        write_str(fhandle);
        writeln(" * 4)");
    }
    writeln("  mov  esi, [edi]");
    writeln("  mov  integer, esi");  /* hang on to iobuffer addr */
    write_str("  mov  eax, ");
    writeln(fhandle);
    writeln("  call getfilehandle");  /* EAX now has the FP */
    writeln("  mov  esi, integer");
    writeln("  invoke fgets, esi, BUFSIZE, eax");
    writeln("  mov  esi, integer");      /* ESI = iobuffer address */
  /**/
    pi = e_pos;
    ch = p_string[pi];
  /**/
    while((pi < len) && (ch != '\n'))   /* process up to line terminator */
    {   pi = get_alpha(pi, len);
        ch = p_string[pi];
        if(pi < len)
        {   e_pos = pi;
            strcpy(varname, get_varname());
            type = get_ObjectType(varname);
            pi = e_pos;
            if(type == 0)       /* input a string$ */
            {   write_str("  mov  edi, ["); /* destination address */
                write_str(varname);
                writeln("]");
                writeln("  call movstrng_bffr");
                write_str("  mov  ");
                write_str(varname);
                writeln(", eax");   /* save string address */
    /**/
                clearstrngbffr = 1;
                movstrngbffr = 1;
            }
            else        /* output a value */
            {   if(type < 3)
                {   write_str("  mov  edi, offset ");
                    writeln(varname);
                    writeln("  call readintstr");
                    readintstr = 1;
                }
                else if(type < 5)
                {   write_str("  mov  edi, offset ");
                    writeln(varname);
                    writeln("  call readfltstr");
                    readfltstr = 1;
                }
                else /* if(type == 5) */
                {   write_str("  mov  edi, offset ");
                    writeln(varname);
                    writeln("  call readQintstr");
                    readQintstr = 1;
                }
            }
            pi = e_pos;
            ch = p_string[pi];
        }
    }
    getfilehandle = 1;
}
/*------- end input_io ----------*/


void write_io()
{   char ch, fhandle[4], varname[VAR_NAME], format[VAR_NAME];
    int pi, len, port, type, wflag=0;
    double file_no;

    len = strlen(p_string);
    strcpy(format, get_varname());
  /**/
    pi = e_pos;
    ch = p_string[pi];
    pi = get_digit(pi, len);    /* WRITE#1, output$ */
    e_pos = pi;
    file_no = get_avalue();
    port = (int) file_no;
    port--;
    sprintf(fhandle, "%d", port);
  /**/
    write_str("  mov  eax, ");
    writeln(fhandle);
    writeln("  call getfilehandle");  /* EAX now has the FP */
    getfilehandle = 1;
  /**/
    pi = e_pos;
    ch = p_string[pi];
    s_holder[0] = '\0';
  /**/
    while((pi < len) && (ch != '\n'))   /* process up to line terminator */
    {   pi = get_alpha(pi, len);
   ch = p_string[pi];
        if(pi < len)
        {   e_pos = pi;
            strcpy(varname, get_varname());
            type = get_ObjectType(varname);
   /**/
            if(type == 0)       /* output a string$ */
            {   if(wflag == 1)
                {   strcat(s_holder, ",");
                }
                strcat(s_holder, varname);
                wflag = 1;
            }
            else        /* output a value */
            {   if(wflag == 1)
                {   strcat(s_holder, ",");
                }
                strcat(s_holder, varname);
                wflag = 1;
            }
            pi = e_pos;
            ch = p_string[pi];
        }
    }
    write_str("  invoke fprintf, eax, addr ");
    write_str(format);
    write_str(", ");
    writeln(s_holder);

/* printf("s_holder=%s\n", s_holder); */
}
/*------- end write_io ----------*/


void parse_open()
{   char ch, fhandle[4], mode[VAR_NAME], filename[PATH], temp[6];
    int pi, len, mark, handle, buffer, iomode;
    double value;

    len = strlen(p_string);
    pi = e_pos;
    value = get_avalue();    /* get I/O Mode */
    iomode = (int) value;
  /**/
    pi = e_pos;
    ch = p_string[pi];
    pi = get_upper(pi, len);
    e_pos = pi;
    strcpy(mode, get_varname());   /* file mode variable */
    pi = e_pos;
 /**/
    pi = get_digit(pi, len);
    e_pos = pi;
    value = get_avalue();
    handle = (int) value;
    handle--;     /* decrement handle number */
    pi = e_pos;
 /**/
    pi = get_alpha(pi, len);        /* path\file name */
    strcpy(temp, "VARX");
    s_pos = pi;
    mark = find_strng(temp);
    mark--;
    if((mark >= 0) && (mark == pi))
    {   mark = 1;
    }
    else
    {   mark = 0;
    }
    e_pos = pi;
    strcpy(filename, get_varname());
    pi = e_pos;
    pi = get_digit(pi, len);
    ch = p_string[pi];
    if((pi < len) && (isdigit(ch)))
    {   e_pos = pi;
        value = get_avalue();
        buffer = (int) value;
    }
    else
    {   buffer = 256;       /* record length (random) */
    }
    fld_bffr[handle].bfr_size = buffer;
  /**/
    writeln("; --------------------------------------------------");
    if(mark == 1)     /* OPEN a quoted string */
    {   write_str("  invoke fopen, addr ");
        write_str(filename);
        write_str(", addr ");
        write_str(mode);
        writeln("\t; OPEN file");
        if(iomode == 1)
        {   writeln("  .if eax == NULL");
            write_str("    invoke fopen, addr ");
            write_str(filename);
            writeln(", addr _Altern_$");
            writeln("  .endif");
        }
    }
    else      /* OPEN a filename string */
    {   write_str("  mov  eax, [");
        write_str(filename);
        writeln("]");
        write_str("  invoke fopen, eax, addr ");
        write_str(mode);
        writeln("\t; OPEN file");
        if(iomode == 1)
        {   writeln("  .if eax == NULL");
            writeln("    invoke fopen, eax, addr _Altern_$");
            writeln("  .endif");
        }
    }
    writeln("  mov  edi, offset iohandles");
    if(handle > 0)
    {   sprintf(fhandle, "%d", handle);
        write_str("  add  edi, (");
        write_str(fhandle);
        writeln(" * 4)");
    }
    writeln("  mov  [edi], eax");
    writeln("  mov  edi, offset iobuffers");
    if(handle > 0)
    {   write_str("  add  edi, (");
        write_str(fhandle);
        writeln(" * 4)");
    }
    sprintf(temp, "%d", buffer);
    write_str("  mov  eax, ");
    writeln(temp);
    writeln("  call setupiobuffer");
  /**/
    setupiobuffer = 1;
}
/*------ end parse_open -------*/


void Do_fclose()
{   char ch, fhandle[4];
    int pi, len, handle;
    double value;

    len = strlen(p_string);
    pi = 0;
    pi = iswhite(pi);
    ch = p_string[pi];
    writeln("; --------------------------------------------------");
  /**/
    if(pi < len)
    {   while((pi < len) && (ch != '\0'))
        {   pi = get_digit(pi, len);
            e_pos = pi;
            value = get_avalue();
            handle = (int) value;
            handle--;   /* decrement handle number */
            sprintf(fhandle, "%d", handle);
   /**/
            write_str("  mov  eax, ");
            writeln(fhandle);
            writeln("  call closeafile");
            closeafile = 1;
            pi = e_pos;
            ch = p_string[pi];
        }
    }
    else
    {   writeln("  call closeallfiles");
        filecloseall = 1;
    }
}
/*------ end do_fclose -------*/



/*--- do not delete!!! called by: Main ---*/
void init_fldbffrs()
{   int ii;
    unsigned size=1;

    for(ii=0; ii < IOARRAY; ii++)           /* initialize Field buffers */
    { fld_bffr[ii].f_bffr = (char*)malloc(size * sizeof(char));
 fld_bffr[ii].f_bffr[0] = '\0';
 fld_bffr[ii].bfr_size = 1;
 fld_bffr[ii].record = 1;
 fld_bffr[ii].fld_count = 0;
 fld_bffr[ii].flag = 0;
    }
}
/*-------- end init_fldbffrs --------*/
/*--- do not delete!!! called by: Main ---*/

/* bxbasm : AsmDInpt.c : alpha version */
/* ----- function prototypes ----- */
//#include "prototyp.h"



void Scan_Obj(char *Name)
{   char ch, varname[VAR_NAME];
    int pi, len, xcnt, type, ab_code=20, x=line_ndx;

/* printf("->scanobj::%s", p_string); */
    strcpy(varname, Name);
    pi = e_pos;
    ch = p_string[pi];
    len = strlen(p_string);
    xcnt = get_paramsCount(pi, len); /* get params count */
    pi++;
    pi = get_paren(pi, len);
    pi++;
    pi = iswhiter(pi);
    ch = p_string[pi];
    switch(ch)
    {   case '$':
            type = 6;   /* string array */
            break;
        case '%':
            type = 7;   /* integer array */
            break;
        case '!':
            type = 8;   /* float array */
            break;
        case '#':
            type = 9;   /* double array */
            break;
        case '@':
        case '&':
            type = 10;   /* long integer */
            break;
        default:
            type = 7;   /* integer array */
            break;
    }
    if(check_VarName(varname) != 0)
    {   a_bort(ab_code,x);
    }
    if(check_arrayName(varname) == 0)
    {   x_write_str("\t");
        x_write_str(varname);
        x_writeln("\t\tDD\t?");
        x_writeln("\t\t\tDW\t61\tdup(?)");
    }
    Sav_ObjName(varname, type, xcnt); /* save object name */
    p_string[pi] = ' ';
  /**/
    /* --- save p_string to array --- */
    strcpy(array1[line_ndx], p_string);   /* store to array */
  /**/
    pi = iswhiter(pi);
    e_pos = pi;
/* printf("%s", p_string); */
}
/*---------- end Scan_Obj ----------*/


void Scan_Var(char *Name)
{   char ch, varname[VAR_NAME];
    int pi, pend, pstart;

/* printf("->scanvar::%s", p_string); */
    strcpy(varname, Name);
    pstart = s_pos;
    pi = e_pos;
    pend = pi;
    pi = iswhiter(pi);
    ch = p_string[pi];
    if(ch == '$')     /* string variable -or- array */
    {   p_string[pi] = ' ';
        pi = iswhiter(pi);
        ch = p_string[pi];
        if(ch == '*')     /* a string array */
        {   e_pos = pend;
            Fix_StrArray2(varname);
            p_string[pi] = ' ';
            pi = iswhiter(pi);
            pi = relocate(pi, pend);
        }
        else
        {   p_string[pend] = ' ';
            e_pos = pend;
            s_pos = pstart;
            Sav_String(varname);
            StorVar(varname);
        }
    }
    else if(ch == '%')    /* integer variable -or- array */
    {   p_string[pi] = ' ';
        pi = iswhiter(pi);
        ch = p_string[pi];
        if(ch == '*')     /* a integer array */
        {   e_pos = pend;
            Fix_VarArray2(varname, 7);
            p_string[pi] = ' ';
            pi = iswhiter(pi);
            pi = relocate(pi, pend);
        }
        else
        {   p_string[pend] = ' ';
            e_pos = pend;
            s_pos = pstart;
            Sav_Destin(2, varname);
        }
    }
    else if(ch == '!')    /* single variable -or- array */
    {   p_string[pi] = ' ';
        pi = iswhiter(pi);
        ch = p_string[pi];
        if(ch == '*')     /* an array */
        {   e_pos = pend;
            Fix_VarArray2(varname, 8);
            p_string[pi] = ' ';
            pi = iswhiter(pi);
            pi = relocate(pi, pend);
        }
        else
        {   p_string[pend] = ' ';
            e_pos = pend;
            s_pos = pstart;
            Sav_Destin(3, varname);
        }
    }
    else if(ch == '#')    /* double variable -or- array */
    {   p_string[pi] = ' ';
        pi = iswhiter(pi);
        ch = p_string[pi];
        if(ch == '*')     /* an array */
        {   e_pos = pend;
            Fix_VarArray2(varname, 9);
            p_string[pi] = ' ';
            pi = iswhiter(pi);
            pi = relocate(pi, pend);
        }
        else
        {   p_string[pend] = ' ';
            e_pos = pend;
            s_pos = pstart;
            Sav_Destin(4, varname);
        }
    }
    else if((ch == '&') || (ch == '@')) /* long variable -or- array */
    {   p_string[pi] = ' ';
        pi = iswhiter(pi);
        ch = p_string[pi];
        if(ch == '*')     /* an array */
        {   e_pos = pend;
            Fix_VarArray2(varname, 10);
            p_string[pi] = ' ';
            pi = iswhiter(pi);
            pi = relocate(pi, pend);
        }
        else
        {   p_string[pend] = ' ';
            e_pos = pend;
            s_pos = pstart;
            Sav_Destin(5, varname);
        }
    }
/* printf("<-scanvar::\n%s", p_string); */
}
/*---------- end Scan_Var ----------*/


void ScanDim()
{   char ch, varname[VAR_NAME];
    int pi, start, len, xcnt, type, ab_code=20, x=line_ndx;

/* printf("DIM::%s", p_string); */
    len = strlen(p_string);
    pi = e_pos;
    ch = p_string[pi];
    while((pi < len) && (ch != '\n'))
    {   start = e_pos;
        strcpy(varname, get_varname());
  /**/
        pi = e_pos;
        type = get_Dvtype(pi);
  /* printf("type=%d\n", type); */

        e_pos = pi;
        if(type == 0)     /* character string */
        {   p_string[pi] = ' ';
            s_pos = start;
            Sav_String(varname);
            StorVar(varname);
        }
        else if(type == 1)    /* name AS datatype */
        {   s_pos = start;
            Scan_Var(varname);
        }
        else if((type >= 2) && (type <= 5)) /* numeric variable */
        {   s_pos = start;
            Sav_Destin(type, varname);
        }
        else if(type == 6)   /* character string array */
        {   Fix_StrArray3(varname, len);
        }
        else if((type >= 7) && (type <= 10))  /* numeric array */
        {   Fix_VarArray3(varname, type, len);
        }
        else if(type == 11)    /* name AS datatype */
        {   s_pos = start;
            Scan_Obj(varname);
        }
        else
        {   ab_code = 25;   /* not a recognized object */
            a_bort(ab_code, x);
        }
        len = strlen(p_string);
        pi = e_pos;
        ch = p_string[pi];
        pi = get_rightExp(pi);
        ch = p_string[pi];
        e_pos = pi;

    }
/* printf("dim::%s", p_string); */
}
/*---------- end ScanDim ----------*/


void Scan_Array(char *name, int type)
{   char ch, varname[VAR_NAME];
    int pi, len;

    strcpy(varname, name);
    pi = e_pos;
    ch = p_string[pi];
    if(strchr("%!#@&", ch))
    {   p_string[pi] = ' ';
        e_pos++;
    }
    StorNVar(varname);   /* save destination array name */
  /**/
    len = strlen(p_string);
    pi = e_pos;
    pi = get_paren(pi, len);
    e_pos = pi;
    ScanArrayParam();   /* assign variables: abc%(1,3,n) */
}
/*---------- end Scan_Array ----------*/


void ScanNumArray(char *name, int type)
{   char ch, varname[VAR_NAME];
    int pi, len, ival, funcflag=0, ab_code=21, x=line_ndx;

/* printf("SNA::%s", p_string); */
    strcpy(varname, name);
    pi = e_pos;
    s_pos = 0;
    Scan_Array(varname, type);
  /**/
    len = strlen(p_string);
    pi = e_pos;
    pi = get_rightExp(pi);   /* jump pi over this operator */
    ch = p_string[pi];
    while((ch != '\n') && (pi < len))
    {   ch = p_string[pi];
        while((isalnum(ch) == 0) && (pi < len) && (strchr(".\"",ch) == 0))
        {   pi++;
            ch = p_string[pi];
            if(ch == '?')   /* math function: ?1(num) */
            {   e_pos = pi + 1;
                ival = (int) get_avalue();
                if((ival == 10) || (ival == 11) || (ival == 29))
                {   pi = len;    /* LOC, LOF, EOF */
                }
                else     /* any other function */
                {   pi = get_paren(pi, len); /* ?num(string$) */
                    ch = p_string[pi];  /* ----^      */
                    funcflag = 1;
                }
            }
        }
        if(pi < len)
        {   e_pos = pi;
            if(funcflag == 1)   /* this is a math function */
            {   ScanMathFunc(len);
                funcflag = 0;
            }
            else if((isdigit(ch)) || (ch == '.'))
            {   GetNewTmp();   /* get new temp varname */
            }
            else if(isalpha(ch))  /* an array or variable name */
            {   pi = e_pos;
                strcpy(varname, get_varname());  /* get varname */
                type = get_ObjectType(varname);
    /**/
                if((type >= 7) && (type <= 10))  /* an array name */
                {   Fix_VarArray(varname);
                    pi = e_pos;
                    pi = get_paren(pi, len);
                    ScanArrayParam();
                }
                else
                {   e_pos = pi;
                    AddNewVar();   /* a variable name */
                }
            }
            else
            {   a_bort(ab_code, x);
            }
            pi = e_pos;
            len = strlen(p_string);
        }
    }
/* printf("sna::%s", p_string); */
}
/*---------- end ScanNumArray ----------*/


void ScanArrayParam()
{   char ch;
    int pi;

    pi = e_pos;
    ch = p_string[pi];
    while(ch != ')')
    {   e_pos = pi;
        if(isalpha(ch))
        {   AddNewVar();
            pi = e_pos;
        }
        else
        {   pi++;
        }
        ch = p_string[pi];
    }
    e_pos = pi;
}
/*---------- end ScanArrayParam ----------*/

/* ----- begin program ------------- */

int main(int argc, char *argv[])
{   int x=0, ab_code=1;
    char CR_1[36] = {"Copyright: Blunt_Axe_Basic, BxbAsm,"};
    char CR_2[28] = {" Bxbasic (c) sarbayo, 2004"};
    char Ver[25] = {"Alpha Release: 1.060"};

    printf("%s%s\n%s\n%s\n",CR_1,CR_2,Ver,"Bxbasm Compiler");
    if(argc != 2)
    {    a_bort(ab_code, x);
    }
    strcpy(t_holder, argv[1]);
    init_fldbffrs();       /* initialize file buffers */
    line_cnt(argv);
    Header();
    pgm_parser();
    Epilog();
    /* --- end of program --- */
    clr_arrays();
    return 0;
}
/*---------- end main ----------*/





void pgm_parser()
{
    line_ndx = 0;
    while(line_ndx < nrows)
    {   s_pos = 0;
        e_pos = 0;
        get_token();
        parser();
        line_ndx++;
    }
}
/*---------- end pgm_parser ----------*/

void get_token()
{
    strcpy(p_string, array1[line_ndx]);
    token = byte_array[line_ndx];
}
/*---------- end get_token ----------*/

void parser()
{   int ab_code=4, x=line_ndx;

    if(token != -1)
    {   num_label(); /* write a numeric label */
    }
    switch(token)
    {   case 1:  /* LET */
            Do_let();
            break;
        case 2:  /* CLEAR  (variables) */
            clr_vars();
            break;
        case 3:  /* LOCATE */
            Do_locate();
            break;
        case 4:  /* PRINT */
            Do_print();
            break;
        case 5:  /* GOTO */
            Do_goto();
            break;
        case 6:  /* BEEP */
            Do_beep();
            break;
        case 7:  /* CLS */
            Do_cls();
            break;
        case 8:  /* END */
            Do_end();
            break;
        case 9:  /* GOSUB */
            Do_gosub();
            break;
        case 10:  /* RETURN */
            Do_return();
            break;
        case 11:  /* FOR */
            Do_for();
            break;
        case 12:  /* NEXT */
            Do_next();
            break;
        case 13:  /* IF */
            Do_if();
            break;
        case 14:  /* ELSEIF */
            Do_elseif();
            break;
        case 15:  /* ELSE */
            Do_else();
            break;
        case 16:  /* ENDIF */
            Do_endif();
            break;
        case 17:  /* INPUT */
            get_input();
            break;
        case 18:  /* LINE INPUT */
            get_lninput();
            break;
        case 19:  /* OPEN */
            parse_open();
            break;
        case 20:  /* CLOSE */
            Do_fclose();
            break;
        case 21:  /* WRITE */
            write_io();
            break;
        case 22:  /* FIELD */
            Do_field();
            break;
        case 23:  /* LSET */
            Do_lset();
            break;
        case 24:  /* RSET */
            Do_rset();
            break;
        case 25:  /* PUT */
            Do_put();
            break;
        case 26:  /* GET */
            Do_get();
            break;
        case 27:  /* CHDIR */
            parse_chd();
            break;
        case 28:  /* MKDIR */
            parse_mkd();
            break;
        case 29:  /* RMDIR */
            parse_rmd();
            break;
        case 30:  /* KILL */
            parse_kill();
            break;
        case 31:  /* NAME-RENAME */
            parse_name();
            break;
        case 32:  /* FILES */
            parse_shell();
            break;
        case 33:  /* SHELL */
            parse_shell();
            break;
        case 34:     /* RANDOM */
            seed_rand();
            break;
        case 35:     /* READ */
            input_io();
            break;
        case 36:     /* CHDRIVE */
            parse_chdrive();
            break;
        case 37:     /* WHILE */
            Do_while();
            break;
        case 38:     /* WEND */
            Do_wend();
            break;
        case 39:     /* LOOP */
            Do_loop();
            break;
        case 40:     /* ENDLOOP */
            Do_endloop();
            break;
        case 41:     /* BREAK */
            Do_break();
            break;
        case 42:     /* DO-WHILE */
            Do_do();
            break;
        case 43:     /* LPRINT */
            Do_lprint();
            break;
        case 44:     /* COLOR */
            Do_color();
            break;
        case 45:     /* ASM */
            Do_asm();
            break;
        case 46:     /* DIM */
            Do_dim();
            break;
        case 47:     /* ERASE-FREE */
            Do_erase();
            break;


        case 99:  /* dump */
            dump();
            break;
        case -1:  /* block label */
            Do_label();
            break;
        default:
            a_bort(ab_code, x);
            break;
    }
}
/*---------- end parser ----------*/


void dump()      /* diagnostic tool */
{  int ii;
       /* dump program array */
    for(ii = 0; ii < nrows; ii++)
    {
        printf("%d:%d %s:%s", ii, byte_array[ii], label_nam[ii], array1[ii]);
    }
       /* dump objects array */
/*    for(ii = 0; ii < ObjNdxCnt; ii++)
    {
        printf("%d %s: %d\n", ii, ObjIndx[ii], ObjType[ii]);
    }
*/
    exit(0);
}
/* ----------- end dump ---------- */


void num_label()    /* post a numeric line label */
{   char ch, label[LLEN];

    ch = label_nam[line_ndx][0];
    if(isdigit(ch))
    {   strcpy(label, "L");
        strcat(label, label_nam[line_ndx]);
        PostLabel(label);   /* Post Label To Output */
    }
}
/* ------- end num_label ------- */


// *************************************************
//                 Runtime Functions
// *************************************************


